select
        DECODE(:lang, 'cs', pv.CZ_NAZEV, 'sk', pv.CZ_NAZEV, NVL(pv.AN_NAZEV, pv.CZ_NAZEV)) AS nazev,
        ra.PRAC_ZKR as fk_prac_zkr,
        ra.ZKR_PREDM as fk_zkr_predm,
        ra.ROK_VARIANTY as fk_rok_varianty,
        ra.CISLO_MIST as fk_cislo_mist,
        ra.ZKR_BUDOVY as fk_zkr_budovy,
        ra.PLAN,
        ra.OBSAZENI,
        decode(ra.plan,null,null,0,null,round(((ra.OBSAZENI/ra.plan)*100),2)) as obsazeni_procentuelne,
        ra.TYPAKCE as zkr_typakce,
        ra.SEMESTR,
        ra.PLATNOST,
        DECODE(:lang, 'cs', (select fn_meaning2(ra.PLATNOST,'PLATNOST_RA') from dual), 'sk', (select fn_meaning(ra.PLATNOST,'PLATNOST_RA')  from dual),
            NVL((select fn_meaning_en(ra.PLATNOST,'PLATNOST_RA')  from dual), (select fn_meaning(ra.PLATNOST,'PLATNOST_RA') from dual))) as platnost_slovne,
        ra.HOD_VYUC_OD,
        ra.HOD_VYUC_DO,
        to_char(ra.skut_hod_od,'HH24:MI') as HOD_SKUT_OD,
        to_char(ra.skut_hod_do,'HH24:MI') as HOD_SKUT_DO,
        to_date(to_char(ra.skut_hod_do,'HH24:MI:SS') ||' 01.01.2001','HH24:MI:SS DD.MM.YYYY') as pom_HOD_SKUT_OD,
        ra.TYDEN_OD,
        ra.TYDEN_DO,
        ra.TYDEN as zkr_tyden,
        DECODE(:lang, 'cs', (select fn_meaning2(ra.tyden,'TYDEN') from dual), 'sk', (select fn_meaning(ra.tyden,'TYDEN')  from dual),
           NVL((select fn_meaning_en(ra.tyden,'TYDEN')  from dual), (select fn_meaning(ra.tyden,'TYDEN') from dual))) as tyden,

        DECODE(:lang, 'cs', (select fn_meaning2(ra.den,'DEN') from dual), 'sk', (select fn_meaning(ra.den,'DEN')  from dual),
        NVL((select fn_meaning_en(ra.den,'DEN')  from dual), (select fn_meaning(ra.den,'DEN') from dual))) AS den,
        ra.roakidno,
        ra.GRUPIDNO,
        ra.JE_NADRAZENA,
        ra.POZNAMKA,
        ra.kontakt,
        FN_GET_UCITELE_RA(ra.roakidno,'P') as vsichni_ucitele_ra,
        (select c1.poradi from cg_ref_codes c1 where c1.rv_domain='DEN' and c1.rv_low_value=ra.den) as pora,
        ra.owner
from    rozvrh_akce ra,
        pred_varianty pv,
        ucitele uc,
        el_akt_vazby eav
where
  pv.ZKR_PREDM = ra.ZKR_PREDM
  and pv.PRAC_ZKR = ra.PRAC_ZKR
  and pv.ROK_VARIANTY = ra.ROK_VARIANTY
  and FN_CS_TO_UPPER_ASC(ra.PRAC_ZKR) LIKE FN_CS_TO_UPPER_ASC(nvl(:PRAC_ZKR,'%'))
  and (select FN_CS_TO_UPPER_ASC(ra.ZKR_PREDM) from dual) LIKE (select FN_CS_TO_UPPER_ASC(:ZKR_PREDM) from dual)
  and ra.semestr like nvl(:semestr,'%')
  and ra.TYPAKCE like nvl(:TYPAKCE,'%')
  and ra.rok_platnosti = :ak_rok
  and decode(nvl(:ucitel,'%'),'%',(select FN_CS_TO_UPPER_ASC(uc.prijmeni) from dual),(select FN_CS_TO_UPPER_ASC(uc.prijmeni) from dual)) like(select  FN_CS_TO_UPPER_ASC(:ucitel) from dual)
  and ra.UCITIDNO = uc.ucitidno(+)
  and nvl(ra.den,'%') like nvl(:den,'%')
  and nvl(upper(ra.ZKR_BUDOVY),'%')||'-'||nvl(upper(ra.CISLO_MIST),'%') like nvl(upper(:budova),'%')||'-'||nvl(upper(:mistnost),'%')
  and pv.ROK_VARIANTY like nvl(:ak_rok,'%')
  and eav.roakidno(+) = ra.roakidno
--@IFNOT(0)  and nvl(ra.HOD_VYUC_OD,0) >= nvl(:hod_od,0)
--@IFNOT(0) and nvl(ra.HOD_VYUC_DO,99) <= nvl(:hod_do,99)
--@IFNOT(0)  and nvl(:cas_od,'00:00') <= to_char(ra.SKUT_HOD_OD,'HH24:MI')
--@IFNOT(0)  and nvl(:cas_do,'24:00') >= to_char(ra.SKUT_HOD_DO,'HH24:MI')
--@IFNOT(0)  and ra.PLATNOST like nvl(:platnost,'%')
--@IFNOT(0)  and ra.tyden like nvl(:typ_tydne,'%')
--@IFNOT(0)  and nvl(ra.TYDEN_OD,1) between nvl(:tyden_od_od,1) and nvl(:tyden_od_do,53)
--@IFNOT(0)  and nvl(ra.TYDEN_DO,1) between nvl(:tyden_do_od,1) and nvl(:tyden_do_do,53)
--@IFNOT(0)  and nvl(ra.PLAN,0) between nvl(:plan_od,0) and nvl(:plan_do,999)
--@IFNOT(0)  and ra.OBSAZENI between nvl(:obsazeni_od,0) and nvl(:obsazeni_do,999)
--@IFNOT(0)  and decode(ra.plan,null,0,0,0,round(((ra.OBSAZENI/ra.plan)*100),2)) between nvl(:obsazeni_proc_od,0) and nvl(:obsazeni_proc_do,100)
--@IFNOT(0)  and ra.owner like nvl(:rozvrhar,'%')
--@IFNOT(0)  and FN_CS_TO_UPPER_ASC(ra.POZNAMKA) like (select FN_CS_TO_UPPER_ASC(:poznamka) from dual)
--@IFNOT(0)  and FN_CS_TO_UPPER_ASC(ra.KONTAKT) like (select FN_CS_TO_UPPER_ASC(:kontakt) from dual)
  and nvl(to_char(ra.GRUPIDNO),'%') like nvl(:grupa,'%')
  order by semestr desc, fk_prac_zkr, fk_zkr_predm, grupidno
