select distinct s.os_cislo,
        (select fn_meaning2(sp.fakulta_sp,'FAKULTA') from dual) fakulta,
        DECODE(:lang, 'cs', sp.CZ_NAZEV, 'sk', sp.CZ_NAZEV, NVL(sp.AN_NAZEV, sp.CZ_NAZEV)) AS program_nazev,
        sp.CZ_NAZEV program_cz_nazev, sp.AN_NAZEV program_an_nazev,
        (select fn_meaning2(sp.typ,'TYP_OBORU') from dual) typ,
        (select fn_meaning2(sp.forma,'FORMA_OBORU_NEW')  from dual) forma,
        (select fn_meaning2(svor.misto_vyuky, 'MISTO_VYUKY')  from dual) misto,
        DECODE(:lang, 'cs', nvl(stpl.NAZEV, ob.CZ_NAZEV), 'sk', nvl(stpl.NAZEV, ob.CZ_NAZEV),
          NVL(nvl(stpl.AN_NAZEV, ob.AN_NAZEV), nvl(stpl.NAZEV, ob.CZ_NAZEV))) AS plan_nazev,
        nvl(stpl.NAZEV, ob.CZ_NAZEV) plan_cz_nazev,
        nvl(stpl.AN_NAZEV, ob.AN_NAZEV) plan_an_nazev,
        DECODE(:lang, 'cs', ob.CZ_NAZEV, 'sk', ob.CZ_NAZEV, NVL(ob.AN_NAZEV, ob.CZ_NAZEV)) AS obor_nazev,
        ob.CZ_NAZEV obor_cz_nazev,
        ob.AN_NAZEV obor_an_nazev,
        svor.rok_platnosti rok,
        s.DAT_NASTUPU datum_nastupu,
        s.DAT_UKONCENI datum_ukonceni
    FROM studenti s,
         studijni_programy sp,
         studenti_v_roce svor,
         studenti_na_oboru_v_roce snor,
         studijni_plany stpl,
         obory ob
    WHERE s.stpridno = sp.stpridno
     AND s.os_cislo = :osCislo
     AND s.os_cislo = svor.os_cislo
     AND s.os_cislo = snor.os_cislo
     and svor.rok_platnosti = (select max(svor2.rok_platnosti) from  studenti_v_roce svor2
                               where svor2.os_cislo = :osCislo)
     AND snor.rok_platnosti = svor.rok_platnosti
     AND snor.stplidno = stpl.stplidno
     and stpl.OBORIDNO = ob.oboridno