CREATE OR REPLACE PACKAGE PG_DATEVA AS

  procedure INIT_dateva;
  procedure VLOZ_dateva(p_reakidno EVA_REAKCE.REAKIDNO%TYPE);
  procedure KONTR_dateva;

  procedure INIT_dateva_stats;
  procedure VLOZ_dateva_stats(p_respidno EVA_RESPONDENTI.RESPIDNO%TYPE);
  procedure KONTR_dateva_stats;

  TYPE eva_reakce_pk_tab IS TABLE OF EVA_REAKCE.REAKIDNO%TYPE INDEX BY BINARY_INTEGER;
  TYPE eva_respondenti_pk_tab IS TABLE OF EVA_RESPONDENTI.RESPIDNO%TYPE INDEX BY BINARY_INTEGER;

  pocet pls_integer;
  t_reakce eva_reakce_pk_tab;
  t_respondenti eva_respondenti_pk_tab;



END PG_DATEVA;

/


CREATE OR REPLACE PACKAGE BODY PG_DATEVA AS
  procedure INIT_dateva AS
  BEGIN
   pocet := 0;
   t_reakce.DELETE;
  END INIT_dateva;
  procedure VLOZ_dateva(p_reakidno EVA_REAKCE.REAKIDNO%TYPE)
  IS
  BEGIN
  pocet := pocet + 1;
  t_reakce(pocet) := p_reakidno;
  END VLOZ_dateva;
  procedure KONTR_dateva is
    cursor c_veto(p_reakidno EVA_REAKCE.REAKIDNO%TYPE)
    IS
    select
      r1.vetovano,
      r.dopridno,
      r.pripidno,
      r.reobidno
    from
      eva_reakce r,
      eva_reakce r1
    where
      r.reakidno = p_reakidno
      and (r1.dopridno = r.dopridno
        or r.dopridno is null)
      and (r1.pripidno = r.pripidno
        or r.pripidno is null)
      and (r1.reobidno = r.reobidno
        or r.reobidno is null)
      and (r1.roakidno = r.roakidno
        or r.roakidno is null)
    order by
      decode(r1.role,'RE',1,'DE',2,'VK','3','GA',4,'VY',5);
 rec_veto      c_veto%rowtype;
 xzverejneno VARCHAR2(1);
  BEGIN
    for i in 1 .. pocet loop
      open c_veto(t_reakce(i));
      fetch c_veto into rec_veto;
      close c_veto;
         /* rozvetveni */
      if rec_veto.dopridno is not null then
          /* zjistit zverejneno */
          select zverejneno into xzverejneno from eva_dot_predmet  where dopridno = rec_veto.dopridno;
           if rec_veto.vetovano = 'A'  and xzverejneno = 'A' THEN
             update Eva_dot_predmet
                set zverejneno = 'N'
             where dopridno = rec_veto.dopridno;
          elsif rec_veto.vetovano = 'N' and xzverejneno = 'N' then
            update EvA_dot_predmet
            set zverejneno = 'A'
            where dopridno = rec_veto.dopridno ;
          end if;
         elsif rec_veto.reobidno is not null then
           select zverejneno into xzverejneno from eva_resp_objekt  where reobidno = rec_veto.reobidno;
           if rec_veto.vetovano = 'A'  and xzverejneno = 'A' THEN
             update eva_resp_objekt
                set zverejneno = 'N'
             where reobidno = rec_veto.reobidno;
          elsif rec_veto.vetovano = 'N' and xzverejneno = 'N' then
            update eva_resp_objekt
            set zverejneno = 'A'
            where reobidno = rec_veto.reobidno;
          end if;
         elsif rec_veto.pripidno is not null then
          select zverejneno into xzverejneno from eva_pripominky  where pripidno = rec_veto.pripidno;
           if rec_veto.vetovano = 'A'  and xzverejneno = 'A' THEN
             update eva_pripominky
                set zverejneno = 'N'
             where pripidno = rec_veto.pripidno;
          elsif rec_veto.vetovano = 'N' and xzverejneno = 'N' then
            update eva_pripominky
            set zverejneno = 'A'
            where pripidno = rec_veto.pripidno;
        end if;
      end if;
    end loop;
    exception
      WHEN NO_DATA_FOUND THEN
         null;
  END KONTR_dateva;
  procedure INIT_dateva_stats AS
  BEGIN
   pocet := 0;
   t_respondenti.DELETE;
  END INIT_dateva_stats;
  procedure VLOZ_dateva_stats(p_respidno EVA_RESPONDENTI.RESPIDNO%TYPE)
  IS
  BEGIN
  pocet := pocet + 1;
  t_respondenti(pocet) := p_respidno;
  END VLOZ_dateva_stats;
  procedure KONTR_dateva_stats is
  /* predmety respondenta */
  cursor c_predmety(p_respidno IN EVA_RESPONDENTI.RESPIDNO%TYPE)is
  select
    re.dotaidno,
    ro.reobidno,
    ro.prac_zkr,
    ro.zkr_predm,
    ro.rok_varianty
  from
    eva_respondenti re ,
    eva_resp_objekt ro
  where
    re.respidno = p_respidno
    and ro.respidno = re.respidno
    and exists
          (select *
            from
              eva_odpovedi_resp
            where
              reobidno = ro.reobidno);
/*
  cursor c_statistiky(p_dotaidno IN EVA_DOTAZNIKY.DOTAIDNO%TYPE
                      ,p_prac_zkr IN PRED_VARIANTY.prac_ZKR%TYPE
                      ,p_zkr_predm IN PRED_VARIANTY.ZKR_PREDM%TYPE
                      ,p_rok_varianty IN PRED_VARIANTY.ROK_VARIANTY%TYPE)
 IS
 select x.statidno,
       x.pocet_odpovedi,
       round(x.prumer,3) prumer,
       round(x.rozptyl,3) rozptyl,
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,3))/(x.pocet_odpovedi * power(x.odchylka,3 ) ),3) )sikmost,  -- u=sum_i(x_i-prumer)^3/(n*sigma^3)
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,4))/(x.pocet_odpovedi * power(x.odchylka,4))-3,3)) spicatost, --  u=sum_i(x_i-prumer)^4/(n*sigma^4) - 3
       decode(nvl(x.pocet_odpovedi,0),0,null,1,null,
          decode(nvl(sto1.studentu,0),0,null,
            decode(x.prumer,0,0,
			        round(100*(1-x.pocet_odpovedi/sto1.studentu)*x.rozptyl/power(x.prumer,2)/x.pocet_odpovedi,3))
                 )
              )   pom_vyb_chyba,
       decode(x.pocet_odpovedi,0,null, 1,null,round(100*(power(x.pocet_odpovedi,2) - z.sum_cetnosti)/(x.pocet_odpovedi * (x.pocet_odpovedi - 1)),3) )mutabilita
from
(select stv.statidno,
       count(*) pocet_odpovedi,
       avg(so.bodovani) prumer,
       VARIANCE(so.bodovani) rozptyl,
       STDDEV(so.bodovani) odchylka
from eva_statistiky_objekt sto,
     eva_statistiky_tvrz stv,
     eva_respondenti re,
     eva_resp_objekt ro,
     eva_odpovedi_resp odp,
     eva_odpovedi so
where sto.dotaidno = p_dotaidno
  and sto.prac_zkr = p_prac_zkr
  and sto.zkr_predm = p_zkr_predm
  and sto.rok_varianty = p_rok_varianty
  and re.dotaidno = sto.dotaidno
  and re.username is NULL
  and ro.respidno = re.respidno
  and stv.staoidno  = sto.staoidno
  and (  odp.tdtvidno is not null
        and stv.tdtvidno = odp.tdtvidno
        or odp.doutidno is not null
        and stv.doutidno = odp.doutidno )
  and ro.prac_zkr = sto.prac_zkr
  AND ro.zkr_predm = sto.zkr_predm
  and ro.rok_varianty = sto.rok_varianty
  and (sto.statut_zapisu is null
         or ro.statut_zapisu = sto.statut_zapisu)
  AND odp.reobidno  = ro.reobidno
  and (odp.ucitidno is null and sto.ucitidno is null
         or odp.ucitidno = sto.ucitidno)
  AND (sto.roakidno is NULL
        or sto.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra where ra.reobidno = ro.reobidno and ra.pripidno is null and ra.roakidno = sto.roakidno)
        )
  AND   so.odpoidno = odp.odpoidno
  and nvl(so.textova_odpoved,'N') = 'N'
  and nvl(so.implicitni,'N') = 'N'
  GROUP BY  stv.statidno) X,
( select
    y.statidno,
    sum(power(pocet,2)) sum_cetnosti
  from
  (select stv2.statidno,
       so2.bodovani,
       count(*) pocet
from
    eva_statistiky_objekt sto2,
    eva_statistiky_tvrz stv2,
     eva_respondenti re2,
     eva_resp_objekt ro2,
     eva_odpovedi_resp odp2,
     eva_odpovedi so2
where sto2.dotaidno = p_dotaidno
  and sto2.prac_zkr = p_prac_zkr
  and sto2.zkr_predm = p_zkr_predm
  and sto2.rok_varianty = p_rok_varianty
  and stv2.staoidno = sto2.staoidno
  and ( odp2.tdtvidno is not null
        and stv2.tdtvidno = odp2.tdtvidno
        or odp2.doutidno is not null
        and stv2.doutidno = odp2.doutidno )
  and re2.dotaidno = sto2.dotaidno
  and re2.username is NULL
  and ro2.respidno = re2.respidno
  and ro2.prac_zkr = sto2.prac_zkr
  AND ro2.zkr_predm = sto2.zkr_predm
  and ro2.rok_varianty = sto2.rok_varianty
  and (sto2.statut_zapisu is null
         or ro2.statut_zapisu = sto2.statut_zapisu)
  AND odp2.reobidno  = ro2.reobidno
  and (odp2.ucitidno is null and sto2.ucitidno is null
         or odp2.ucitidno = sto2.ucitidno)
  AND (sto2.roakidno is NULL
        or sto2.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra2 where ra2.reobidno = ro2.reobidno and ra2.roakidno = sto2.roakidno and ra2.pripidno is null)
        )
  and so2.odpoidno = odp2.odpoidno
  and nvl(so2.textova_odpoved,'N') = 'N'
  and nvl(so2.implicitni,'N') = 'N'
  GROUP BY sto2.staoidno,
        stv2.statidno,
       odp2.tdtvidno,
       odp2.doutidno,
       so2.bodovani)Y
group by      y.statidno)Z,
     eva_statistiky_objekt sto1,
     eva_statistiky_tvrz stv1,
     eva_respondenti re1,
     eva_resp_objekt ro1,
     eva_odpovedi_resp odp1,
     eva_odpovedi so1
 where stv1.statidno = x.statidno
  and z.statidno  = x.statidno
  and sto1.staoidno = stv1.staoidno
  and  re1.dotaidno = sto1.dotaidno
  and re1.username is NULL
  and ro1.respidno = re1.respidno
  and sto1.prac_zkr = p_prac_zkr
  and sto1.zkr_predm = p_zkr_predm
  and sto1.rok_varianty = p_rok_varianty
  and ro1.prac_zkr = sto1.prac_zkr
  AND ro1.zkr_predm = sto1.zkr_predm
  and ro1.rok_varianty = sto1.rok_varianty
  and ( sto1.statut_zapisu is null
         or ro1.statut_zapisu = sto1.statut_zapisu)
  AND odp1.reobidno  = ro1.reobidno
  and (odp1.tdtvidno is not null
       and odp1.tdtvidno = stv1.tdtvidno
       or odp1.doutidno is not null
         and odp1.doutidno = stv1.doutidno)
  and (odp1.ucitidno is null and sto1.ucitidno is null
         or odp1.ucitidno = sto1.ucitidno)
  AND (sto1.roakidno is NULL
        or sto1.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra1 where ra1.reobidno = ro1.reobidno and ra1.roakidno = sto1.roakidno and ra1.pripidno is null)
        )
   and so1.odpoidno = odp1.odpoidno
  and nvl(so1.textova_odpoved,'N') = 'N'
  and nvl(so1.implicitni,'N') = 'N'
  group by x.statidno,
         sto1.studentu,
       x.pocet_odpovedi,
       x.prumer,
       x.rozptyl,
       x.odchylka,
       z.sum_cetnosti
       ;
*/
cursor c_statistiky(p_dotaidno IN EVA_DOTAZNIKY.DOTAIDNO%TYPE,
                    p_reobidno IN EVA_RESP_OBJEKT.reobidno%TYPE
                      ,p_prac_zkr IN PRED_VARIANTY.prac_ZKR%TYPE
                      ,p_zkr_predm IN PRED_VARIANTY.ZKR_PREDM%TYPE
                      ,p_rok_varianty IN PRED_VARIANTY.ROK_VARIANTY%TYPE)
                      is
select x.staoidno,
       x.tdtvidno,
       x.doutidno,
       x.pocet_odpovedi,
       round(x.prumer,3) prumer,
       round(x.rozptyl,3) rozptyl,
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,3))/(x.pocet_odpovedi * power(x.odchylka,3 ) ),3) )sikmost,  -- u=sum_i(x_i-prumer)^3/(n*sigma^3)
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,4))/(x.pocet_odpovedi * power(x.odchylka,4))-3,3)) spicatost, --  u=sum_i(x_i-prumer)^4/(n*sigma^4) - 3
       decode(nvl(x.pocet_odpovedi,0),0,null,1,null,
          decode(nvl(sto1.studentu,0),0,null,
            decode(x.prumer,0,0,
			        round(100*(1-x.pocet_odpovedi/sto1.studentu)*x.rozptyl/power(x.prumer,2)/x.pocet_odpovedi,3))
                 )
              )   pom_vyb_chyba,
       decode(x.pocet_odpovedi,0,null, 1,null,round(100*(power(x.pocet_odpovedi,2) - z.sum_cetnosti)/(x.pocet_odpovedi * (x.pocet_odpovedi - 1)),3) )mutabilita
from
(
select sto.staoidno,
       odp.tdtvidno,
       odp.doutidno,
       count(*) pocet_odpovedi,
       avg(so.bodovani) prumer,
       VARIANCE(so.bodovani) rozptyl,
       STDDEV(so.bodovani) odchylka
from eva_statistiky_objekt sto,
     eva_respondenti re,
     eva_resp_objekt ro,
     eva_odpovedi_resp odp,
     eva_odpovedi so
where re.dotaidno = p_dotaidno
  and re.username is NULL
  and sto.dotaidno = re.dotaidno
  and sto.prac_zkr = p_prac_zkr
  and sto.zkr_predm = p_zkr_predm
  and sto.rok_varianty = p_rok_varianty
  and ro.respidno = re.respidno
  and ro.prac_zkr = sto.prac_zkr
  AND ro.zkr_predm = sto.zkr_predm
  and ro.rok_varianty = sto.rok_varianty
  AND odp.reobidno  = ro.reobidno
  and (sto.statut_zapisu is null
         or ro.statut_zapisu = sto.statut_zapisu)
  and (odp.ucitidno is null and sto.ucitidno is null
         or odp.ucitidno = sto.ucitidno)
  AND (sto.roakidno is NULL
        or sto.roakidno IN
           (select ra.roakidno
              from
                eva_rozvrh_akce ra
              where
                ra.reobidno = p_reobidno -- update jen ra spojene s respondentem
                and ra.pripidno is null
                )
        )
  AND   so.odpoidno = odp.odpoidno
  and nvl(so.textova_odpoved,'N') = 'N'
  and nvl(so.implicitni,'N') = 'N'
  GROUP BY sto.staoidno,
       odp.tdtvidno,
       odp.doutidno) X,
( select
    y.staoidno,
    y.tdtvidno,
    y.doutidno,
    sum(power(pocet,2)) sum_cetnosti
  from
  (
  select
    sto2.staoidno,
    odp2.tdtvidno,
    odp2.doutidno,
    so2.bodovani,
    count(*) pocet
  from
    eva_statistiky_objekt sto2,
    eva_respondenti re2,
    eva_resp_objekt ro2,
    eva_odpovedi_resp odp2,
    eva_odpovedi so2
  where sto2.dotaidno = p_dotaidno
    and sto2.prac_zkr = p_prac_zkr
    and sto2.zkr_predm = p_zkr_predm
    and sto2.rok_varianty = p_rok_varianty
    and re2.dotaidno = sto2.dotaidno
    and re2.username is NULL
    and ro2.respidno = re2.respidno
    and ro2.prac_zkr = sto2.prac_zkr
    AND ro2.zkr_predm = sto2.zkr_predm
    and ro2.rok_varianty = sto2.rok_varianty
    and (sto2.statut_zapisu is null
         or ro2.statut_zapisu = sto2.statut_zapisu)
    AND odp2.reobidno  = ro2.reobidno
    and (odp2.ucitidno is null and sto2.ucitidno is null
         or odp2.ucitidno = sto2.ucitidno)
    AND (sto2.roakidno is NULL
        or sto2.roakidno in
             (select
                ra2.roakidno
              from
                eva_rozvrh_akce ra2
              where
                ra2.reobidno = p_reobidno
                and ra2.pripidno is null)
        )
  and so2.odpoidno = odp2.odpoidno
  and nvl(so2.textova_odpoved,'N') = 'N'
  and nvl(so2.implicitni,'N') = 'N'
  GROUP BY sto2.staoidno,
          odp2.tdtvidno,
       odp2.doutidno,
       so2.bodovani) Y
 group by
    y.staoidno,
    y.tdtvidno,
    y.doutidno)Z,
     eva_statistiky_objekt sto1,
     eva_respondenti re1,
     eva_resp_objekt ro1,
     eva_odpovedi_resp odp1,
     eva_odpovedi so1
  where sto1.staoidno = x.staoidno
  and (odp1.tdtvidno = x.tdtvidno
      or odp1.doutidno = x.doutidno)
  and z.staoidno  = x.staoidno
 and (z.tdtvidno = x.tdtvidno
      or z.doutidno = x.doutidno )
  and  re1.dotaidno = sto1.dotaidno
  and re1.username is NULL
  and ro1.respidno = re1.respidno
  and sto1.prac_zkr = p_prac_zkr
  and sto1.zkr_predm = p_zkr_predm
  and sto1.rok_varianty = p_rok_varianty
  and ro1.prac_zkr = sto1.prac_zkr
  AND ro1.zkr_predm = sto1.zkr_predm
  and ro1.rok_varianty = sto1.rok_varianty
  and ( sto1.statut_zapisu is null
         or ro1.statut_zapisu = sto1.statut_zapisu)
  AND odp1.reobidno  = ro1.reobidno
  and (odp1.ucitidno is null and sto1.ucitidno is null
         or odp1.ucitidno = sto1.ucitidno)
  AND (sto1.roakidno is NULL
        or sto1.roakidno in
          (select
                ra3.roakidno
              from
                eva_rozvrh_akce ra3
              where
                ra3.reobidno = p_reobidno
                and ra3.pripidno is null)
       )
   and so1.odpoidno = odp1.odpoidno
  and nvl(so1.textova_odpoved,'N') = 'N'
  and nvl(so1.implicitni,'N') = 'N'
  group by
    x.staoidno,
    x.tdtvidno,
    x.doutidno,
    sto1.studentu,
    x.pocet_odpovedi,
    x.prumer,
    x.rozptyl,
    x.odchylka,
    z.sum_cetnosti;
xdotaidno eva_dotazniky.dotaidno%TYPE;
xprac_zkr pred_varianty.prac_zkr%type;
xzkr_predm pred_varianty.zkr_predm%type;
xrok_varianty pred_varianty.rok_varianty%type;
xreobidno eva_resp_objekt.reobidno%type;
xstudentu number;
  BEGIN
  for i in 1 .. pocet loop
    /* update poctu respondentu u predmetu, grain ra, statut
       brrrrr merge se nesnese s API triggerama */
   /*merge into eva_statistiky_objekt s
   using(
     select
      x.dotaidno,
      x.prac_zkr,
      x.zkr_predm,
      x.rok_varianty,
      x.roakidno,
      x.statut_zapisu
    from
     (SELECT
       re.dotaidno,
       ro.prac_zkr,
       ro.zkr_predm,
       ro.rok_varianty,
       ra.roakidno,
       ro.statut_zapisu
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_rozvrh_akce ra
      where
        re.respidno  = t_respondenti(i)
        and ro.respidno = re.respidno
        and ra.reobidno = ro.reobidno
      group by rollup(
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty,
        ro.statut_zapisu,
        ra.roakidno) union
       SELECT
         re.dotaidno,
         ro.prac_zkr,
         ro.zkr_predm,
         ro.rok_varianty,
         ra.roakidno,
         null
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_rozvrh_akce ra
      where
        re.respidno  = t_respondenti(i)
        and ro.respidno = re.respidno
        and ra.reobidno = ro.reobidno
      group by rollup(
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty,
       ra.roakidno
        )
        )x
      where x.rok_varianty is not null
      and x.prac_Zkr is not null
      and x.zkr_predm is not null) y
    ON
    (s.prac_zkr = y.prac_zkr
    and      s.zkr_predm = y.zkr_predm
    and s.rok_varianty  = y.rok_varianty
    and nvl(s.statut_zapisu,'N') = nvl(y.statut_zapisu,'N')
    and( s.roakidno is null and y.roakidno is null
    or s.roakidno = y.roakidno)
    and  s.dotaidno = y.dotaidno)
    WHEN MATCHED THEN UPDATE SET s.respondentu = s.respondentu + 1
    WHEN NOT MATCHED THEN INSERT (dotaidno, prac_zkr, zkr_predm, rok_varianty, statut_zapisu, roakidno, ucitidno, studentu, respondentu) values
    (y.dotaidno,
    y.prac_zkr,
     y.zkr_predm,
     y.rok_varianty,
     y.statut_zapisu,
     y.roakidno,
       null,
       0,
       1) ;*/
  for p in(    select
      x.dotaidno,
      x.prac_zkr,
      x.zkr_predm,
      x.rok_varianty,
      x.roakidno,
      x.statut_zapisu
    from
     (SELECT
       re.dotaidno,
       ro.prac_zkr,
       ro.zkr_predm,
       ro.rok_varianty,
       ra.roakidno,
       ro.statut_zapisu
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_rozvrh_akce ra
      where
        re.respidno  = t_respondenti(i)
        and ro.respidno = re.respidno
        and ra.reobidno = ro.reobidno
      group by rollup(
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty,
        ro.statut_zapisu,
        ra.roakidno) union
       SELECT
         re.dotaidno,
         ro.prac_zkr,
         ro.zkr_predm,
         ro.rok_varianty,
         ra.roakidno,
         null
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_rozvrh_akce ra
      where
        re.respidno  = t_respondenti(i)
        and ro.respidno = re.respidno
        and ra.reobidno = ro.reobidno
      group by rollup(
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty,
       ra.roakidno
        )
        )x
      where x.rok_varianty is not null
      and x.prac_Zkr is not null
      and x.zkr_predm is not null) loop
       update eva_statistiky_objekt
       set respondentu = respondentu + 1
       where  prac_zkr = p.prac_zkr
    and      zkr_predm = p.zkr_predm
    and rok_varianty  = p.rok_varianty
    and nvl(statut_zapisu,'N') = nvl(p.statut_zapisu,'N')
    and( roakidno is null and p.roakidno is null
    or roakidno = p.roakidno)
    and  dotaidno = p.dotaidno;
       
       if SQL%ROWCOUNT = 0 then
         select
          count(*) into xstudentu
          from
            vstudenti_na_oboru_eva sp,
            znamky z,
            eva_dotazniky dot
         where
          dot.dotaidno = p.dotaidno
           and z.prac_zkr = p.prac_zkr
           and z.zkr_predm = p.zkr_predm
           and z.rok_varianty = p.rok_varianty
           and z.os_cislo  = sp.os_cislo
           and z.uznano = 'N'
           and z.semestr = dot.semestr
           and sp.rok_platnosti = dot.skolni_rok
           AND (select count(*)
      from
        eva_omezeni_resp om,
        eva_polozky_zahlavi pz
       where
         om.tydoidno = dot.tydoidno
         AND om.zapoidno = pz.zapoidno
         AND (pz.zkr          = 'fakulta'
              AND sp.fakulta_sp   = om.hodnota_polozky
              or
               (pz.zkr          = 'obor'
                AND to_char(sp.oboridno)   = om.hodnota_polozky)
              or (pz.zkr          = 'studijni_program'
                AND to_char(sp.stpridno)   = om.hodnota_polozky)
              or (pz.zkr          = 'rok_studia'
                AND sp.standard_rok   = om.hodnota_polozky)
                ) ) = 0
                and (z.statut = p.statut_zapisu
                     or p.statut_zapisu is null)
                and (p.roakidno is null
                  or exists (select null from  eva_resp_objekt ro, eva_rozvrh_akce ra
                  where ro.respidno = t_respondenti(i)
                  and ra.reobidno = ro.reobidno));
        INSERT into eva_statistiky_objekt (dotaidno, prac_zkr, zkr_predm, rok_varianty, statut_zapisu, roakidno, ucitidno, studentu, respondentu)
        values (p.dotaidno,
    p.prac_zkr,
     p.zkr_predm,
     p.rok_varianty,
     p.statut_zapisu,
     p.roakidno,
      null,
      xstudentu,
       1);
     end if;
      end loop;
/* statistiky update */
      open c_predmety(t_respondenti(i));
      loop
        fetch c_predmety into xdotaidno,xreobidno,  xprac_zkr, xzkr_predm, xrok_varianty;
        exit when c_predmety%notfound;
       for x in c_statistiky(xdotaidno, xreobidno, xprac_zkr, xzkr_predm, xrok_varianty) loop
         begin
       insert into eva_statistiky_tvrz(staoidno, tdtvidno, doutidno, odpovedi, prumer, rozptyl, pom_vyb_chyba, sikmost, spicatost, mutabilita)
       values (x.staoidno, x.tdtvidno, x.doutidno, x.pocet_odpovedi, x.prumer, x.rozptyl, x.pom_vyb_chyba, x.sikmost, x.spicatost, x.mutabilita);
          exception
           when dup_val_on_index then
          UPDATE eva_statistiky_tvrz
          set odpovedi = x.pocet_odpovedi
          ,prumer = x.prumer
          ,rozptyl = x.rozptyl
          ,pom_vyb_chyba = x.pom_vyb_chyba
          ,sikmost = x.sikmost
          ,spicatost = x.spicatost
          ,mutabilita = x.mutabilita
          where
             staoidno = x.staoidno
            and (tdtvidno = x.tdtvidno
                and doutidno is null
                and x.doutidno is null
              or
                doutidno = x.doutidno
                and tdtvidno is null
                and x.tdtvidno is null)
        ;
          end;
       end loop;
   end loop;
 end loop;
  END KONTR_dateva_stats;
END PG_DATEVA;
/

