CREATE OR REPLACE PACKAGE                   Pg_Eva IS


type ref_c is ref cursor;

/* neni k tomu napsana funkce, proto je kursor ve verejne casti, v tele baliku je kursor i s RA, 
  tento je docasny pro usnadneni prevodu dat */
  
cursor c_stats_obj_ins_bez_ra(p_dotaidno eva_dotazniky.dotaidno%type) is
           select
           dp.dotaidno,
           dp.prac_zkr,
           dp.zkr_predm,
           dp.rok_varianty,
           null roakidno,
           z.statut,
           count (z.os_cislo) studentu
          from
           eva_dotazniky dot,   
           eva_dot_predmet dp,
           vstudenti_na_oboru_eva sp,
           znamky z
          where
           dot.dotaidno = p_dotaidno
          and dp.dotaidno = dot.dotaidno
          and z.prac_zkr = dp.prac_zkr
          and z.zkr_predm = dp.zkr_predm
          and z.rok_varianty = dp.rok_varianty
          and z.semestr = dot.semestr
          and z.uznano = 'N'
          and sp.os_cislo = z.os_cislo
          and sp.rok_platnosti = dot.skolni_rok          
          and(select count(*)   from
                 eva_omezeni_resp om,
                 eva_polozky_zahlavi pz
                where
                  om.tydoidno = dot.tydoidno
                  AND om.zapoidno = pz.zapoidno
                  AND (pz.zkr          = 'fakulta'
                       AND sp.fakulta_sp   = om.hodnota_polozky
                       or
                        (pz.zkr          = 'obor'
                         AND to_char(sp.oboridno)   = om.hodnota_polozky)
                       or (pz.zkr          = 'studijni_program'
                         AND to_char(sp.stpridno)   = om.hodnota_polozky)
                       or (pz.zkr          = 'rok_studia'
                         AND sp.standard_rok   = om.hodnota_polozky)
                         ) ) = 0
          group by dp.dotaidno, dp.prac_zkr, dp.zkr_predm, dp.rok_varianty,rollup(z.statut)     
order by 2,3,5,6;

function zobraz_zahlavi(metoda VARCHAR2, p_zkr VARCHAR2,lang VARCHAR2)
  return varchar2;

function zobraz_fakulta(p_zkr VARCHAR2,lang VARCHAR2)
  return varchar2;

function zobraz_studijni_program(p_stpridno VARCHAR2,lang VARCHAR2)
  return varchar2;

function zobraz_obor(p_oboridno VARCHAR2,lang VARCHAR2)
  return varchar2;

function zobraz_kombinace (p_kombidno VARCHAR2,lang VARCHAR2)
  return varchar2;

function zobraz_typ(p_abbreviation VARCHAR2, lang VARCHAR2)
  return varchar2;

function zobraz_typ_zk_new(p_low_value VARCHAR2, lang VARCHAR2)
  return varchar2;

function zobraz_forma(p_abbreviation VARCHAR2, lang VARCHAR2)
  return varchar2;

function zobraz_vykazovan(p_abbreviation VARCHAR2,lang VARCHAR2)
  return varchar2;

function get_default_odpoidno(p_saodidno NUMBER)
 return number;

 function get_default_odpoidno(p_tdtvidno NUMBER, p_doutidno NUMBER)
 return number;

 function cti_parametr(p_dotaidno NUMBER, p_parametr VARCHAR2)
  return VARCHAR2;

function cti_parametr1(p_tydoidno NUMBER, p_parametr VARCHAR2)
  return VARCHAR2;

 function get_respidno(p_dotaidno NUMBER, p_username VARCHAR2)
  return number;

 function get_odpovedi(p_saodidno NUMBER, volby VARCHAR2 default null) return
 varchar2;

 function update_odpovedi(p_respidno NUMBER, p_reobidno NUMBER,a_data eva_tvrzodp_tab,
                         p_pripominka VARCHAR2, p_anonymni VARCHAR2)
  return varchar2; -- null update ok, retezec neuspesnych odreidno oddelenych strednikem, na konci mozno failed pro neuspesny uppdate pripominky

  function update_pripominka_sem(p_respidno NUMBER,  p_prip_sem VARCHAR2)
  return number; -- 0 update ok

  function update_pripominka_tech(p_respidno NUMBER,  p_prip_tech VARCHAR2)
  return number; -- 0 update ok

 function get_ma_prip_obj(p_reobidno NUMBER)
  return number; -- navrat 0 - nema vyplneno, 1 - ma vyplneno

 function get_ma_prip_celk(p_respidno NUMBER, p_typ_prip VARCHAR2)
  return number; -- navrat 0 - nema vyplneno, 1 - ma vyplneno, typ_prip - SEM, TECH

 /*function get_ma_prip_celk(p_username VARCHAR, p_dotaidno NUMBER,  p_typ_prip VARCHAR2)
  return number; -- navrat 0 - nema vyplneno, 1 - ma vyplneno, typ_prip - SEM, TECH */

 function close_dotaznik(p_respidno NUMBER)
  return number; -- 0 uzavreni OK

 function get_text_tvrzeni(p_tdtvidno NUMBER , p_doutidno NUMBER)  -- asi se nepouziva nikde ... proverit
   RETURN VARCHAR2;

 function  get_merged_reakce(p_vetoidno NUMBER, p_reobidno NUMBER, p_pripidno NUMBER)
   return clob;

 function get_role_predmet(p_ucitidno number, p_dopridno NUMBER)  -- vrati nejvyssi  GA, VK, DE, PR, null
 return varchar2;

function get_nejvyssi_vetovano(p_dopridno NUMBER, p_reobidno number, p_pripidno number,p_roak VARCHAR2)-- vrati nejvyznamejsi hodnotu vetovano u predmetu
 return varchar2;

function ma_hledanou_prip(key_words VARCHAR2, p_dopridno number)
return number;

procedure pr_get_role(p_ucitidno in NUMBER, out_role OUT VARCHAR2, out_fakulta OUT VARCHAR2, out_katedra OUT VARCHAR2);

function get_vyucujici_predm(p_dotaidno IN NUMBER, p_prac_zkr IN VARCHAR2, p_zkr_predm IN VARCHAR2, p_rok_varianty IN VARCHAR2)
return VARCHAR2;

function get_rozvrh_akce(p_pripidno IN NUMBER, p_reobidno IN NUMBER)
return VARCHAR2;

/*function copy_anketa(p_vzor EVA_TYP_DOTAZNIKU.TYDOIDNO%TYPE, p_zkr EVA_TYP_DOTAZNIKU.ZKR%TYPE)
return number;*/
procedure  copy_anketa(p_vzor EVA_TYP_DOTAZNIKU.TYDOIDNO%TYPE, p_zkr EVA_TYP_DOTAZNIKU.ZKR%TYPE);

function  cp_anketa(p_vzor EVA_TYP_DOTAZNIKU.TYDOIDNO%TYPE)
return number;

function fn_role_pristup(p_uzroidno eva_role_pristup.uzroidno%TYPE)
return varchar2;

/*
function ins_eva_role(p_ucitidno EVA_ROLE.UCITIDNO%TYPE, p_role EVA_ROLE.ROLE_UZIVATELE%TYPE)
return EVA_ROLE.UZROIDNO%TYPE;
*/
function autoclose_dotazniku(p_dotaidno IN NUMBER)
return number;

procedure job_ukonceni;

function get_default_rok return VARCHAR2;

/* deprecated */
function statistiky_update(p_dotaidno IN NUMBER)
return number;

function statistiky_merge(p_dotaidno eva_dotazniky.dotaidno%type)
return number;

function statistiky_obj_insert(p_dotaidno in eva_dotazniky.dotaidno%type)
return number;

function statistiky_tvrz_merge(p_dotaidno in eva_dotazniky.dotaidno%type)
return number;

function get_rok_semestr_b (p_tydoidno IN NUMBER)
return varchar2 ;

function ins_eva_glob_stats(p_dotaidno IN NUMBER)
return number;

function upd_eva_glob_stats(p_dotaidno IN NUMBER)
return number;

function del_nevyplnene_dot(p_dotaidno in number)
return number;

function ins_dotaznik_b(p_tydoidno EVA_DOTAZNIKY.TYDOIDNO%TYPE,
p_otevreni varchar2,
p_uzavreni varchar2,
p_skolni_rok varchar2,
p_semestr varchar2,
p_predstih varchar2,
p_vetovani varchar2,
p_text_emailu varchar2,
p_ucitidno varchar2,
p_prac_zkr varchar2,
p_zkr_predm varchar2,
p_rok_varianty varchar2
)
return varchar2;
--return number;

function typdot_tvrz_insert(p_tydoidno number,
                            p_sluzidno number,
                            p_satvidno number,
                            p_poradi number,
                            p_saodidno number,
                            p_vaha  number)
return number;

function get_tydoidno_b
return eva_typ_dotazniku.tydoidno%type;

function complete_delete_dotaznik(p_dotaidno number)
return number;


TYP_B_BLOCKED_SEM EXCEPTION;
TYP_B_BLOCKED_INTERVAL EXCEPTION;
TYP_B_MIN  EXCEPTION;
TYP_B_ZALOZEN EXCEPTION;


end;
/


CREATE OR REPLACE package body          Pg_Eva as


cursor c_stats_obj_ins(p_dotaidno eva_dotazniky.dotaidno%type) is
           select
           dp.dotaidno,
           dp.prac_zkr,
           dp.zkr_predm,
           dp.rok_varianty,
           null roakidno,
           z.statut,
           count (z.os_cislo) studentu
          from
           eva_dotazniky dot,   eva_dot_predmet dp,
           vstudenti_na_oboru_eva sp,
           znamky z
          where
           dot.dotaidno = p_dotaidno
          and dp.dotaidno = dot.dotaidno
          and z.prac_zkr = dp.prac_zkr
          and z.zkr_predm = dp.zkr_predm
          and z.rok_varianty = dp.rok_varianty
          and z.semestr = dot.semestr
          and z.uznano = 'N'
          and sp.os_cislo = z.os_cislo
          and sp.rok_platnosti = dot.skolni_rok          
          and(select count(*)   from
                 eva_omezeni_resp om,
                 eva_polozky_zahlavi pz
                where
                  om.tydoidno = dot.tydoidno
                  AND om.zapoidno = pz.zapoidno
                  AND (pz.zkr          = 'fakulta'
                       AND sp.fakulta_sp   = om.hodnota_polozky
                       or
                        (pz.zkr          = 'obor'
                         AND to_char(sp.oboridno)   = om.hodnota_polozky)
                       or (pz.zkr          = 'studijni_program'
                         AND to_char(sp.stpridno)   = om.hodnota_polozky)
                       or (pz.zkr          = 'rok_studia'
                         AND sp.standard_rok   = om.hodnota_polozky)
                         ) ) = 0
          group by dp.dotaidno, dp.prac_zkr, dp.zkr_predm, dp.rok_varianty,rollup(z.statut)
     union
     select
           dp.dotaidno,
           dp.prac_zkr,
           dp.zkr_predm,
           dp.rok_varianty,
           zap.roakidno,
           z.statut,
           count (zap.os_cislo) studentu
          from
           eva_dotazniky dot,
           eva_dot_predmet dp,
           vstudenti_na_oboru_eva sp,
           zapisy zap,
           znamky z
          where
           dot.dotaidno = p_dotaidno
          and dp.dotaidno = dot.dotaidno
          and z.prac_zkr = dp.prac_zkr
          and z.zkr_predm = dp.zkr_predm
          and z.rok_varianty = dp.rok_varianty
          and z.semestr = dot.semestr
          and sp.os_cislo = z.os_cislo
          and z.uznano = 'N'
          and sp.rok_platnosti = dot.skolni_rok          
          and zap.prac_zkr = z.prac_zkr
          and zap.zkr_predm = z.zkr_predm
          and zap.rok_varianty = z.rok_varianty
          and zap.semestr = z.semestr
          and zap.rok_platnosti = dot.skolni_rok
          and zap.os_cislo = z.os_cislo
         and (select count(*)
               from
                 eva_omezeni_resp om,
                 eva_polozky_zahlavi pz
                where
                  om.tydoidno = dot.tydoidno
                  AND om.zapoidno = pz.zapoidno
                  AND (pz.zkr          = 'fakulta'
                       AND sp.fakulta_sp   = om.hodnota_polozky
                       or
                        (pz.zkr          = 'obor'
                         AND to_char(sp.oboridno)   = om.hodnota_polozky)
                       or (pz.zkr          = 'studijni_program'
                         AND to_char(sp.stpridno)   = om.hodnota_polozky)
                       or (pz.zkr          = 'rok_studia'
                         AND sp.standard_rok   = om.hodnota_polozky)
                         ) ) = 0
          group by
            dp.dotaidno,
            dp.prac_zkr,
            dp.zkr_predm,
            dp.rok_varianty,
            zap.roakidno,
            rollup(z.statut)
order by 2,3,5,6;

function zobraz_zahlavi(metoda VARCHAR2, p_zkr VARCHAR2,lang VARCHAR2)
  return varchar2
  is
  xselect  VARCHAR2(500);
  hodnota VARCHAR2(500);

begin


    xselect := 'select pg_eva.zobraz_'||metoda ||'(:1,:2) from dual';
    execute IMMEDIATE xselect into hodnota using p_zkr, lang;

    return(hodnota);

    exception when
      OTHERS then
        return (SQLERRM);


end zobraz_zahlavi;


function zobraz_fakulta(p_zkr VARCHAR2,lang VARCHAR2)
  return varchar2 is

  nazev CIS_PRACOVIST.NAZEV%TYPE;

 begin

    select  decode(lang,'en', cp.an_nazev, cp.nazev) into nazev  from
    cis_pracovist cp
    where cp.zkr = p_zkr;

  return nazev;

  exception when
      OTHERS then
        return null;

end zobraz_fakulta;

function zobraz_studijni_program(p_stpridno VARCHAR2,lang VARCHAR2)
  return varchar2 is

  nazev studijni_programy.CZ_NAZEV%TYPE;

 begin

    select  decode(lang,'en', stpr.an_nazev, stpr.cz_nazev) into nazev  from
    studijni_programy stpr
    where stpr.stpridno = to_number(p_stpridno);

  return nazev;

  exception when
      OTHERS then
        return null;

end zobraz_studijni_program;

function zobraz_obor(p_oboridno VARCHAR2, lang VARCHAR2)
  return varchar2 is

  nazev obory.CZ_NAZEV%TYPE;

 begin

    select  decode(lang,'en', o.an_nazev, o.cz_nazev) into nazev  from
    obory o
    where o.oboridno = to_number(p_oboridno);

  return nazev;

  exception when
      OTHERS then
        return null;

end zobraz_obor;

function zobraz_kombinace(p_kombidno VARCHAR2,lang VARCHAR2)
  return varchar2 is

 komb VARCHAR2(4000);

 begin
  /* *vykradeno z fn_konbinace, rozsireno o lokaliaci */
  komb := '';

  for k in (select decode(lang,'en',o.an_nazev, o.cz_nazev) nazev
     from pom_komb pk,obory o
             where pk.oboridno=o.oboridno
               and pk.kombidno=to_number(p_kombidno)
               and o.je_aprobace='A') loop

           komb := komb||', '||k.nazev;

  end loop;

  if length(komb) > 2 then
     komb := substr(komb,3);
   end if;

   RETURN komb;


  exception when
      OTHERS then
        return null;

end zobraz_kombinace;

function zobraz_typ(p_abbreviation VARCHAR2, lang VARCHAR2)
  return varchar2

is

hodnota CG_REF_CODES.RV_MEANING%TYPE;

 begin

 select decode(lang,'en', english, rv_meaning) into hodnota
   from cg_ref_codes
  where rv_domain = 'TYP_OBORU'
    and rv_abbreviation = p_abbreviation;

  return hodnota;

  exception when
      OTHERS then
        return null;

end zobraz_typ;

function zobraz_typ_zk_new(p_low_value VARCHAR2, lang VARCHAR2)
  return varchar2

is

hodnota CG_REF_CODES.RV_MEANING%TYPE;

 begin

 select decode(lang,'en', english, rv_meaning) into hodnota
   from cg_ref_codes
  where rv_domain = 'TYP_ZK_NEW'
    and rv_low_value = p_low_value;

  return hodnota;

  exception when
      OTHERS then
        return null;

end zobraz_typ_zk_new;

function zobraz_forma(p_abbreviation VARCHAR2, lang VARCHAR2)
  return varchar2

is

hodnota CG_REF_CODES.RV_MEANING%TYPE;

 begin

 select decode(lang,'en', english, rv_meaning) into hodnota
   from cg_ref_codes
  where rv_domain = 'FORMA_OBORU_NEW'
    and rv_abbreviation = p_abbreviation;

  return hodnota;

  exception when
      OTHERS then
        return null;

end zobraz_forma;


function zobraz_vykazovan(p_abbreviation VARCHAR2,lang VARCHAR2)
  return varchar2 is

hodnota CG_REF_CODES.RV_MEANING%TYPE;

 begin
  select decode(lang,'en', english, rv_meaning) into hodnota
   from cg_ref_codes
  where rv_domain = 'ANO_NE'
    and rv_abbreviation = p_abbreviation;

  return hodnota;

  exception when
      OTHERS then
        return null;
end zobraz_vykazovan;

function get_default_odpoidno(p_saodidno NUMBER)
 return number
 is

 cursor c_odpoved is
  select   odp.odpoidno
    from  eva_odpovedi odp
    where   odp.saodidno = p_saodidno
   order by implicitni, poradi  ;

 xnavrat number;

 begin

     open c_odpoved;
     fetch c_odpoved into xnavrat;
     close c_odpoved;

     return xnavrat;
 end;

 function get_default_odpoidno(p_tdtvidno NUMBER, p_doutidno NUMBER)
 return number
 is

 cursor c_odpoved_tdtv is
  select   odp.odpoidno
    from  eva_odpovedi odp,
          eva_typdot_tvrzeni tt
    where  tt.tdtvidno = p_tdtvidno
      and   odp.saodidno = tt.saodidno
   order by odp.implicitni, odp.poradi;

cursor c_odpoved_dout is
   select   odp.odpoidno
    from  eva_odpovedi odp,
          eva_dot_ucitel_tvrz ut
    where  ut.doutidno = p_doutidno
      and   odp.saodidno = ut.saodidno
   order by odp.implicitni, odp.poradi;

 xnavrat number;

 begin

    if p_tdtvidno is not null then

     open c_odpoved_tdtv;
     fetch c_odpoved_tdtv into xnavrat;
     close c_odpoved_tdtv;

    else

     open c_odpoved_dout;
     fetch c_odpoved_dout into xnavrat;
     close c_odpoved_dout;

    end if;

     return xnavrat;

 end;

 function cti_parametr(p_dotaidno NUMBER, p_parametr VARCHAR2)
  return VARCHAR2
  is

    xnavrat EVA_NASTAVENI.HODNOTA_PARAMETRU%TYPE;

  begin


    select n.hodnota_parametru into xnavrat
     from eva_nastaveni n, eva_parametry p, eva_typ_dotazniku td,
     eva_dotazniky d
     where p.zkr = p_parametr
    and p.paraidno = n.paraidno
     and n.tydoidno = td.tydoidno
     and td.tydoidno  = d.tydoidno
     and d.dotaidno = p_dotaidno;

     return(xnavrat);

     exception
       when others then
         return  null;
  end;

function get_respidno(p_dotaidno NUMBER, p_username VARCHAR2)
  return number
  is


  cursor c_respidno(p_os_cislo IN VARCHAR2) is
   select respidno
      from eva_respondenti
     where username = p_os_cislo
     and dotaidno = p_dotaidno;


 /* kursor, pokud nema zadane os_cislo zaznam v estudenti_v_roce, zkusi najit predchozi os_cislo pred navazujicim studiem */
 cursor c_os_cislo(p_dotaznik IN NUMBER, p_os_cislo IN VARCHAR2)
 is
  select
  os_cislo
from
(select
  os_cislo,1  poradi
from
  studenti_v_roce sr,
  eva_dotazniky dot
where
 dot.dotaidno = p_dotaznik
 and sr.rok_platnosti = dot.skolni_rok
 and sr.os_cislo = p_os_cislo
 union
 select
  s2.os_cislo,2
  from
    studenti s1,
    studenti s2,
    studijni_programy sp1,
    studijni_programy sp2,
    eva_dotazniky dot,
    studenti_v_roce sr
where
s1.os_cislo = p_os_cislo
and s2.osobidno  = s1.osobidno
and sp1.stpridno = s1.stpridno
and s2.absolvent = 'A'
and sp1.navazujici = 'A'
and sp2.stpridno  = s2.stpridno
and sp2.fakulta_sp = sp1.fakulta_sp
and dot.dotaidno = p_dotaznik
and sr.rok_platnosti = dot.skolni_rok
and sr.os_cislo = s2.os_cislo
order by poradi)
where rownum =1;

  xrespidno number;
  os_cislo_resp eva_respondenti.username%TYPE;

  begin

     lock table eva_respondenti
     IN  EXCLUSIVE  MODE ;

    xrespidno := -1;

    open c_os_cislo(p_dotaidno, p_username);
    fetch c_os_cislo into os_cislo_resp;
    close c_os_cislo;

    if os_cislo_resp is not null then



     open c_respidno(os_cislo_resp);
     fetch c_respidno into xrespidno;

     if c_respidno%notfound then
       begin
         insert into eva_respondenti(dotaidno, username)
         values(p_dotaidno, os_cislo_resp)   returning respidno into xrespidno;
       exception
          when OTHERS  -- predelat na pojmenovanou exception
           then xrespidno := -1;
       end;
     end if;

     close c_respidno;
    end if;

    commit; --(unlock)

    return(xrespidno);

/*     exception
       WHEN  others  then
        return SQLCODE; */
  end;


 function get_odpovedi(p_saodidno NUMBER, volby VARCHAR2 default null)
 return  varchar2
 IS


   c_odpovedi ref_c; -- referenci kursor
   stmt VARCHAR2(1024);
   odpovedi VARCHAR2(4000);

   zaznam EVA_ODPOVEDI%ROWTYPE;

 BEGIN
    odpovedi :=' ';

    stmt := 'select *
             from eva_odpovedi o
          where o.saodidno = :saodidno
            and o.platnost = ''A''
           order by poradi';

      OPEN c_odpovedi for stmt using p_saodidno;
      FETCH c_odpovedi into zaznam;
      LOOP
         EXIT WHEN c_odpovedi%NOTFOUND ;
         if volby = 'idno' then
           odpovedi := odpovedi
           || zaznam.odpoidno ||'###';
         else
            odpovedi := odpovedi || zaznam.hodnota ||'###';
         end if;
         FETCH c_odpovedi into zaznam;
      END LOOP;
      CLOSE C_ODPOVEDI;

       return substr(odpovedi,1,length(odpovedi)-3);
     exception
        WHEN  others  then
         return SQLERRM;
 END;

 function update_odpovedi(p_respidno NUMBER, p_reobidno NUMBER,a_data eva_tvrzodp_tab,
                         p_pripominka VARCHAR2, p_anonymni VARCHAR2)
  return varchar2

  is

  chyba VARCHAR2(1024) := '';
  xodreidno  number;
  respidno_db number;
  podvod exception;

  pragma EXCEPTION_INIT(podvod,-20901);

  begin

  /* kontrola na podstrcena reobidna  */
  select respidno into respidno_db from eva_resp_objekt
    where reobidno = p_reobidno;

  if respidno_db <>  p_respidno then
    raise podvod ;
  end if;

  /* update odpovedi */
  if a_data.first is not null then  -- je alespon jedna odpoved

   for i in a_data.first .. a_data.last
     loop
      begin
       update EVA_ODPOVEDI_RESP
           set odpoidno = a_data(i).odpoidno,
               text_odpoved = a_data(i).text_odpoved
         where reobidno = p_reobidno
           and (tdtvidno = a_data(i).tdtvidno
              or (tdtvidno is null and a_data(i).tdtvidno is null))
           and (doutidno = a_data(i).doutidno
              or (doutidno is null and a_data(i).doutidno is null))
           and (ucitidno = a_data(i).ucitidno
              or (ucitidno is null and a_data(i).ucitidno is null))

    ;
    exception
      when others then
        -- zjistit odreidno
        select odreidno into xodreidno from eva_odpovedi_resp
         where reobidno = p_reobidno
           and (tdtvidno = a_data(i).tdtvidno
              or (tdtvidno is null and a_data(i).tdtvidno is null))
           and (doutidno = a_data(i).doutidno
              or (doutidno is null and a_data(i).doutidno is null))
           and (ucitidno = a_data(i).ucitidno
              or (ucitidno is null and a_data(i).ucitidno is null));

        chyba := to_char(xodreidno)||';';

        end;

    end loop;
   end if;

    /* update pripominky */
    if pg_eva.get_ma_prip_obj(p_reobidno) = 0 then
     begin
      update eva_resp_objekt
      set pripominka = p_pripominka,
          anonymni_prip = p_anonymni
      where reobidno = p_reobidno;

      EXCEPTION
        when others then
        chyba:='failed;';
     end;

    end if;

  return trim(chyba);

   /*exception
    when others then
      return SQLCODE;*/

  end;

 function update_pripominka_sem(p_respidno NUMBER,  p_prip_sem VARCHAR2)
  return number
  is
  xnavrat number;
  begin
   /* kontrolu presunout do triggeru !!! */
   xnavrat := pg_eva.get_ma_prip_celk(p_respidno,'SEM'); -- muze updatovat, pokud jeste na prip neodpovedel tzn. kdyz vrati 0

   if xnavrat  = 0 then

       update eva_respondenti
          set pripominka_sem =  p_prip_sem
        where respidno = p_respidno;

   end if;

   return xnavrat;

   exception
     when others then
       return 2;

  end;

  function update_pripominka_tech(p_respidno NUMBER, p_prip_tech VARCHAR2)
  return number
  is

  xnavrat number;
  begin

   /* kontrolu presunout do triggeru !!! */
   xnavrat := pg_eva.get_ma_prip_celk(p_respidno,'TECH'); -- muze updatovat, pokud jeste na prip neodpovedel tzn. kdyz vrati 0

   if xnavrat  = 0 then

       update eva_respondenti
          set pripominka_tech =  p_prip_tech
        where respidno = p_respidno;

   end if;

   return xnavrat;

   exception
     when others then
       return 2;

  end;

  function get_ma_prip_obj(p_reobidno NUMBER)
  return number
  is

  cursor c_vyp_prip
  is
  select count(*)
from   eva_resp_objekt ro,
       eva_respondenti re,
       eva_vyp_prip_obj vpo
where ro.reobidno = p_reobidno
  and re.respidno = ro.respidno
  and vpo.username = re.username
  and nvl(vpo.mel_prip_obj,'N') = 'A'
  and ( (ro.sluzidno is not null
      and vpo.sluzidno = ro.sluzidno)
    or  (vpo.prac_zkr = ro.prac_zkr
      and vpo.zkr_predm = ro.zkr_predm
      and vpo.rok_varianty = ro.rok_varianty
      )
    );

  xnavrat NUMBER;


  begin

    open c_vyp_prip;
    fetch c_vyp_prip into xnavrat;
    close c_vyp_prip;

    return xnavrat;
  end;

  function get_ma_prip_celk(p_respidno NUMBER, p_typ_prip VARCHAR2)
  return number
  -- navrat 0 - nema vyplneno, 1 - ma vyplneno, typ_prip - SEM, TECH
  is

  cursor c_vyp_prip
  is
  select count(*)
   from eva_respondenti re,
        eva_vyp_celk vypc
  where re.respidno  = p_respidno
    and vypc.username = re.username
    and vypc.dotaidno = re.dotaidno
    and( (p_typ_prip = 'SEM'
    and nvl(vypc.mel_prip_sem,'N') = 'A')
     or (p_typ_prip = 'TECH'
    and nvl(vypc.mel_prip_tech,'N') = 'A')
    );

  xnavrat number;

  BEGIN

    open c_vyp_prip;
    fetch c_vyp_prip into xnavrat;
    close c_vyp_prip;

    return xnavrat;

  end;

  /*function get_ma_prip_celk(p_username VARCHAR, p_dotaidno NUMBER,  p_typ_prip VARCHAR2)
  return number -- navrat 0 - nema vyplneno, 1 - ma vyplneno, typ_prip - SEM, TECH
  IS
  -- pouziva trigger tr_e2re_bru
   cursor c_vyp_prip
  is
  select count(*)
   from  eva_vyp_prip_celk vypc
  where vypc.username = p_username
    and vypc.dotaidno = p_dotaidno
    and( (p_typ_prip = 'SEM'
    and nvl(vypc.mel_prip_sem,'N') = 'A')
     or (p_typ_prip = 'TECH'
    and nvl(vypc.mel_prip_tech,'N') = 'A')
    );

  xnavrat number;

  BEGIN

    open c_vyp_prip;
     fetch c_vyp_prip into xnavrat;
    close c_vyp_prip;

    return xnavrat;

  END;
    */
  function close_dotaznik(p_respidno NUMBER)
    return number -- 0 uzavreni OK
    is

   begin

     update EVA_RESPONDENTI
     set username = null
     where respidno = p_respidno;

     if SQL%ROWCOUNT = 1 then
      return 0;
     end if;

     return -1;

     exception
       when others then
         return(SQLCODE);

    end;


function get_text_tvrzeni(p_tdtvidno NUMBER , p_doutidno NUMBER)
   RETURN VARCHAR2
   is

   navrat eva_sady_tvrzeni.text_tvrzeni%TYPE;

   BEGIN

     if p_doutidno is NOT NULL THEN

       select st.text_tvrzeni into navrat
         from eva_dot_ucitel_tvrz du,
              eva_sady_tvrzeni st
        where du.doutidno  = p_doutidno
          and st.satvidno = du.satvidno;

     end if;

     if p_tdtvidno is not NULL THEN

        select st.text_tvrzeni into navrat
         from eva_typdot_tvrzeni tt,
              eva_sady_tvrzeni st
        where tt.tdtvidno  = p_tdtvidno
          and st.satvidno = tt.satvidno;

     end if;

     return navrat;

   end;

function  get_merged_reakce(p_vetoidno NUMBER, p_reobidno NUMBER, p_pripidno NUMBER)
   return clob
is
   reakce clob;

    cursor c_reakce is
      select
            er.KOMENTAR,
            er.role,
            fn_get_ucitel(er.UCITIDNO,'JP','A') as ucitel
        from
            eva_reakce er
        where
          p_pripidno is not null
        and er.pripidno = p_pripidno
        or p_reobidno is not null
        and er.reobidno = p_reobidno
        or p_pripidno is not null
        and pripidno = p_pripidno
        order by date_of_update;

BEGIN
        reakce := empty_clob();
        FOR reak in c_reakce
        LOOP
            reakce := reakce || reak.ucitel ||'\n'||reak.komentar || '\n';
        END LOOP;


 RETURN reakce;
end;

function get_role_predmet(p_ucitidno number, p_dopridno NUMBER)
 return varchar2
 is


 rc_role ref_c;

 xrole VARCHAR2(2); -- navratova hodnota

 tmp_hodnota EVA_ROLE_PRISTUP.HODNOTA%TYPE;
 tmp_number NUMBER;


 begin

   /* zjisteni z CIS_PRACOVISR a z EVA_ROLE->EVA_ROLE_PRISTUP */

   /* prorektor (pouze z EVA_ROLE) -- pristup ke vsem predmetum  */
   OPEN rc_role for
   'select
     erp.hodnota
    from
      eva_role erl,
      eva_role_pristup erp
    where
      erl.ucitidno = :p_ucitidno
      and erl.role_uzivatele = ''PROREKTOR''
      and erp.uzroidno =  erl.uzroidno' using p_ucitidno;

    fetch rc_role into tmp_hodnota;
    close rc_role;

    if tmp_hodnota = 'REK' then
      return 'PR';
    end if;

   /* dekan, vratit fakultu  */

  open rc_role for
    'select dp.dopridno
from
   (select cp.zkr
from
   cg_ref_codes cg,
   cis_pracovist cp
where cg.rv_domain = ''FAKULTA''
and cg.rv_abbreviation = cp.zkr
and cp.ucitidno = :p_ucitidno
and cp.typ_prac = ''F''
union
select erp.hodnota
from eva_role erl,
    eva_role_pristup erp
where erl.ucitidno = :p_ucitidno
and erl.role_uzivatele = ''DEKAN''
and erp.uzroidno =  erl.uzroidno)X,
   eva_dot_predmet dp,
   cis_pracovist cp1  -- fakulta predmetu
where
 dp.dopridno = :p_dopridno
and dp.prac_zkr  = cp1.zkr
and (cp1.zkr = x.zkr
    or cp1.nad_prac_zkr = x.zkr
    or EXISTS
    (select stpr.FAKULTA_SP from  BLOKY_PREDM blpr,
         BLOKY blok,
         SEGMENTY_ST_PLANU sesp,
         PORADI_SEGMENTU pose,
         STUDIJNI_PLANY stpl,
         OBORY obor,
         STUDIJNI_PROGRAMY stpr
      where  blpr.PRAC_ZKR = dp.PRAC_ZKR
        AND  blpr.ZKR_PREDM =  dp.ZKR_PREDM
        AND  blpr.ROK_VARIANTY = dp.ROK_VARIANTY
        AND blpr.BLOKIDNO = blok.BLOKIDNO
        AND blok.SESPIDNO = sesp.SESPIDNO
        AND sesp.SESPIDNO = pose.SESPIDNO
        AND pose.STPLIDNO = stpl.STPLIDNO
        AND stpl.OBORIDNO = obor.OBORIDNO
     -- obor = stpr
        AND obor.STPRIDNO = stpr.STPRIDNO
        AND stpr.FAKULTA_SP = x.ZKR)
    )' using p_ucitidno, p_ucitidno, p_dopridno;

    fetch rc_role into tmp_number;
    close rc_role;

    if tmp_number is not null then
      return('DE');
    end if;

   /* vedouci katedry */
     open rc_role for '
      select
        dopridno
      from
        (select cp.zkr
        from cis_pracovist cp
        where cp.ucitidno = :p_ucitidno
        and cp.typ_prac = ''K''
        union
        select
          erp.hodnota
        from
          eva_role erl,
          eva_role_pristup erp
        where
          erl.ucitidno = :p_ucitidno
          and erl.role_uzivatele = ''VEDOUCI_KATEDRY''
          and erp.uzroidno =  erl.uzroidno) x,
          eva_dot_predmet dp
      where
        dp.dopridno = :p_dopridno
        and dp.prac_zkr = x.zkr' using p_ucitidno, p_ucitidno, p_dopridno;

    fetch rc_role into tmp_number;
    close rc_role;

    if tmp_number is not null then
      return('VK');
    end if;

   /* garant */

  open rc_role for '
  select
    dp.dopridno
  from
  eva_dot_predmet dp,
  ucitele_predmetu up
where
 dp.dopridno = :p_dopridno
 and up.prac_zkr = dp.prac_zkr
 and up.zkr_predm = dp.zkr_predm
 and up.rok_varianty  = dp.rok_varianty
 and up.ucitidno = :p_ucitidno
 and up.garant = ''A'' ' using  p_dopridno, p_ucitidno;

  fetch rc_role into tmp_number;
  close rc_role;

  if tmp_number is not null then
    return('GA');
  end if;

   /* zadna role */
   return null;

end;


 function get_nejvyssi_vetovano(p_dopridno NUMBER, p_reobidno number, p_pripidno number,p_roak VARCHAR2)
 return varchar2
 is

 cursor  c_vetovano is
 select
  vetovano
 from
  eva_reakce
where
  (dopridno = p_dopridno
  or reobidno = p_reobidno
  or pripidno = p_pripidno )
  and (p_roak is not null and roakidno = p_roak
       or roakidno is null)
order by decode(role,'PR',1,'DE',2,'VK','3','GA',4,'VY',5);

xhodnota VARCHAR2(1);

begin

 open c_vetovano;
 fetch c_vetovano into xhodnota;
 close c_vetovano;

 return xhodnota;

end;

function ma_hledanou_prip(key_words VARCHAR2, p_dopridno number)
return number
is

xslovatemp VARCHAR2(4000);
xkeywords  VARCHAR2(4000);


rc_pripominky ref_c;

xindex number;
tmp_reobidno number;

xdotaz varchar2(4000);
begin

 /* zpracovani vstupniho retezce */
    xslovatemp := trim(key_words);
	 if (length(xslovatemp) is not null) then  -- bude alespon jedno slovo
     xkeywords := ' and (';
   loop
      xindex :=  instr(xslovatemp,' ');
		  if(xindex > 0) then
 		 	  xkeywords := xkeywords || ' instr(lower(ro.PRIPOMINKA,'''||lower(substr(xslovatemp,1,xindex-1))||''')<>0';
			       xslovatemp := trim(substr(xslovatemp,xindex));
       else
 	       xkeywords := xkeywords || ' instr(lower(ro.PRIPOMINKA),'''||lower(substr(xslovatemp,1,length(xslovatemp)))||''')<>0';
			   exit;   -- opustit smycku
      end if;
		  xkeywords := xkeywords ||' or';  -- bude nasledovat dalsi slovo
    end loop;  -- kriteria  vyhledavani
	     xkeywords := xkeywords || ')';
	 end if;


    xdotaz:= '
    select
      dp.dopridno
    from
      eva_dotazniky dot,
      eva_dot_predmet dp,
      eva_respondenti re,
      eva_resp_objekt ro
    where
      dp.dopridno = :dopridno
      and dot.dotaidno = dp.dotaidno
      and re.username is null
      and re.dotaidno = dot.dotaidno
      and ro.respidno = re.respidno
      and ro.prac_zkr = dp.prac_zkr
      and ro.zkr_predm = dp.zkr_predm
      and ro.rok_varianty = dp.rok_varianty
      and ro.pripominka is not null ' || xkeywords ||
      'union
    select
      dp.dopridno
    from
      eva_dotazniky dot,
      eva_dot_predmet dp,
      eva_pripominky ro
    where
      dp.dopridno = :dopridno
      and dot.dotaidno = dp.dotaidno
      and ro.dotaidno = dot.dotaidno
      and ro.prac_zkr = dp.prac_zkr
      and ro.zkr_predm = dp.zkr_predm
      and ro.rok_varianty = dp.rok_varianty ' || xkeywords;

open rc_pripominky for xdotaz using p_dopridno, p_dopridno;
fetch  rc_pripominky into  tmp_reobidno;
close rc_pripominky;

return  tmp_reobidno;
end;

procedure pr_get_role(p_ucitidno in NUMBER, out_role OUT VARCHAR2, out_fakulta OUT VARCHAR2, out_katedra OUT VARCHAR2)
is

rc_role ref_c;
tmp_prac EVA_ROLE_PRISTUP.HODNOTA%TYPE;
p_role EVA_ROLE.ROLE_UZIVATELE%TYPE;

begin

       out_role := null;
       out_fakulta := null;
       out_katedra := null;

  /* zjisteni REKTORA -- pouze z eva_role_pristup */
   p_role := 'PROREKTOR';

    open rc_role for
      'select
        erp.hodnota
       from
        eva_role erl,
        eva_role_pristup erp
      where
        erl.ucitidno = :p_ucitidno
        and erl.role_uzivatele = :p_role
        and erp.uzroidno =  erl.uzroidno' using p_ucitidno, p_role ;

     fetch rc_role into tmp_prac;
     close rc_role;

     if tmp_prac is not null then
       out_role := 'PR';
       return;
     end if;

     /* zjisteni dekana - z cis_pracovist, z EVA_ROLE_PRISTUP */
     p_role := 'DEKAN';

     open rc_role for
      'select
        cp.zkr
       from
        cg_ref_codes cg,
        cis_pracovist cp
       where
        cg.rv_domain = ''FAKULTA''
        and cg.rv_abbreviation = cp.zkr
        and cp.ucitidno = :p_ucitidno
        and cp.typ_prac = ''F''
       union
       select
        erp.hodnota
       from eva_role erl,
        eva_role_pristup erp
       where erl.ucitidno = :p_ucitidno
       and erl.role_uzivatele = :p_role
       and erp.uzroidno =  erl.uzroidno'
       using p_ucitidno, p_ucitidno, p_role;

     fetch rc_role into tmp_prac;
     close rc_role;

     if tmp_prac is not null then
       out_role := 'DE';
       out_fakulta := tmp_prac;
       return;
     end if;

 /*zjisteni ved. katedry  */
    p_role:= 'VEDOUCI_KATEDRY';

    open rc_role for '
      select cp.zkr
        from cis_pracovist cp
        where cp.ucitidno = :p_ucitidno
        and cp.typ_prac = ''K''
      union
      select
        erp.hodnota
      from
        eva_role erl,
        eva_role_pristup erp
      where
        erl.ucitidno = :p_ucitidno
        and erl.role_uzivatele = :p_role
        and erp.uzroidno =  erl.uzroidno'
        using p_ucitidno, p_ucitidno, p_role;

     fetch rc_role into tmp_prac;
     close rc_role;

     if tmp_prac is not null then
       out_role := 'VK';
       out_katedra := tmp_prac;
       return;
     end if;

end;

function get_vyucujici_predm(p_dotaidno IN NUMBER, p_prac_zkr IN VARCHAR2, p_zkr_predm IN VARCHAR2, p_rok_varianty IN VARCHAR2)
return VARCHAR2 IS

  cursor c_vyucujici  is
 select distinct
  fn_get_ucitel(nvl(up.ucitidno, ra.ucitidno), 'JP','N') ucitel,
  up.ga,
  nvl(up.pr,ra.pr) pr,
  nvl(up.se,ra.se) se,
  nvl(up.cv,ra.cv) cv
from
(select
  up.ucitidno  ,
   decode(up.garant,'A','Ga') ga,
   decode(up.prednasejici, 'A','P') pr,
   decode(up.seminarici, 'A','Se') se,
   decode(up.cvicici,'A','Cv') cv
from ucitele_predmetu up
where up.prac_zkr = p_prac_zkr
and up.zkr_predm = p_zkr_predm
and up.rok_varianty = p_rok_varianty ) up
full outer join (
select distinct coalesce(p.ucitidno, cv.ucitidno, se.ucitidno) ucitidno,
  p.pr, cv.cv, se.se
from
  (select
    ra.ucitidno
    ,ra.typakce  pr
  from
    rozvrh_akce ra,
    eva_dotazniky dot
  where ra.prac_zkr = p_prac_zkr
  and ra.zkr_predm = p_zkr_predm
  and ra.rok_varianty = p_rok_varianty
  and ra.platnost = 'A'
  and dot.dotaidno = p_dotaidno
  and ra.rok_platnosti = dot.skolni_rok
  and ra.semestr  = dot.semestr
  and ra.typakce = 'P'
  and ra.ucitidno is not null)p
full outer join
  (select
    ra.ucitidno
    ,ra.typakce  cv
  from
    rozvrh_akce ra,
    eva_dotazniky dot
  where ra.prac_zkr = p_prac_zkr
  and ra.zkr_predm = p_zkr_predm
  and ra.rok_varianty = p_rok_varianty
  and ra.platnost = 'A'
  and dot.dotaidno = p_dotaidno
  and ra.rok_platnosti = dot.skolni_rok
  and ra.semestr  = dot.semestr
  and ra.typakce = 'Cv'
  and ra.ucitidno is not null)cv
on (p.ucitidno = cv.ucitidno)
full outer join
  (select
    ra.ucitidno
    ,ra.typakce  se
  from
    rozvrh_akce ra,
    eva_dotazniky dot
  where ra.prac_zkr = p_prac_zkr
  and ra.zkr_predm = p_zkr_predm
  and ra.rok_varianty = p_rok_varianty
  and ra.platnost = 'A'
  and dot.dotaidno = p_dotaidno
  and ra.rok_platnosti = dot.skolni_rok
  and ra.semestr  = dot.semestr
  and ra.typakce = 'Se'
  and ra.ucitidno is not null) se
on (se.ucitidno = cv.ucitidno)) ra
 on (ra.ucitidno = up.ucitidno)
order by  ga,pr,se,cv
;

  navrat VARCHAR2(4000);
  tmp_len number;

  begin

    navrat := '';

  for v in c_vyucujici  loop

    navrat := navrat || v.ucitel||'('||v.ga;

    if v.ga is not null THEN
      navrat := navrat || ', ';
    end if;

    navrat := navrat ||v.pr;

    if v.pr is not null THEN
      navrat := navrat || ', ';
    end if;

    navrat := navrat ||v.se;

    if v.se is not null THEN
      navrat := navrat || ', ';
    end if;

    navrat := navrat ||v.cv;

    if v.cv is null THEN
      tmp_len := length(navrat);
      navrat :=substr(navrat,1,tmp_len-2);
    end if;

    navrat := navrat || '), ';

  end loop;
/* odebrat 2 znaky z konce */
      tmp_len := length(navrat);
      navrat :=substr(navrat,1,tmp_len-2);
  return(navrat);
end;

function get_rozvrh_akce(p_pripidno IN NUMBER, p_reobidno IN NUMBER)
return VARCHAR2
IS

xnavrat VARCHAR2(4000);

begin
/* vstup reobidno, pripidno, vystup ra - typ, mistnost, cas, ucitel(e) */

for x in (
select
  distinct
    ra.typakce||' '||
    ra.zkr_budovy||'_'||
    ra.cislo_mist||', '||
    ra.den||' '||
    ra.hod_vyuc_od||'-'||
    ra.hod_vyuc_do||', '||
    fn_get_ucitel(ra.ucitidno,'JP','N') ra,
    ra.hod_vyuc_od,
    fn_meaning3(ra.den,'DEN') den
from
  eva_rozvrh_akce era,
  rozvrh_akce ra
where
  (era.pripidno = p_pripidno
  and era.reobidno is null
   or era.reobidno = p_reobidno
   and era.pripidno is null)
  and ra.roakidno = era.roakidno
  order by den,ra.hod_vyuc_od
 ) loop
   xnavrat := xnavrat || x.ra||';';
 end loop;

 return (xnavrat);

end;

/*function  copy_anketa(p_vzor EVA_TYP_DOTAZNIKU.TYDOIDNO%TYPE, p_zkr EVA_TYP_DOTAZNIKU.ZKR%TYPE)
return number*/
procedure  copy_anketa(p_vzor EVA_TYP_DOTAZNIKU.TYDOIDNO%TYPE, p_zkr EVA_TYP_DOTAZNIKU.ZKR%TYPE)
IS

new_tydoidno eva_typ_dotazniku.tydoidno%type;
new_tdtvidno eva_typdot_tvrzeni.tdtvidno%type;

begin


/* vlozeni do eva_typ_dotanziku */
  for d in (select p_zkr, td.platnost, td.pocet_vol_tvrz, td.popis, td.rozsah_resp from eva_typ_dotazniku td
  where td.tydoidno = p_vzor) loop
    insert into eva_typ_dotazniku(zkr, platnost, pocet_vol_tvrz, popis, rozsah_resp )
    values(p_zkr, d.platnost, d.pocet_vol_tvrz, d.popis, d.rozsah_resp)  returning tydoidno into new_tydoidno;
  end loop;


  /* ulozeni eva_typdot_sluzby  a eva_typdot_tvrzeni pro sluzby */
  for s in (select
                tt.satvidno,
                tt.saodidno,
                tt.poradi,
                tt.vaha,
                ts.sluzidno
              from
                eva_typdot_sluzby ts,
                eva_typdot_tvrzeni tt
             where tt.tydoidno = p_vzor
                and  ts.tdtvidno = tt.tdtvidno) loop

    insert into eva_typdot_tvrzeni (tydoidno, satvidno, saodidno, poradi, vaha )
    values  (new_tydoidno, s.satvidno, s.saodidno, s.poradi, s.vaha) returning tdtvidno into new_tdtvidno;

    insert into eva_typdot_sluzby (tdtvidno, sluzidno) values (new_tdtvidno, s.sluzidno);

  end loop;


  /* ulozeni typdot_tvrzeni pro predmety  */
  insert into eva_typdot_tvrzeni (tydoidno, satvidno, saodidno, poradi, vaha )
  select new_tydoidno, tt.satvidno, tt.saodidno, tt.poradi, tt.vaha
  from eva_typdot_tvrzeni tt
  where tt.tydoidno = p_vzor
  and not exists (select * from eva_typdot_sluzby ts where ts.tdtvidno = tt.tdtvidno);

  /* ulozeni omezeni tvrzeni */
  insert into eva_omezeni_tvrzeni (tydoidno, satvidno)
  select new_tydoidno, ot.satvidno FROM eva_omezeni_tvrzeni ot where ot.tydoidno = p_vzor;

  /* ulozeni zahlavi */
  insert into eva_zahlavi(tydoidno, poradi, ukladat, zapoidno)
  select new_tydoidno, za.poradi, za.ukladat, za.zapoidno
  from eva_zahlavi za
  where za.tydoidno = p_vzor;

  /* ulozeni nastaveni parametru */
  insert into eva_nastaveni (tydoidno, paraidno, hodnota_parametru)
  select new_tydoidno, na.paraidno, na.hodnota_parametru
  from eva_nastaveni na
  where na.tydoidno = p_vzor;

  /* ulozeni omezeni_resp */
  insert into eva_omezeni_resp(tydoidno, zapoidno, hodnota_polozky)
  select new_tydoidno, om.zapoidno, om.hodnota_polozky
  from eva_omezeni_resp om
  where om.tydoidno = p_vzor;


  commit;

  --return new_tydoidno;

end;
function  cp_anketa(p_vzor EVA_TYP_DOTAZNIKU.TYDOIDNO%TYPE)
return number
IS

new_tydoidno eva_typ_dotazniku.tydoidno%type;
new_tdtvidno eva_typdot_tvrzeni.tdtvidno%type;
p_zkr  EVA_TYP_DOTAZNIKU.ZKR%TYPE;

begin

  select  zkr into p_zkr from eva_typ_dotazniku where tydoidno = p_vzor;
  p_zkr := substr('Kopie '||p_zkr,1,20);
/* vlozeni do eva_typ_dotanziku */

  for d in (select p_zkr, td.platnost, td.pocet_vol_tvrz, td.popis, td.rozsah_resp from eva_typ_dotazniku td
  where td.tydoidno = p_vzor) loop
    insert into eva_typ_dotazniku(zkr, platnost, pocet_vol_tvrz, popis, rozsah_resp )
    values(p_zkr, d.platnost, d.pocet_vol_tvrz, d.popis, d.rozsah_resp)  returning tydoidno into new_tydoidno;
  end loop;


  /* ulozeni eva_typdot_sluzby  a eva_typdot_tvrzeni pro sluzby */
  for s in (select
     tt.satvidno,
     tt.saodidno,
     tt.poradi,
     tt.vaha,
     tt.tdtvidno
  from
     eva_typdot_tvrzeni tt
 where
  tt.tydoidno = p_vzor
  and  exists (select * from eva_typdot_sluzby ts where ts.tdtvidno = tt.tdtvidno)) loop

    insert into eva_typdot_tvrzeni (tydoidno, satvidno, saodidno, poradi, vaha )
    values  (new_tydoidno, s.satvidno, s.saodidno, s.poradi, s.vaha) returning tdtvidno into new_tdtvidno;

    for t in (select ts.sluzidno from eva_typdot_sluzby ts where ts.tdtvidno = s.tdtvidno) loop
      insert into eva_typdot_sluzby (tdtvidno, sluzidno) values (new_tdtvidno, t.sluzidno);
    end loop;

  end loop;


  /* ulozeni typdot_tvrzeni pro predmety  */
  insert into eva_typdot_tvrzeni (tydoidno, satvidno, saodidno, poradi, vaha )
  select new_tydoidno, tt.satvidno, tt.saodidno, tt.poradi, tt.vaha
  from eva_typdot_tvrzeni tt
  where tt.tydoidno = p_vzor
  and not exists (select * from eva_typdot_sluzby ts where ts.tdtvidno = tt.tdtvidno);

  /* ulozeni omezeni tvrzeni */
  insert into eva_omezeni_tvrzeni (tydoidno, satvidno)
  select new_tydoidno, ot.satvidno FROM eva_omezeni_tvrzeni ot where ot.tydoidno = p_vzor;

  /* ulozeni zahlavi */
  insert into eva_zahlavi(tydoidno, poradi, ukladat, zapoidno)
  select new_tydoidno, za.poradi, za.ukladat, za.zapoidno
  from eva_zahlavi za
  where za.tydoidno = p_vzor;

  /* ulozeni nastaveni parametru */
  insert into eva_nastaveni (tydoidno, paraidno, hodnota_parametru)
  select new_tydoidno, na.paraidno, na.hodnota_parametru
  from eva_nastaveni na
  where na.tydoidno = p_vzor;

  /* ulozeni omezeni_resp */
  insert into eva_omezeni_resp(tydoidno, zapoidno, hodnota_polozky)
  select new_tydoidno, om.zapoidno, om.hodnota_polozky
  from eva_omezeni_resp om
  where om.tydoidno = p_vzor;


  commit;

 return new_tydoidno;

end;
/*
function ins_eva_role(p_ucitidno EVA_ROLE.UCITIDNO%TYPE, p_role EVA_ROLE.ROLE_UZIVATELE%TYPE)
return EVA_ROLE.UZROIDNO%TYPE
is

new_uzroidno eva_role.uzroidno%TYPE;

 begin

  insert into  eva_role(ucitidno, role_uzivatele)
  values (p_ucitidno, p_role) returning uzroidno into new_uzroidno;

  return new_uzroidno;

  exception
   when DUP_VAL_ON_INDEX then
     return(null);


 end;
*/
function fn_role_pristup(p_uzroidno eva_role_pristup.uzroidno%TYPE)
return varchar2
is
xhodnoty varchar2(1024);


begin

  for h in (select rp.hodnota from eva_role_pristup rp where rp.uzroidno = p_uzroidno order by rp.hodnota) loop
    xhodnoty := xhodnoty||' ,'||h.hodnota;
  end loop;

  return(substr(xhodnoty,3));

end;

function autoclose_dotazniku(p_dotaidno IN NUMBER)
return number
is
index_ukoncenych number := 0;
begin
-- execute immediate 'alter trigger TR_E2RE_AUS disable'; -- nepocitat statistiky

for x in (
select  re.respidno
from eva_respondenti re
where dotaidno = p_dotaidno
and re.username is not null
and (re.pripominka_sem is not null
 or re.pripominka_tech is not null
 or exists (select *
              from
                eva_resp_objekt ro
             where
              ro.respidno = re.respidno
              and (ro.pripominka is not null
              or exists(
                  select *
                     from
                      eva_odpovedi_resp odp,
                      eva_odpovedi so
                    where
                      odp.reobidno = ro.reobidno
                      and so.odpoidno = odp.odpoidno
                      and so.implicitni <> 'A'))
          )
      )

 )loop

  update eva_respondenti
   set username = null
   where respidno = x.respidno;

   index_ukoncenych := index_ukoncenych +1;
 end loop;

--execute IMMEDIATE 'alter trigger TR_E2RE_AUS enable'; -- nepocitat statistiky

/* prepocet statistik */
 return index_ukoncenych ; -- nevim jestli funguje

end;
procedure job_ukonceni
is


ukoncenych number;

m_from UCITELE.EMAIL%TYPE;
m_to varchar2(255);
m_subject  varchar2(255);

m_message EVA_DOTAZNIKY.TEXT_EMAILU%TYPE;

def_email parametry_stagu.hodnota_char%type;
xtmp number;

begin

 /* automaticke ukonceni rozpracovanych dotazniku */
  for d in (select
               dot.dotaidno
            from
              eva_dotazniky dot,
              eva_nastaveni na,
              eva_parametry pa
            where
              trunc(sysdate) =  trunc(dot.uzavreni + 1 )
              and na.tydoidno = dot.tydoidno
              and pa.paraidno = na.paraidno
              and pa.zkr = 'xautoodeslanidot'
              and nvl(na.hodnota_parametru,'N') = 'A') loop

    ukoncenych := autoclose_dotazniku(d.dotaidno);

  /*  if ukoncenych > 0 then
      -- update_statistik
    end; */

  end loop;

  /* automaticke odesilani emailu */
  for d in (select
          dot.dotaidno,
          dot.ucitidno,
          dot.text_emailu
        from
          eva_dotazniky dot,
          eva_omezeni_resp om,
          eva_polozky_zahlavi pz
        where
          pz.zkr = 'predmet'
          and om.zapoidno = pz.zapoidno
          and om.tydoidno = dot.tydoidno
          and hodnota_polozky = 'B'
          and trim(dot.text_emailu) is not null
          and trunc(dot.otevreni) - trunc(sysdate) - dot.predstih = 0) loop

          begin
            select hodnota_char into def_email from parametry_stagu where nazev = 'EMAIL';

            exception
              when NO_DATA_FOUND  then
                def_email := null;
           end;



          begin
            select email into m_from from ucitele where ucitidno = d.ucitidno;
            exception
              when others  then
                m_from := def_email;
           end;


          m_subject := 'Kvalita vuky';
          m_message :=  d.text_emailu;


          begin

          pr_posli_email (def_email,m_from, 'Byl rozesln nsledujc email studentm.', m_message);


          for m in (SELECT  sp.os_cislo,
                            (select FN_EMAIL_STUDENTA(sp.os_cislo) from dual)email
                              FROM
                                 znamky sp,
                                 eva_dotazniky dot,
                                 eva_dot_predmet dp
                           WHERE
                                dot.dotaidno = d.dotaidno
                             and dp.dotaidno =  dot.dotaidno
                             and sp.prac_zkr = dp.prac_zkr
                             and sp.zkr_predm = dp.zkr_predm
                             and sp.rok_varianty =  dp.rok_varianty
                             and sp.semestr = dot.semestr) loop


                    m_to := m.email;
                    pr_posli_email(m_from,m_to,m_subject,m_message);

           end loop;
        exception
             when others then null;
          end;

  end loop;
  /* update globalnich statistik */

  for d in (select
                dot.dotaidno
             from
              eva_dotazniky dot,
              eva_omezeni_resp om
            where
              trunc(sysdate) between trunc(dot.otevreni) and trunc(uzavreni+1)
              and dot.tydoidno = om.tydoidno
              and om.zapoidno = (select zapoidno from eva_polozky_zahlavi where zkr = 'predmet')
              and instr(om.hodnota_polozky,'A') > 0) loop

      xtmp := upd_eva_glob_stats(d.dotaidno);

    end loop;
   /* statistiky_objekt insert => muze trvat dlouhou dobu, proto v jobu
     podle date_of_insert, pokud = sysdate - 1, pokud exituje eva_sady_odpovedi => merge jinak insert */
     for d in (select
                dot.dotaidno
             from
              eva_dotazniky dot
            where
              trunc(sysdate-1) = trunc(dot.date_of_insert) ) loop

              select count(*) into xtmp
              from eva_statistiky_objekt
              where dotaidno = d.dotaidno;

              /* pokud uz jsou vyplneny, netreba panikarit v pg_dateva se merguje statistika, staci jen doplnit */
              if xtmp > 0 then
                xtmp := pg_eva.statistiky_merge(d.dotaidno);
              else
                 xtmp := pg_eva.statistiky_obj_insert(d.dotaidno);
              end if;
              /* kdyz chyba, posli email DOPLNIT !!! */
    end loop;

end;

function get_default_rok
return varchar2
is

xrok varchar2(4);

begin

  begin
    select max(skolni_rok) into xrok from eva_dotazniky;

    exception
      when others then xrok := to_char(sysdate,'RRRR');
   end;

  --return to_number(xrok);
  return xrok;
end;


function statistiky_update(p_dotaidno IN NUMBER)
return number
is

type datarec IS record(
   staoidno dbms_sql.number_table,
   tdtvidno dbms_sql.number_table,
   doutidno dbms_sql.number_table,
   pocet    dbms_sql.number_table,
   prumer dbms_sql.number_table,
   rozptyl dbms_sql.number_table,
   sikmost dbms_sql.number_table,
   spicatost dbms_sql.number_table,
   chyba dbms_sql.number_table,
   mutabilita dbms_sql.number_table
   );


l_record datarec;

cursor c_data(p_dotaidno in number) is
select x.staoidno,
       x.tdtvidno,
       x.doutidno,
       x.pocet_odpovedi,
       round(x.prumer,3) prumer,
       round(x.rozptyl,3) rozptyl,
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,3))/(x.pocet_odpovedi * power(x.odchylka,3 ) ),3) )sikmost,  -- u=sum_i(x_i-prumer)^3/(n*sigma^3)
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,4))/(x.pocet_odpovedi * power(x.odchylka,4))-3,3)) spicatost, --  u=sum_i(x_i-prumer)^4/(n*sigma^4) - 3
       decode(nvl(x.pocet_odpovedi,0),0,null,1,null,
          decode(nvl(sto1.studentu,0),0,null,
            decode(x.prumer,0,0,
			        round(100*(1-x.pocet_odpovedi/sto1.studentu)*x.rozptyl/power(x.prumer,2)/x.pocet_odpovedi,3))
                 )
              )   pom_vyb_chyba,
       decode(x.pocet_odpovedi,0,null, 1,null,round(100*(power(x.pocet_odpovedi,2) - z.sum_cetnosti)/(x.pocet_odpovedi * (x.pocet_odpovedi - 1)),3) )mutabilita
from
(select sto.staoidno,
       odp.tdtvidno,
       odp.doutidno,
       count(*) pocet_odpovedi,
       avg(so.bodovani) prumer,
       VARIANCE(so.bodovani) rozptyl,
       STDDEV(so.bodovani) odchylka
from eva_statistiky_objekt sto,
     eva_respondenti re,
     eva_resp_objekt ro,
     eva_odpovedi_resp odp,
     eva_odpovedi so
where sto.dotaidno = p_dotaidno
  and re.dotaidno = sto.dotaidno
  and re.username is NULL
  and ro.respidno = re.respidno
  and ro.prac_zkr = sto.prac_zkr
  AND ro.zkr_predm = sto.zkr_predm
  and ro.rok_varianty = sto.rok_varianty
  and (sto.statut_zapisu is null
         or ro.statut_zapisu = sto.statut_zapisu)
  AND odp.reobidno  = ro.reobidno
  and (odp.ucitidno is null and sto.ucitidno is null
         or odp.ucitidno = sto.ucitidno)
  AND (sto.roakidno is NULL
        or sto.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra where ra.reobidno = ro.reobidno and ra.pripidno is null and ra.roakidno = sto.roakidno)
        )
  AND   so.odpoidno = odp.odpoidno
  and nvl(so.textova_odpoved,'N') = 'N'
  and nvl(so.implicitni,'N') = 'N'
  GROUP BY sto.staoidno,
       odp.tdtvidno,
       odp.doutidno) X,
(select y.staoidno,
       y.tdtvidno,
       y.doutidno,
       sum(power(pocet,2)) sum_cetnosti
from
(select sto2.staoidno,
       odp2.tdtvidno,
       odp2.doutidno,
       so2.bodovani,
       count(*) pocet
from eva_statistiky_objekt sto2,
     eva_respondenti re2,
     eva_resp_objekt ro2,
     eva_odpovedi_resp odp2,
     eva_odpovedi so2
where sto2.dotaidno = p_dotaidno
  and re2.dotaidno = sto2.dotaidno
  and re2.username is NULL
  and ro2.respidno = re2.respidno
  and ro2.prac_zkr = sto2.prac_zkr
  AND ro2.zkr_predm = sto2.zkr_predm
  and ro2.rok_varianty = sto2.rok_varianty
  and (sto2.statut_zapisu is null
         or ro2.statut_zapisu = sto2.statut_zapisu)
  AND odp2.reobidno  = ro2.reobidno
  and (odp2.ucitidno is null and sto2.ucitidno is null
         or odp2.ucitidno = sto2.ucitidno)
  AND (sto2.roakidno is NULL
        or sto2.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra2 where ra2.reobidno = ro2.reobidno and ra2.roakidno = sto2.roakidno and ra2.pripidno is null)
        )
  and so2.odpoidno = odp2.odpoidno
  and nvl(so2.textova_odpoved,'N') = 'N'
  and nvl(so2.implicitni,'N') = 'N'
  GROUP BY sto2.staoidno,
       odp2.tdtvidno,
       odp2.doutidno,
       so2.bodovani)Y
group by y.staoidno,
       y.tdtvidno,
       y.doutidno)Z,
     eva_statistiky_objekt sto1,
     eva_respondenti re1,
     eva_resp_objekt ro1,
     eva_odpovedi_resp odp1,
     eva_odpovedi so1
 where sto1.staoidno = x.staoidno
  and z.staoidno  = x.staoidno
  and (z.tdtvidno is not null
        and  z.tdtvidno = x.tdtvidno
       or z.doutidno is not null
       and z.doutidno = x.doutidno)
  and  re1.dotaidno = sto1.dotaidno
  and re1.username is NULL
  and ro1.respidno = re1.respidno
  and ro1.prac_zkr = sto1.prac_zkr
  AND ro1.zkr_predm = sto1.zkr_predm
  and ro1.rok_varianty = sto1.rok_varianty
  and ( sto1.statut_zapisu is null
         or ro1.statut_zapisu = sto1.statut_zapisu)
  AND odp1.reobidno  = ro1.reobidno
  and (odp1.tdtvidno is not null
       and odp1.tdtvidno = x.tdtvidno
       or odp1.doutidno is not null
         and odp1.doutidno = x.doutidno)
  and (odp1.ucitidno is null and sto1.ucitidno is null
         or odp1.ucitidno = sto1.ucitidno)
  AND (sto1.roakidno is NULL
        or sto1.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra1 where ra1.reobidno = ro1.reobidno and ra1.roakidno = sto1.roakidno and ra1.pripidno is null)
        )
   and so1.odpoidno = odp1.odpoidno
  and nvl(so1.textova_odpoved,'N') = 'N'
  and nvl(so1.implicitni,'N') = 'N'
  group by x.staoidno,
           sto1.studentu,
       x.tdtvidno,
       x.doutidno,
       x.pocet_odpovedi,
       x.prumer,
       x.rozptyl,
       x.odchylka,
       z.sum_cetnosti
       ;

begin

merge into eva_statistiky_objekt s
using(  SELECT  -- roak, status
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      ra.roakidno,
      ro.statut_zapisu,
      count(distinct ro.reobidno) pocet
     FROM
      eva_respondenti re,
      eva_resp_objekt ro,
      eva_rozvrh_akce ra
    where
      re.dotaidno  = p_dotaidno
      and re.username is null
      and ro.respidno = re.respidno
      and ra.reobidno = ro.reobidno
    group by
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      ro.statut_zapisu,
      ra.roakidno
  union
       SELECT  -- roak, null
         re.dotaidno,
         ro.prac_zkr,
         ro.zkr_predm,
         ro.rok_varianty,
         ra.roakidno,
         null statut,
         count (distinct ro.reobidno) pocet
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_rozvrh_akce ra
      where
        re.dotaidno  = p_dotaidno
        and re.username is null
        and ro.respidno = re.respidno
        and ra.reobidno = ro.reobidno
      group by
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty,
        ra.roakidno
     UNION
     SELECT  -- null, statut
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      null roakidno,
      ro.statut_zapisu,
      count(distinct ro.reobidno) pocet
     FROM
      eva_respondenti re,
      eva_resp_objekt ro,
      eva_dot_predmet dp
    where
      re.dotaidno  = p_dotaidno
      and re.username is null
      and ro.respidno = re.respidno
      and dp.dotaidno = re.dotaidno
      and dp.prac_zkr = ro.prac_zkr
      and dp.zkr_predm = ro. zkr_predm
      and dp.rok_varianty = ro.rok_varianty
    group by
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      ro.statut_zapisu
 union
      SELECT  -- null, null
         re.dotaidno,
         ro.prac_zkr,
         ro.zkr_predm,
         ro.rok_varianty,
         null roakidno,
         null statut,
         count (distinct ro.reobidno) pocet
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_dot_predmet dp
      where
        re.dotaidno  = p_dotaidno
        and re.username is null
        and ro.respidno = re.respidno
        and dp.dotaidno = re.dotaidno
        and dp.prac_zkr = ro.prac_zkr
        and dp.zkr_predm = ro. zkr_predm
        and dp.rok_varianty = ro.rok_varianty
      group by
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty   ) y
    ON
    (s.prac_zkr = y.prac_zkr
    and      s.zkr_predm = y.zkr_predm
    and s.rok_varianty  = y.rok_varianty
    and nvl(s.statut_zapisu,'N') = nvl(y.statut_zapisu,'N')
    and( s.roakidno is null and y.roakidno is null
    or s.roakidno = y.roakidno)
    and  s.dotaidno = y.dotaidno)
    WHEN MATCHED THEN UPDATE SET s.respondentu = y.pocet;


    OPEN c_data(p_dotaidno);
    FETCH c_data bulk collect
    INTO l_record.staoidno ,
   l_record.tdtvidno ,
   l_record.doutidno ,
   l_record.pocet    ,
   l_record.prumer ,
   l_record.rozptyl,
   l_record.sikmost ,
   l_record.spicatost ,
   l_record.chyba ,
   l_record.mutabilita;
CLOSE c_data;

forall i IN 1 .. l_record.staoidno.COUNT

UPDATE EVA_STATISTIKY_TVRZ
  SET
   odpovedi = l_record.pocet(i)
   ,prumer = l_record.prumer(i)
   ,rozptyl = l_record.rozptyl(i)
   ,sikmost = l_record.sikmost(i)
   ,spicatost = l_record.spicatost(i)
   ,pom_vyb_chyba  = l_record.chyba(i)
   ,mutabilita = l_record.mutabilita(i)
 WHERE
  staoidno = l_record.staoidno(i)
  and (l_record.tdtvidno(i) is not null
        and tdtvidno = l_record.tdtvidno(i)
    or l_record.doutidno(i) is not null
      and doutidno = l_record.doutidno(i))
 ;

commit;

return(0);

end;
function cti_parametr1(p_tydoidno NUMBER, p_parametr VARCHAR2)
  return VARCHAR2
  is
  p_navrat eva_nastaveni.hodnota_parametru%type;
  begin

  select n.hodnota_parametru into p_navrat
     from eva_nastaveni n, eva_parametry p
     where p.zkr = p_parametr
    and p.paraidno = n.paraidno
     and n.tydoidno = p_tydoidno
     ;

     return(p_navrat);

     exception
       when others then
         return  null;
  end;




function get_rok_semestr_b(p_tydoidno IN NUMBER)
return varchar2 is

p_akt_semestr eva_nastaveni.hodnota_parametru%type;
p_pocet_semestru eva_nastaveni.hodnota_parametru%type;
xnavrat varchar2(4000) default '';
p_a_rok varchar2(4);
p_a_semestr varchar2(2);

begin
   -- zjisteni aktualniho roku a semestru
   /* doplnit exception */

   select
    k.rok_platnosti,
    substr(k.typ_rozvrh_dne,1,1)||'S' semestr into p_a_rok, p_a_semestr
   from kalendar  k
   where k.datum = trunc(sysdate);

   p_akt_semestr := nvl(cti_parametr1(p_tydoidno,'xpovolaktsem'),'A');
   p_pocet_semestru := nvl(cti_parametr1(p_tydoidno,'xpocetsem'),'2');

   if p_akt_semestr = 'A' then
     xnavrat := p_a_rok || p_a_semestr||';';
   end if;


   for i in 1..p_pocet_semestru loop
      if p_a_semestr = 'LS' then
        xnavrat := xnavrat||p_a_rok|| 'ZS'||';';
        p_a_semestr :=  'ZS';
      else
         p_a_rok := to_char(to_number(p_a_rok)-1);
         xnavrat := xnavrat || p_a_rok||'LS'||';';
         p_a_semestr :=  'LS';
      end if;
   end loop;

   return xnavrat;
end;

function ins_eva_glob_stats(p_dotaidno IN NUMBER)
return number
is
begin
 INSERT INTO EVA_GLOB_STATS(dotaidno, fakulta, program,
forma,ROK_ST,VYKAZOVAN,STUDENTU, RESPONDENTU)
SELECT dot.dotaidno,
     sp.fakulta_sp fakulta,
     sp.stpridno PROGRAM,
     sp.forma,
     sor.rok_st,
     decode(sp.VYKAZOVAN||st.VYKAZOVAN,'AA','A','N') vykazovan,
     COUNT(DISTINCT st.os_cislo) pocet,
     0
   FROM
    studijni_programy sp,
    obory o,
    studenti st,
    studenti_v_roce sr,
    studenti_na_oboru_v_roce sor,
    eva_dotazniky dot
   WHERE
    dot.dotaidno  = p_dotaidno
   AND sp.stpridno = st.stpridno
   AND sr.os_cislo = st.os_cislo
   AND sr.rok_platnosti = dot.skolni_rok
   AND sor.os_cislo = sr.os_cislo
   AND sor.rok_platnosti = sr.rok_platnosti
   AND o.STPRIDNO = sp.STPRIDNO
   AND(dot.semestr = 'LS' AND sr.prerus_ls = 'N'
        OR dot.semestr = 'ZS' AND sr.prerus_zs = 'N')
   AND(trunc(st.dat_ukonceni)  >= trunc(dot.otevreni)
           OR st.dat_ukonceni IS NULL)
   AND EXISTS
    (SELECT os_cislo
     FROM znamky z,
       eva_dotazniky dot,
       eva_dot_predmet dp
     WHERE
      z.rok_platnosti = sor.rok_platnosti
     AND z.os_cislo = sor.os_cislo
     AND z.semestr = dot.semestr
     AND z.uznano = 'N'
     AND dp.prac_zkr = z.prac_zkr
     AND dp.zkr_predm = z.zkr_predm
     AND dp.rok_varianty = z.rok_varianty
     AND dp.dotaidno = dot.dotaidno)
  GROUP BY
     dot.dotaidno,
     sp.fakulta_sp,
     sp.stpridno,
     sp.forma,
     sor.rok_st,
     decode(sp.VYKAZOVAN||st.VYKAZOVAN,'AA','A','N')
 ORDER by 2,4,3,5,6;

  return(SQL%ROWCOUNT);

end ins_eva_glob_stats;

function upd_eva_glob_stats(p_dotaidno IN NUMBER)
return number
is
begin

 merge into eva_glob_stats s
using
(
select
  r.fakulta,
  r.forma_studia,
  r.vykazovan,
  r.rok_st,
  r.program,
  r.respondentu,
  so.pocet_odpovedi,
  so.prumer,
  so.rozptyl
 from
(select
  zr.hodnota_polozky fakulta,
  zr1.hodnota_polozky forma_studia,
  zr2.hodnota_polozky vykazovan,
  zr3.hodnota_polozky rok_st,
  zr4.hodnota_polozky program,
  count(odp.odpoidno) pocet_odpovedi,
  round(avg(so.bodovani),3) prumer,
  round(VARIANCE(so.bodovani),3) rozptyl
from
  eva_respondenti re,
  eva_zahlavi_resp zr,
  eva_zahlavi za,
  eva_polozky_zahlavi pz,
  eva_zahlavi_resp zr1,
  eva_zahlavi za1,
  eva_polozky_zahlavi pz1,
  eva_zahlavi_resp zr2,
  eva_zahlavi za2,
  eva_polozky_zahlavi pz2,
  eva_zahlavi_resp zr3,
  eva_zahlavi za3,
  eva_polozky_zahlavi pz3,
  eva_zahlavi_resp zr4,
  eva_zahlavi za4,
  eva_polozky_zahlavi pz4,
  eva_resp_objekt ro,
  eva_odpovedi_resp odp,
  eva_odpovedi so
where
  re.dotaidno = p_dotaidno
  and re.username is null
  and zr.respidno = re.respidno
  and za.zahlidno = zr.zahlidno
  and pz.zapoidno = za.zapoidno
  and pz.zkr = 'fakulta'
  and zr1.respidno = re.respidno
  and za1.zahlidno = zr1.zahlidno
  and pz1.zapoidno = za1.zapoidno
  and pz1.zkr = 'forma_studia'
  and zr2.respidno = re.respidno
  and za2.zahlidno = zr2.zahlidno
  and pz2.zapoidno = za2.zapoidno
  and pz2.zkr = 'vykazovan'
  and zr3.respidno = re.respidno
  and za3.zahlidno = zr3.zahlidno
  and pz3.zapoidno = za3.zapoidno
  and pz3.zkr = 'rok_studia'
  and zr4.respidno = re.respidno
  and za4.zahlidno = zr4.zahlidno
  and pz4.zapoidno = za4.zapoidno
  and pz4.zkr = 'studijni_program'
  and ro.respidno (+) = re.respidno
  and odp.reobidno = ro.reobidno
  and so.odpoidno = odp.odpoidno
  and nvl(so.implicitni,'N') = 'N'
  and nvl(so.textova_odpoved,'N') = 'N'
group by
  zr.hodnota_polozky,
  zr1.hodnota_polozky,
  zr2.hodnota_polozky,
  zr3.hodnota_polozky,
  zr4.hodnota_polozky) so,
  (
  select
    zr.hodnota_polozky fakulta,
  zr1.hodnota_polozky forma_studia,
  zr2.hodnota_polozky vykazovan,
  zr3.hodnota_polozky rok_st,
  zr4.hodnota_polozky program,
  count(re.respidno) respondentu
from
  eva_respondenti re,
  eva_zahlavi_resp zr,
  eva_zahlavi za,
  eva_polozky_zahlavi pz,
  eva_zahlavi_resp zr1,
  eva_zahlavi za1,
  eva_polozky_zahlavi pz1,
  eva_zahlavi_resp zr2,
  eva_zahlavi za2,
  eva_polozky_zahlavi pz2,
  eva_zahlavi_resp zr3,
  eva_zahlavi za3,
  eva_polozky_zahlavi pz3,
  eva_zahlavi_resp zr4,
  eva_zahlavi za4,
  eva_polozky_zahlavi pz4
where
  re.dotaidno = p_dotaidno
  and re.username is null
  and zr.respidno = re.respidno
  and za.zahlidno = zr.zahlidno
  and pz.zapoidno = za.zapoidno
  and pz.zkr = 'fakulta'
  and zr1.respidno = re.respidno
  and za1.zahlidno = zr1.zahlidno
  and pz1.zapoidno = za1.zapoidno
  and pz1.zkr = 'forma_studia'
  and zr2.respidno = re.respidno
  and za2.zahlidno = zr2.zahlidno
  and pz2.zapoidno = za2.zapoidno
  and pz2.zkr = 'vykazovan'
  and zr3.respidno = re.respidno
  and za3.zahlidno = zr3.zahlidno
  and pz3.zapoidno = za3.zapoidno
  and pz3.zkr = 'rok_studia'
  and zr4.respidno = re.respidno
  and za4.zahlidno = zr4.zahlidno
  and pz4.zapoidno = za4.zapoidno
  and pz4.zkr = 'studijni_program'
  and exists(select * from eva_resp_objekt ro where ro.respidno = re.respidno)
group by
  zr.hodnota_polozky,
  zr1.hodnota_polozky,
  zr2.hodnota_polozky,
  zr3.hodnota_polozky,
  zr4.hodnota_polozky) r
where so.fakulta(+) = r.fakulta
  and so.forma_studia(+) = r.forma_studia
  and so.vykazovan (+) = r.vykazovan
  and so.rok_st(+) = r.rok_st
  and so.program (+) = r.program  ) y
  ON
    ( s.dotaidno = p_dotaidno
    and s.fakulta = y.fakulta
    and s.forma = y.forma_studia
    and s.vykazovan = y.vykazovan
    and s.rok_st = y.rok_st
    and s.program = y.program
    )
    WHEN MATCHED THEN UPDATE SET
      s.respondentu = y.respondentu,
      s.odpovedi = y.pocet_odpovedi,
      s.prumer = y.prumer,
      s.rozptyl = y.rozptyl;

  /*WHEN NOT MATCHED THEN INSERT (s.dotaidno, s.fakulta, s.forma, s.vykazovan, s.rok_st, s.program, s.studentu, s.respondentu, s.odpovedi, s.prumer, s.rozptyl)
     VALUES (p_dotaidno, y.fakulta, y.forma_studia, y.vykazovan, y.rok_st, y.program, 0, y.respondentu, y.pocet_odpovedi, y.prumer, y.rozptyl);*/

  /* update poctu anonymnich pripominek k eva_glob_stats */
merge
  into eva_glob_stats s
using(
select
  zr.hodnota_polozky fakulta,
  zr1.hodnota_polozky forma,
  zr2.hodnota_polozky vykazovan,
  zr3.hodnota_polozky standard_rok,
  zr4.hodnota_polozky stpridno,
  count(ro.reobidno) pocet_prip_a
 from eva_respondenti re, 
 eva_resp_objekt ro,
   eva_zahlavi_resp zr,
  eva_zahlavi za,
  eva_polozky_zahlavi pz,
  eva_zahlavi_resp zr1,
  eva_zahlavi za1,
  eva_polozky_zahlavi pz1,
  eva_zahlavi_resp zr2,
  eva_zahlavi za2,
  eva_polozky_zahlavi pz2,
  eva_zahlavi_resp zr3,
  eva_zahlavi za3,
  eva_polozky_zahlavi pz3,
  eva_zahlavi_resp zr4,
  eva_zahlavi za4,
  eva_polozky_zahlavi pz4
where
  re.dotaidno = p_dotaidno
  and re.username is null
  and ro.respidno = re.respidno 
  and ro.pripominka is not null
  and zr.respidno = re.respidno
  and za.zahlidno = zr.zahlidno
  and pz.zapoidno = za.zapoidno
  and pz.zkr = 'fakulta'
  and zr1.respidno = re.respidno
  and za1.zahlidno = zr1.zahlidno
  and pz1.zapoidno = za1.zapoidno
  and pz1.zkr = 'forma_studia'
  and zr2.respidno = re.respidno
  and za2.zahlidno = zr2.zahlidno
  and pz2.zapoidno = za2.zapoidno
  and pz2.zkr = 'vykazovan'
  and zr3.respidno = re.respidno
  and za3.zahlidno = zr3.zahlidno
  and pz3.zapoidno = za3.zapoidno
  and pz3.zkr = 'rok_studia'
  and zr4.respidno = re.respidno
  and za4.zahlidno = zr4.zahlidno
  and pz4.zapoidno = za4.zapoidno
  and pz4.zkr = 'studijni_program'  
group by zr.hodnota_polozky, zr1.hodnota_polozky, zr2.hodnota_polozky, zr3.hodnota_polozky, zr4.hodnota_polozky    
  )y
  on (s.dotaidno = p_dotaidno
  and s.fakulta = y.fakulta
  and s.forma = y.forma
  and s.program = y.stpridno
  and s.rok_st = y.standard_rok
  and s.vykazovan = y.vykazovan )
  WHEN MATCHED THEN UPDATE SET
      s.pripominek_a = y.pocet_prip_a;


  /* update poctu pripominek podepsanych */

merge into eva_glob_stats s
using(
select
  sp.fakulta_sp,
  sp.forma,
  sp.stpridno,
  sr.standard_rok,
  decode(s.vykazovan||sp.vykazovan,'AA','A','N') vykazovan,
  count(*) pocet_prip_p
from
  eva_dotazniky dot,
  eva_pripominky vp,
  studenti s,
  studijni_programy sp,
  studenti_v_roce sr
where
  dot.dotaidno =  p_dotaidno
  and vp.dotaidno = dot.dotaidno
  and s.os_cislo = vp.username
  and sp.stpridno = s.stpridno
  and sr.rok_platnosti = dot.skolni_rok
  and sr.os_cislo = s.os_cislo
  group by  sp.fakulta_sp,
  sp.forma,
  sp.stpridno,
  sr.standard_rok,
  decode(s.vykazovan||sp.vykazovan,'AA','A','N')
  )y
  on (s.dotaidno = p_dotaidno
  and s.fakulta = y.fakulta_sp
  and s.forma = y.forma
  and s.program = y.stpridno
  and s.rok_st = y.standard_rok
  and s.vykazovan = y.vykazovan )
  WHEN MATCHED THEN UPDATE SET
      s.pripominek_p = y.pocet_prip_p;


  return 0;

end upd_eva_glob_stats;

function del_nevyplnene_dot(p_dotaidno in number)
return number
is

xnavrat number;

begin

DELETE FROM
  (    SELECT odp.*
    FROM
      eva_odpovedi_resp odp,
      eva_resp_objekt ro,
      eva_respondenti re,
      eva_odpovedi so
      where re.dotaidno = p_dotaidno
      and re.username is not null
      and ro.respidno = re.respidno
      and odp.reobidno = ro.reobidno
      and so.odpoidno = odp.odpoidno
      and (odp.text_odpoved is null
          and nvl(so.textova_odpoved,'N') = 'A'
          OR
           nvl(so.textova_odpoved,'N') = 'N'
           and nvl(so.implicitni,'N') = 'A')
      );


delete
from
(
select ra.*
  from
    eva_rozvrh_akce ra,
    eva_resp_objekt ro,
    eva_respondenti re
 where
    re.dotaidno = p_dotaidno
    and re.username is not null
    and ro.respidno = re.respidno
    and ra.reobidno = ro.reobidno
    and trim(ro.pripominka) is null
    );


delete from (
  select ro.*
  from
    eva_resp_objekt ro,
    eva_respondenti re
  where
    re.dotaidno = p_dotaidno
    and re.username is not null
    and ro.respidno = re.respidno
    and not exists
      (select *
          from
            eva_odpovedi_resp odp
         where
          odp.reobidno= ro.reobidno)
    )
  where trim(pripominka) is null;


delete
from (
select
  zr.*
  from
    eva_zahlavi_resp zr,
    eva_respondenti re
  where
    re.dotaidno = p_dotaidno
    and re.username is not null
    and trim(re.pripominka_sem) is null
    and trim(re.pripominka_tech) is null
    and not exists(select * from eva_resp_objekt ro where ro.respidno = re.respidno)
    and zr.respidno = re.respidno);


  delete
    from
      eva_respondenti re
    where
      dotaidno = p_dotaidno
      and re.username is not null
      and trim(re.pripominka_sem) is null
      and trim(re.pripominka_tech) is null
      and not exists(select * from eva_resp_objekt ro where ro.respidno = re.respidno);



   xnavrat := SQL%ROWCOUNT;

  return xnavrat;

  exception
    when others then
     rollback;
     return 0;

end del_nevyplnene_dot;

function ins_dotaznik_b(p_tydoidno EVA_DOTAZNIKY.TYDOIDNO%TYPE,
p_otevreni varchar2,
p_uzavreni varchar2,
p_skolni_rok varchar2,
p_semestr varchar2,
p_predstih varchar2,
p_vetovani varchar2,
p_text_emailu varchar2,
p_ucitidno varchar2,
p_prac_zkr varchar2,
p_zkr_predm varchar2,
p_rok_varianty varchar2
)
return varchar2

is

new_dotaidno EVA_DOTAZNIKY.DOTAIDNO%TYPE;

ret_val VARCHAR2(4000);

begin

  /* kontrola datumu triggeru */
  begin

    insert into eva_dotazniky(tydoidno, otevreni, uzavreni, skolni_rok, semestr, predstih, vetovani, text_emailu, ucitidno )
    values (p_tydoidno, to_date(p_otevreni,'DD.MM.RRRR'), to_date(p_uzavreni, 'DD.MM.RRRR'), p_skolni_rok, p_semestr, p_predstih, p_vetovani, p_text_emailu, p_ucitidno)
    returning dotaidno into new_dotaidno;

    -- vlozeni do eva_dot_predmet
    insert into eva_dot_predmet(dotaidno, prac_zkr, zkr_predm, rok_varianty, username)
    values (new_dotaidno, p_prac_zkr, p_zkr_predm, p_rok_varianty, p_ucitidno);
    insert into eva_pocty_roak(dotaidno, roakidno, statut_zapisu, pocet_studentu)
    SELECT NEW_DOTAIDNO,  ra.roakidno, z.statut,
    COUNT(zap.os_cislo) pocet_stud_roak
     FROM
      eva_dot_predmet dp     ,
      rozvrh_akce ra         ,
      zapisy zap             ,
      znamky z
    WHERE
      dp.dotaidno = NEW_dotaidno
      AND z.prac_zkr       = dp.prac_zkr
      AND z.zkr_predm      = dp.zkr_predm
      AND z.rok_varianty   = dp.rok_varianty
      AND z.semestr        = p_semestr
      AND z.uznano         = 'N'
      AND zap.os_cislo     = z.os_cislo
      AND zap.prac_zkr     = z.prac_zkr
      AND zap.zkr_predm    = z.zkr_predm
      AND zap.rok_varianty = z.rok_varianty
      AND zap.semestr      = z.semestr
      AND ra.roakidno      = zap.roakidno
      AND ra.platnost      = 'A'
    GROUP BY
        z.statut         ,
        ra.roakidno
    order by 2,3  ;

     exception
      when TYP_B_BLOCKED_SEM then
       new_dotaidno  := -20811;
      when TYP_B_BLOCKED_INTERVAL then
        new_dotaidno  := -20812;
      when TYP_B_MIN then
        -- raise_application_error(-20811,'TYP_B_MIN');
        new_dotaidno  := -20813;
      when TYP_B_ZALOZEN  then
          new_dotaidno  := -20814;
      when others then
           new_dotaidno := -1;
  end;

  if new_dotaidno < 0 then
    rollback;
  else
   commit;
  end if;

  return(to_char(new_dotaidno));

end;

function get_tydoidno_b
return eva_typ_dotazniku.tydoidno%type

is


  b_tydoidno eva_typ_dotazniku.tydoidno%type;

  begin

    select tydoidno into b_tydoidno from eva_typ_dotazniku
    where zkr = 'Typ B';

    return b_tydoidno;

    exception
        WHEN NO_DATA_FOUND THEN
          raise_application_error(-20900, 'Typ B nedefinovan');
          return -1;
        WHEN TOO_MANY_ROWS THEN
         raise_application_error(-20900, 'Vicenasobna definice Typ B nepodporovana');
         return -2;

  end get_tydoidno_b;


function typdot_tvrz_insert(p_tydoidno number,
                            p_sluzidno number,
                            p_satvidno number,
                            p_poradi number,
                            p_saodidno number,
                            p_vaha  number)
return number
is

new_tdtvidno number;

begin


   insert into eva_typdot_tvrzeni(tydoidno, satvidno, saodidno, poradi, vaha)
    values (p_tydoidno, p_satvidno, p_saodidno, p_poradi, p_vaha ) returning
    tdtvidno into new_tdtvidno;

    insert into eva_typdot_sluzby(sluzidno, tdtvidno)
    values(p_sluzidno, new_tdtvidno);

   return 1;

    exception
      when others then return 0;



  end;

function complete_delete_dotaznik(p_dotaidno number)
return number
is
  begin

    /* nejde pres CASCADE ... je tam trigger, ktery tomu brani */ 
     delete from
      (select zr.* from
        eva_zahlavi_resp zr,
        eva_respondenti re
        where re.dotaidno = p_dotaidno
        and zr.respidno = re.respidno);
       
    delete from
      (select odp.* from
        eva_respondenti re,
        eva_resp_objekt ro,
        eva_odpovedi_resp odp
        where re.dotaidno = p_dotaidno
        and ro.respidno = re.respidno
        and odp.reobidno = ro.reobidno);

      delete from
      (select ro.* from
        eva_respondenti re,
        eva_resp_objekt ro
        where re.dotaidno = p_dotaidno
        and ro.respidno = re.respidno);

     delete from eva_respondenti
     where dotaidno = p_dotaidno;

    
     delete from 
     (select rc.*
        from
          eva_reakce rc, 
          eva_dot_predmet dp        
        where dp.dotaidno = p_dotaidno
        and rc.dopridno = dp.dopridno);
     
     delete from 
        eva_dot_predmet 
        where dotaidno = p_dotaidno;
        
    
   /* zapomnel jsem dat do CASE ... proverit jestli by nesla uplne zrusit */
   delete from eva_pocty_roak where dotaidno = p_dotaidno;
     

     delete from eva_dotazniky
     where dotaidno = p_dotaidno;

     return 0;

  end;

function statistiky_obj_insert(p_dotaidno in eva_dotazniky.dotaidno%type)
return number is
/*
   insertuje eva_statistiky_objekt ... pustit v jobu po zalozeni ankety !!!
*/

inserted_rows number :=0;

begin
 /* optimalizovat bulk insertem  */
 for x in c_stats_obj_ins(p_dotaidno) loop


                insert into eva_statistiky_objekt (dotaidno, prac_zkr, zkr_predm, rok_varianty, roakidno,  statut_zapisu, respondentu, studentu, ucitidno)
                values (x.dotaidno, x.prac_zkr, x.zkr_predm, x.rok_varianty, x.roakidno, x.statut, 0, x.studentu, null);

               inserted_rows := inserted_rows +1;



           end loop;

           commit;
 return   inserted_rows;
    exception when others then
         return -1;
end;


function statistiky_merge(p_dotaidno eva_dotazniky.dotaidno%type)
return number
is

  /* funkce insertuje, popripade updatuje statistiky predmetu  */
  /* doplnit SLUZBY !!! */


  inserted_rows number default 0;
  updated_rows  number default 0;




begin


     for x in c_stats_obj_ins(p_dotaidno) loop
             begin

                insert into eva_statistiky_objekt (dotaidno, prac_zkr, zkr_predm, rok_varianty, roakidno,  statut_zapisu, respondentu, studentu, ucitidno)
                values (x.dotaidno, x.prac_zkr, x.zkr_predm, x.rok_varianty, x.roakidno, x.statut, 0, x.studentu, null);
               inserted_rows := inserted_rows +1;

               exception
                when dup_val_on_index then

                update eva_statistiky_objekt
                set studentu  = x.studentu
                where
                 dotaidno = x.dotaidno
                 and prac_zkr = x.prac_zkr
                 and zkr_predm = x.zkr_predm
                 and rok_varianty  = x.rok_varianty
                 and (roakidno is null or
                         roakidno = x.roakidno)
                 and nvl(statut_zapisu,'N') =  nvl(x.statut, 'N')
                 and ucitidno is null;

                 updated_rows := updated_rows +1;

             end;

           end loop;
           commit;
           merge into eva_statistiky_objekt s

using(  SELECT  -- roak, status
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      ra.roakidno,
      ro.statut_zapisu,
      count(distinct ro.reobidno) pocet
     FROM
      eva_respondenti re,
      eva_resp_objekt ro,
      eva_rozvrh_akce ra
    where
      re.dotaidno  = p_dotaidno
      and re.username is null
      and ro.respidno = re.respidno
      and ra.reobidno = ro.reobidno
    group by
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      ro.statut_zapisu,
      ra.roakidno
  union
       SELECT  -- roak, null
         re.dotaidno,
         ro.prac_zkr,
         ro.zkr_predm,
         ro.rok_varianty,
         ra.roakidno,
         null statut,
         count (distinct ro.reobidno) pocet
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_rozvrh_akce ra
      where
        re.dotaidno  = p_dotaidno
        and re.username is null
        and ro.respidno = re.respidno
        and ra.reobidno = ro.reobidno
      group by
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty,
        ra.roakidno
     UNION
     SELECT  -- null, statut
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      null roakidno,
      ro.statut_zapisu,
      count(distinct ro.reobidno) pocet
     FROM
      eva_respondenti re,
      eva_resp_objekt ro,
      eva_dot_predmet dp
    where
      re.dotaidno  = p_dotaidno
      and re.username is null
      and ro.respidno = re.respidno
      and dp.dotaidno = re.dotaidno
      and dp.prac_zkr = ro.prac_zkr
      and dp.zkr_predm = ro. zkr_predm
      and dp.rok_varianty = ro.rok_varianty
    group by
      re.dotaidno,
      ro.prac_zkr,
      ro.zkr_predm,
      ro.rok_varianty,
      ro.statut_zapisu
 union
      SELECT  -- null, null
         re.dotaidno,
         ro.prac_zkr,
         ro.zkr_predm,
         ro.rok_varianty,
         null roakidno,
         null statut,
         count (distinct ro.reobidno) pocet
      FROM
       eva_respondenti re,
       eva_resp_objekt ro,
       eva_dot_predmet dp
      where
        re.dotaidno  = p_dotaidno
        and re.username is null
        and ro.respidno = re.respidno
        and dp.dotaidno = re.dotaidno
        and dp.prac_zkr = ro.prac_zkr
        and dp.zkr_predm = ro. zkr_predm
        and dp.rok_varianty = ro.rok_varianty
      group by
        re.dotaidno,
        ro.prac_zkr,
        ro.zkr_predm,
        ro.rok_varianty   ) y
    ON
    (s.prac_zkr = y.prac_zkr
    and      s.zkr_predm = y.zkr_predm
    and s.rok_varianty  = y.rok_varianty
    and nvl(s.statut_zapisu,'N') = nvl(y.statut_zapisu,'N')
    and( s.roakidno is null and y.roakidno is null
    or s.roakidno = y.roakidno)
    and  s.dotaidno = y.dotaidno)
    WHEN MATCHED THEN UPDATE SET s.respondentu = y.pocet;

    commit;

  return inserted_rows + updated_rows;

        exception when others then
         return -1;
end;

function statistiky_tvrz_merge(p_dotaidno in eva_dotazniky.dotaidno%type)
return number
is 
ret_val number default 0;


/* prikaz merge nelze pouzit nema se rad s api triggerama ... */
begin

for s in (
select x.staoidno,
       x.tdtvidno,
       x.doutidno,
       x.pocet_odpovedi odpovedi,
       round(x.prumer,3) prumer,
       round(x.rozptyl,3) rozptyl,
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,3))/(x.pocet_odpovedi * power(x.odchylka,3 ) ),3) )sikmost,  -- u=sum_i(x_i-prumer)^3/(n*sigma^3)
       decode(x.odchylka,0,null, round(sum(power(so1.bodovani-x.prumer,4))/(x.pocet_odpovedi * power(x.odchylka,4))-3,3)) spicatost, --  u=sum_i(x_i-prumer)^4/(n*sigma^4) - 3
       decode(nvl(x.pocet_odpovedi,0),0,null,1,null,
       decode(nvl(sto1.studentu,0),0,null,
       decode(x.prumer,0,0,
			     round(100*(1-x.pocet_odpovedi/sto1.studentu)*x.rozptyl/power(x.prumer,2)/x.pocet_odpovedi,3))
                 )
              )   pom_vyb_chyba,
       decode(x.pocet_odpovedi,0,null, 1,null,round(100*(power(x.pocet_odpovedi,2) - z.sum_cetnosti)/(x.pocet_odpovedi * (x.pocet_odpovedi - 1)),3) )mutabilita
from
(select sto.staoidno,
       odp.tdtvidno,
       odp.doutidno,
       count(*) pocet_odpovedi,
       avg(so.bodovani) prumer,
       VARIANCE(so.bodovani) rozptyl,
       STDDEV(so.bodovani) odchylka
from eva_statistiky_objekt sto,
     eva_respondenti re,
     eva_resp_objekt ro,
     eva_odpovedi_resp odp,
     eva_odpovedi so
where sto.dotaidno = p_dotaidno
  and re.dotaidno = sto.dotaidno
  and re.username is NULL
  and ro.respidno = re.respidno
  and ro.prac_zkr = sto.prac_zkr
  AND ro.zkr_predm = sto.zkr_predm
  and ro.rok_varianty = sto.rok_varianty
  and (sto.statut_zapisu is null
         or ro.statut_zapisu = sto.statut_zapisu)
  AND odp.reobidno  = ro.reobidno
  and (odp.ucitidno is null and sto.ucitidno is null
         or odp.ucitidno = sto.ucitidno)
  AND (sto.roakidno is NULL
        or sto.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra where ra.reobidno = ro.reobidno and ra.pripidno is null and ra.roakidno = sto.roakidno)
        )
  AND   so.odpoidno = odp.odpoidno
  and nvl(so.textova_odpoved,'N') = 'N'
  and nvl(so.implicitni,'N') = 'N'
  GROUP BY sto.staoidno,
       odp.tdtvidno,
       odp.doutidno) X,
(select y.staoidno,
       y.tdtvidno,
       y.doutidno,
       sum(power(pocet,2)) sum_cetnosti
from
(select sto2.staoidno,
       odp2.tdtvidno,
       odp2.doutidno,
       so2.bodovani,
       count(*) pocet
from eva_statistiky_objekt sto2,
     eva_respondenti re2,
     eva_resp_objekt ro2,
     eva_odpovedi_resp odp2,
     eva_odpovedi so2
where sto2.dotaidno = p_dotaidno
  and re2.dotaidno = sto2.dotaidno
  and re2.username is NULL
  and ro2.respidno = re2.respidno
  and ro2.prac_zkr = sto2.prac_zkr
  AND ro2.zkr_predm = sto2.zkr_predm
  and ro2.rok_varianty = sto2.rok_varianty
  and (sto2.statut_zapisu is null
         or ro2.statut_zapisu = sto2.statut_zapisu)
  AND odp2.reobidno  = ro2.reobidno
  and (odp2.ucitidno is null and sto2.ucitidno is null
         or odp2.ucitidno = sto2.ucitidno)
  AND (sto2.roakidno is NULL
        or sto2.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra2 where ra2.reobidno = ro2.reobidno and ra2.roakidno = sto2.roakidno and ra2.pripidno is null)
        )
  and so2.odpoidno = odp2.odpoidno
  and nvl(so2.textova_odpoved,'N') = 'N'
  and nvl(so2.implicitni,'N') = 'N'
  GROUP BY sto2.staoidno,
       odp2.tdtvidno,
       odp2.doutidno,
       so2.bodovani)Y
group by y.staoidno,
       y.tdtvidno,
       y.doutidno)Z,
     eva_statistiky_objekt sto1,
     eva_respondenti re1,
     eva_resp_objekt ro1,
     eva_odpovedi_resp odp1,
     eva_odpovedi so1
 where sto1.staoidno = x.staoidno
  and z.staoidno  = x.staoidno
  and (z.tdtvidno is not null
        and  z.tdtvidno = x.tdtvidno
       or z.doutidno is not null
       and z.doutidno = x.doutidno)
  and  re1.dotaidno = sto1.dotaidno
  and re1.username is NULL
  and ro1.respidno = re1.respidno
  and ro1.prac_zkr = sto1.prac_zkr
  AND ro1.zkr_predm = sto1.zkr_predm
  and ro1.rok_varianty = sto1.rok_varianty
  and ( sto1.statut_zapisu is null
         or ro1.statut_zapisu = sto1.statut_zapisu)
  AND odp1.reobidno  = ro1.reobidno
  and (odp1.tdtvidno is not null
       and odp1.tdtvidno = x.tdtvidno
       or odp1.doutidno is not null
         and odp1.doutidno = x.doutidno)
  and (odp1.ucitidno is null and sto1.ucitidno is null
         or odp1.ucitidno = sto1.ucitidno)
  AND (sto1.roakidno is NULL
        or sto1.roakidno is not NULL
            and exists
            (select * from eva_rozvrh_akce ra1 where ra1.reobidno = ro1.reobidno and ra1.roakidno = sto1.roakidno and ra1.pripidno is null)
        )
   and so1.odpoidno = odp1.odpoidno
  and nvl(so1.textova_odpoved,'N') = 'N'
  and nvl(so1.implicitni,'N') = 'N'
  group by x.staoidno,
           sto1.studentu,
       x.tdtvidno,
       x.doutidno,
       x.pocet_odpovedi,
       x.prumer,
       x.rozptyl,
       x.odchylka,
       z.sum_cetnosti) loop

      begin
       insert into eva_statistiky_tvrz(staoidno, tdtvidno, doutidno, odpovedi, prumer, rozptyl, sikmost, spicatost, pom_vyb_chyba, mutabilita)
       values (s.staoidno, s.tdtvidno, s.doutidno, s.odpovedi, s.prumer, s.rozptyl, s.sikmost, s.spicatost, s.pom_vyb_chyba, s.mutabilita);

       exception
       when dup_val_on_index then

          update
             eva_statistiky_tvrz
             set odpovedi = s.odpovedi
              ,prumer = s.prumer
              ,rozptyl  = s.rozptyl
              ,sikmost = s.sikmost
              ,spicatost = s.spicatost
              ,pom_vyb_chyba = s.pom_vyb_chyba
              ,mutabilita = s.mutabilita
             where
              staoidno = s.staoidno
              and tdtvidno = s.tdtvidno
              and doutidno = s.doutidno;

          end;
  ret_val := ret_val +1;
  
end loop;
commit;
return ret_val;
end;


end; -- konec pg_eva
/

