SELECT distinct
  dot.dotaidno,
  dot.otevreni,
  dot.uzavreni,
  (select max(om.hodnota_polozky)
    from
      eva_omezeni_resp om,
      eva_polozky_zahlavi zp
    where
     om.zapoidno = zp.zapoidno
     and zp.zkr = 'predmet'
     and om.tydoidno = dot.tydoidno) as typ_dotazniku,

  case  (select count(*)
    from
      eva_omezeni_resp om,
      eva_polozky_zahlavi zp
    where
     om.zapoidno = zp.zapoidno
     and zp.zkr = 'predmet'
     and om.hodnota_polozky = 'B'
     and om.tydoidno = dot.tydoidno)  when 1  then
         (select dp.prac_zkr||'/'||dp.zkr_predm predmet from eva_dot_predmet dp where dotaidno = dot.dotaidno)
     else
       td.zkr
     end zkr,
  td.popis,
  dot.skolni_rok,
  dot.semestr,
  --(select nvl(pg_eva.cti_parametr(dot.dotaidno,'hodnotit_vyucujici'),'N') from dual) hodnotit_ucitele,
  (select nvl(pg_eva.cti_parametr(dot.dotaidno,'hodnotit_vyucujici'),'N') from dual) hodnotit_ucitele
   FROM
  VSTUDENTI_NA_OBORU_EVA sp,
  eva_dotazniky dot,
  eva_typ_dotazniku td
  WHERE dot.otevreni <= TRUNC(sysdate)
AND dot.uzavreni     >= TRUNC(sysdate)
AND td.tydoidno       = dot.tydoidno
AND sp.OS_CISLO        = FN_OS_CISLO_K_DOTAZNIKU(:xuser,dot.dotaidno)
and sp.rok_platnosti = dot.skolni_rok
AND (select count(*)
      from
        eva_omezeni_resp om,
        eva_polozky_zahlavi pz
       where
         om.tydoidno = dot.tydoidno
         AND om.zapoidno = pz.zapoidno
         AND (pz.zkr          = 'fakulta'
              AND sp.fakulta_sp   = om.hodnota_polozky
              or
               (pz.zkr          = 'obor'
                AND to_char(sp.oboridno)   = om.hodnota_polozky)
              or (pz.zkr          = 'studijni_program'
                AND to_char(sp.stpridno)   = om.hodnota_polozky)
              or (pz.zkr          = 'rok_studia'
                AND sp.standard_rok   = om.hodnota_polozky)
              or (pz.zkr          = 'navazujici'
                AND sp.navazujici   = om.hodnota_polozky)
              or(pz.zkr          = 'katedra'
                AND (sp.katedra_ob   = om.hodnota_polozky or sp.katedra_ob is null))
              or (pz.zkr         = 'celozivot_vzdelavani'
                AND sp.celozivotni_vzdelavani = om.hodnota_polozky)
              or (pz.zkr         = 'forma_studia'
                AND sp.forma = om.hodnota_polozky)
                ) ) = 0
AND (EXISTS
  (SELECT *
     FROM eva_typdot_tvrzeni tt,
    eva_typdot_sluzby ts
    WHERE tt.tydoidno = dot.tydoidno
  AND ts.tdtvidno     = tt.tdtvidno
  )
OR EXISTS
  (SELECT *
     FROM znamky z,
    eva_dot_predmet dp
    WHERE z.rok_platnosti = dot.skolni_rok
  AND z.rok_varianty      = dot.skolni_rok
  AND z.semestr           = dot.semestr
  AND z.os_cislo          = sp.OS_CISLO --.xuser --sp.OS_CISLO
  AND z.uznano            = 'N'
  AND dp.prac_zkr         = z.prac_zkr
  AND dp.zkr_predm        = z.zkr_predm
  AND dp.rok_varianty     = z.rok_varianty
  AND dp.dotaidno         = dot.dotaidno
  ))
ORDER BY dot.otevreni