select
    np.prac_zkr_podm as pk_prac_zkr,
    np.zkr_predm_podm as pk_zkr_predm,
    np.AIDNO,
    DECODE(:lang, 'cs', p.cz_nazev, 'sk', p.cz_nazev, NVL(p.AN_NAZEV, p.cz_nazev)) as nazev

from
    np_pod np,
    pred_varianty p

where
    np.PRAC_ZKR = upper(:pracoviste)
    and np.ZKR_PREDM = upper(:zkr_pred)
    and p.PRAC_ZKR = np.PRAC_ZKR_PODM
    and p.ZKR_PREDM = np.ZKR_PREDM_PODM
    and p.ROK_VARIANTY = (
        select
            max(pr.rok_varianty)
        from
            pred_varianty pr
        where
            pr.PRAC_ZKR = np.PRAC_ZKR_PODM
            and pr.ZKR_PREDM = np.ZKR_PREDM_PODM
    )
    
order  by 3, 1, 2