select
    np.prac_zkr_podm as pk_prac_zkr,
    np.zkr_predm_podm as pk_zkr_predm,
    DECODE(?, 'cs', p.cz_nazev, 'sk', p.cz_nazev, NVL(p.AN_NAZEV, p.cz_nazev)) as nazev

from
    np_pod np,
    pred_varianty p

where
    np.aidno = ?
    and p.PRAC_ZKR = np.PRAC_ZKR
    and p.ZKR_PREDM = np.ZKR_PREDM
    and p.ROK_VARIANTY = (
        select
            max(pr.rok_varianty)
        from
            pred_varianty pr
        where
            pr.PRAC_ZKR = np.PRAC_ZKR
            and pr.ZKR_PREDM = np.ZKR_PREDM
        )

order  by 1, 2