SELECT
	DISTINCT RA.UcitIDNO AS PK_UcitIDNO,
	U.Jmeno AS Jmeno,
	U.Prijmeni AS Prijmeni,
  DECODE(:lang, 'cs', C1.RV_Abbreviation, 'sk', C1.RV_Abbreviation, NVL(C1.English, C1.RV_Abbreviation)) AS Titul_Pred,
  DECODE(:lang, 'cs', C2.RV_Abbreviation, 'sk', C2.RV_Abbreviation, NVL(C2.English, C2.RV_Abbreviation)) AS Titul_Za,
  DECODE(U.Titul_Pred, NULL, NULL, C1.RV_Abbreviation||' ') || U.Jmeno || ' ' || U.Prijmeni || DECODE(U.Titul_Za, NULL, NULL,', '||C2.RV_Abbreviation) AS Ucitel

FROM
	Rozvrh_Akce RA,
	Ucitele U,
	CG_Ref_Codes C1,
	CG_Ref_Codes C2

WHERE
	RA.Prac_Zkr = UPPER(:katedra)
	AND RA.Zkr_Predm = UPPER(:zkr_predm)
	AND RA.Rok_Platnosti = :rok
	AND RA.UcitIDNO = U.UcitIDNO
	AND C1.RV_DOMAIN(+) = 'TITUL_PRED'
	AND C1.RV_LOW_VALUE(+) = U.Titul_Pred
	AND C2.RV_DOMAIN(+) = 'TITUL_ZA'
	AND C2.RV_LOW_VALUE(+) = U.Titul_Za

UNION
   
SELECT
	U.UcitIDNO as PK_UcitIDNO,
	U.Jmeno,
	U.Prijmeni,
	DECODE(:lang, 'cs', C1.RV_Abbreviation, 'sk', C1.RV_Abbreviation, NVL(C1.English, C1.RV_Abbreviation)) AS Titul_Pred,
	DECODE(:lang, 'cs', C2.RV_Abbreviation, 'sk', C2.RV_Abbreviation, NVL(C2.English, C2.RV_Abbreviation)) AS Titul_Za,
	DECODE(U.Titul_Pred, NULL, NULL, C1.RV_Abbreviation||' ') || U.Jmeno || ' ' || U.Prijmeni || DECODE(U.Titul_Za, NULL, NULL,', '||C2.RV_Abbreviation) AS Ucitel

FROM
	Ucitele U,
	Ucitele_Predmetu UP,
	CG_Ref_Codes C1,
	CG_Ref_Codes C2

WHERE
	UP.Zkr_Predm = UPPER(:zkr_predm)
	AND UP.Prac_Zkr = UPPER(:katedra)
	AND UP.Rok_Varianty = :rok
	AND U.UcitIDNO = UP.UcitIDNO
	AND C1.RV_Domain(+) = 'TITUL_PRED'
	AND C1.RV_Low_Value(+) = U.Titul_Pred
	AND C2.RV_Domain(+) = 'TITUL_ZA'
	AND C2.RV_Low_Value(+) = U.Titul_Za

