SELECT
       R.osob_idno osoba,
       R.uchazec_idno uchazec,
       U.rod_cislo rod_cislo,
       u.jmeno, u.prijmeni,
       to_char(U.datum_naroz, 'DD.MM.RRRR') datum_naroz,
       SP.fakulta_SP,
       sp.celozivotni_vzdelavani czv,
       (select install2.Fn_Meaning2(SP.fakulta_SP, 'FAKULTA') from dual) fakulta,
       SP.cz_nazev||' ('||SP.cisp_kod||')' program,
       decode(S.oboridno, NULL, K.zkratka, SO.cz_nazev||' ('||SO.cisoboru||'/'||SO.cisspec||')') obor,
       (select install2.Fn_Meaning2(SP.typ, 'TYP_OBORU') from dual) typ,
       (select install2.Fn_Meaning2(SP.forma, 'FORMA_OBORU_NEW') from dual) forma,
       -- body z testu
       DECODE(S.web_body_s, 'A', DECODE(R.bodu,0,'Zatím neuvedeno', to_char(R.bodu)),NULL) bodu_s,
       DECODE(S.web_body_s, 'A', X.bodu_max, NULL) maximum_s,
       DECODE(S.web_body_s, 'A', nvl(to_char(S.hranice_bodu),'Zatím neuvedeno'),NULL) minimum_s,
       -- body ze SS
       DECODE(S.web_body_bez, 'A', DECODE(R.bodu_bez,0,'Zatím neuvedeno', to_char(R.bodu_bez)),NULL) bodu_bez,
       DECODE(S.web_body_bez, 'A', Y.bodu_max, NULL) maximum_bez,
       DECODE(S.web_body_bez, 'A', nvl(to_char(S.hranice_bodu_bez),'Zatím neuvedeno'),NULL) minimum_bez,
       -- vyhovel
       DECODE(S.web_vyhovel_s, 'A', DECODE(S.hranice_bodu,NULL,NULL,DECODE(R.bodu,0,NULL,DECODE(R.vyhovel,'A','ANO','NE'))),NULL) vyhovel_s,
       DECODE(S.web_vyhovel_bez, 'A', DECODE(S.hranice_bodu_bez,NULL,NULL,DECODE(R.bodu_bez,0,NULL,DECODE(R.vyhovel_bez,'A','ANO','NE'))),NULL) vyhovel_bez,
       -- rozhodnuti
       DECODE(S.web_rozhodnuti, 'A', DECODE(R.rektor_rozhodnuti, NULL, DECODE(R.dekan_rozhodnuti,NULL,DECODE(R.komise_rozhodnuti,
       NULL, 'Zatím nerozhodnuto', (select install2.Fn_Meaning2(R.komise_rozhodnuti, 'ROZHODNUTI') from dual)),
      (select  install2.Fn_Meaning2(R.dekan_rozhodnuti, 'ROZHODNUTI') from dual)),(select  install2.Fn_Meaning2(R.rektor_rozhodnuti, 'ROZHODNUTI') from dual)),NULL) rozhodnuti,
       -- termin
       DECODE(S.web_termin, 'A', decode(R.termin_idno,NULL,'Zatím nepridelen',to_char(T.datum,'DD.MM.RRRR')||', '||to_char(T.cas,'HH24:MI')||', '||T.adresa), NULL) termin,
       -- URL zadane fakultou
       S.WEB_URL,
       S.WEB_INFO,
       S.web_body_s zobrazit_poradi,
       -- TODO az bude polozka WEB_ZOBRAZIT_OS_CISLO hotova, odkomentovat!
--       s.WEB_ZOBRAZIT_OS_CISLO WEB_ZOBRAZIT_OS_CISLO,
--       decode(s.WEB_ZOBRAZIT_OS_CISLO, 'A', (select svor.os_cislo from STUDENTI_NA_OBORU_V_ROCE SVOR where svor.uchazec_idno = r.uchazec_idno and rownum <= 1), null) os_cislo
       'A' WEB_ZOBRAZIT_OS_CISLO,
       decode('A', 'A', (select svor.os_cislo from STUDENTI_NA_OBORU_V_ROCE SVOR where svor.uchazec_idno = r.uchazec_idno and rownum <= 1), null) os_cislo
  FROM PR_SPOJOVACI S,
       PR_RIZENI R,
       PR_UCHAZECI U,
       STUDIJNI_PROGRAMY SP,
       OBORY SO,
       KOMBINACE K,
       PR_TERMINY T,
       (SELECT T2.global_idno,
              T2.rok,
              sum(T2.bodu_max) bodu_max
         FROM PR_TESTY T2
        WHERE T2.zapocitavat_s = 'A'
        GROUP BY T2.global_idno,
              T2.rok) X,
       (SELECT T2.global_idno,
              T2.rok,
              sum(T2.bodu_max) bodu_max
         FROM PR_TESTY T2
        WHERE T2.zapocitavat_bez = 'A'
        GROUP BY T2.global_idno,
              T2.rok) Y
 WHERE
   S.rok = to_char(add_months(sysdate, 13-nvl(pg_cti_parametry.CTI_CISLO_FAK('EPR_PRELOM_ROKU', sp.fakulta_sp), 9)), 'RRRR')
   AND R.uchazec_idno = :uchazec_idno
    -- PR_UCHAZEC .. PR_RIZENI
   AND U.osob_idno = R.osob_idno
    -- PR_RIZENI .. PR_SPOJOVACI
   AND R.global_idno = S.global_idno
   AND R.rok = S.rok
    -- PR_SPOJOVACI .. STUDIJNI_PROGRAMY
   AND S.stpridno = SP.stpridno
    -- PR_SPOJOVACI .. OBORY
   AND S.oboridno = SO.oboridno(+)
    -- PR_SPOJOVACI .. KOMBINACE
   AND S.kombidno = K.kombidno(+)
    -- PR_SPOJOVACI .. X
   AND S.global_idno = X.global_idno(+)
   AND S.rok = X.rok(+)
    -- PR_SPOJOVACI .. Y
   AND S.global_idno = Y.global_idno(+)
   AND S.rok = Y.rok(+)
    -- PR_RIZENI .. PR_TERMINY
   AND R.termin_idno = T.termin_idno(+)
 ORDER BY R.uchazec_idno