select
  DECODE(:lang, 'cs', sp.cz_nazev, 'sk', sp.cz_nazev, NVL(sp.an_nazev, sp.cz_nazev)) AS nazevProgramu,
  sp.kodsp_i kod_programu,
  DECODE(:lang, 'cs', o.CZ_NAZEV, 'sk', o.CZ_NAZEV, NVL(o.AN_NAZEV, o.CZ_NAZEV)) AS nazev,
  DECODE(:lang, 'cs', cto.RV_MEANING, 'sk', cto.RV_MEANING, NVL(cto.ENGLISH, cto.RV_MEANING)) AS typ,
  DECODE(:lang, 'cs', cfo.RV_MEANING, 'sk', cfo.RV_MEANING, NVL(cfo.ENGLISH, cfo.RV_MEANING)) AS forma,
  DECODE(:lang, 'cs', o.profil_cz, 'sk', o.profil_cz, NVL(o.profil, o.profil_cz)) AS profil,
  DECODE(:lang, 'cs', o.profil_programu_cz, 'sk', o.profil_programu_cz, NVL(o.profil_programu_an, o.profil_programu_cz)) AS profil_programu,
  DECODE(:lang, 'cs', o.cz_profesni_profily_absolventu, 'sk', o.cz_profesni_profily_absolventu,
    NVL(o.an_profesni_profily_absolventu, o.cz_profesni_profily_absolventu)) AS profesni_profily_absolventu,
  DECODE(:lang, 'cs', o.cz_kvalifikacni_pozadavky, 'sk', o.cz_kvalifikacni_pozadavky,
    NVL(o.an_kvalifikacni_pozadavky, o.cz_kvalifikacni_pozadavky)) AS kvalifikacni_pozadavky,
  sp.forma as fk_forma,
  sp.typ as fk_typ,
  sp.CELOZIVOTNI_VZDELAVANI,
  o.cisoboru,
  o.cisspec,
  o.platny_od,
  o.neplatny_od,
  o.oboridno as pk_oboridno,
  o.FAKULTA_OBORU as fk_fakulta,
  DECODE(:lang, 'cs', o.CZ_ANOTACE, 'sk', o.CZ_ANOTACE, NVL(o.AN_ANOTACE, o.CZ_ANOTACE)) AS anotace,
  o.LIMIT_CRD_OBOR limit_kreditu,
  o.POCET_ETAP,
  o.MAX_DELKA,
  o.STAND_DELKA,
  o.STPRIDNO,
  o.ZKRATKA,
  FN_GET_UCITEL(o.ucitidno_garant) as garant_oboru,
  o.ucitidno_garant,
  FN_GET_UCITEL(o.ucitidno_garant_2) as garant_oboru_2,
  o.ucitidno_garant_2
from
  obory o,
  cg_ref_codes cfo,
  cg_ref_codes cto,
  studijni_programy sp
where
  sp.stpridno = :stpridno
  and  cfo.rv_domain = 'FORMA_OBORU_NEW'
  and  sp.forma = cfo.rv_low_value
  and  cto.rv_domain = 'TYP_OBORU'
  and  sp.typ = cto.rv_low_value
  and  o.stpridno=sp.stpridno
  and  ((nvl(o.neplatny_od,'2050')> :rok) and (nvl(o.platny_od,'1970')<=:rok))
order  by
    cisoboru,
    cisspec,
    DECODE(:lang, 'cs', sp.cz_nazev, 'sk', sp.cz_nazev, NVL(sp.an_nazev, sp.cz_nazev)),
    DECODE(:lang, 'cs', cto.RV_MEANING, 'sk', cto.RV_MEANING, NVL(cto.ENGLISH, cto.RV_MEANING)),
    DECODE(:lang, 'cs', cfo.RV_MEANING, 'sk', cfo.RV_MEANING, NVL(cfo.ENGLISH, cfo.RV_MEANING))