select /*+ FIRST_ROWS */ * from (
select /*+ FIRST_ROWS */ rownum as poradi, x.* from
(select /*+ FIRST_ROWS
@IF(0)   ORDERED
*/
	distinct s.os_cislo, o.jmeno, o.prijmeni,
         c1.rv_abbreviation AS titul_pred, c2.rv_abbreviation AS titul_za,
         sp.fakulta_sp, sp.kodsp_i,
         LOWER ((SELECT fn_meaning2 (s.stav, 'STAV_STUDENTA')
                   FROM DUAL)) stav, max(svor.standard_rok) as standard_rok,
         (SELECT fn_meaning (sp.typ, 'TYP_OBORU') FROM DUAL) typ, sp.forma,
         (select  fn_meaning(svor.misto_vyuky, 'MISTO_VYUKY') from dual) misto,
         sp.celozivotni_vzdelavani,
         fn_vsechny_obko(s.os_cislo,svor.rok_platnosti) as obor_komb
    FROM
@IF(1)      studenti s, osoby o,
@IFNOT(1)   osoby o, studenti s,
         studijni_programy sp,
         studenti_v_roce svor,
         studenti_na_oboru_v_roce snor,
         studijni_plany stpl,obory ob,
         kombinace k,
         cg_ref_codes c1,
         cg_ref_codes c2
    WHERE o.osobidno = s.osobidno
     AND s.stpridno = sp.stpridno
     AND s.os_cislo = svor.os_cislo
     AND stpl.oboridno = ob.oboridno
     AND snor.stplidno = stpl.stplidno
     AND snor.os_cislo = svor.os_cislo
     AND snor.rok_platnosti = svor.rok_platnosti
     AND k.kombidno(+) = svor.kombidno
     AND svor.rok_platnosti like nvl(:xrok_platnosti,'%')
     AND sp.fakulta_sp LIKE NVL (upper(:p_fak_sp), '%')
     AND sp.kodsp_i LIKE NVL (:p_stud_program, '%')
     AND sp.forma LIKE NVL (:p_forma, '%')
     AND sp.typ LIKE NVL (:p_typ, '%')
     AND ob.cisoboru LIKE NVL (:p_obor, '%')
     AND Svor.misto_vyuky like nvl(:p_misto,'%')
     AND nvl(Svor.KROUZEK_A,'%') like nvl(:p_studijni_krouzek,'%')
     AND nvl(Svor.SKUPINA_A,'%') like nvl(:p_studijni_skupina,'%')
     AND (k.zkratka IS NULL OR k.zkratka LIKE NVL (:p_kombinace, '%'))
     and s.stav like nvl(:xstav,'%')
     and (select FN_CS_TO_UPPER_ASC(o.prijmeni) from dual) LIKE (select FN_CS_TO_UPPER_ASC(:prijmeni) from dual)
     and (select FN_CS_TO_UPPER_ASC(o.jmeno) from dual) LIKE (select FN_CS_TO_UPPER_ASC(:jmeno) from dual)
     and s.os_cislo like nvl(upper(:xos_cislo),'%')
     and svor.standard_rok between nvl(:rocnik_od,1) and nvl(:rocnik_do,99)
     AND c1.rv_domain(+) = 'TITUL_PRED'
     AND c1.rv_low_value(+) = o.titul_pred
     AND c2.rv_domain(+) = 'TITUL_ZA'
     AND c2.rv_low_value(+) = o.titul_za
     group by s.os_cislo, o.jmeno, o.prijmeni,
         c1.rv_abbreviation, c2.rv_abbreviation,
         sp.fakulta_sp, sp.kodsp_i,
         s.stav,
         sp.typ , sp.forma,
         svor.misto_vyuky,
         sp.celozivotni_vzdelavani,
         fn_vsechny_obko(s.os_cislo,svor.rok_platnosti)
 order by NLSSORT(prijmeni, 'NLS_SORT = XCZech'),NLSSORT(jmeno, 'NLS_SORT = XCZech')
) x
where rownum <= nvl(:do,51)
) y
where y.poradi >= nvl(:od,0)