select /*+ FIRST_ROWS */ * from (
select /*+ FIRST_ROWS */ rownum as poradi, x.* from
(select /*+ FIRST_ROWS */
		 case
		 when t.platnost='N' then 'Z' -- zrusene
		 when fn_zive_datum(t.datum,t.hod_do)=1 then 'A' -- aktualni
		 else 'P' -- prosle
		 end barva,
		 t.platnost,
		 t.limit_terminu as limit,
		 t.obsazeni_terminu as obsazeni,
		 decode(t.limit_terminu,null,null,0,null,round(((t.obsazeni_terminu/t.limit_terminu)*100),2)) as obsazeni_procentuelne,
		 t.datum,
		 to_char(t.hod_od,'HH24:MI') as hod_skut_od,
		 to_char(t.hod_do,'HH24:MI') as hod_skut_do,
		 t.blok_datum,
		 DECODE(:lang, 'cs', p.cz_nazev, 'sk', p.cz_nazev, NVL(p.an_nazev, p.cz_nazev)) AS nazev,
		 t.zkr_budovy||'-'||t.cislo_mist AS mistnost,
		 nvl(t.semestr,'ZL') as semestr,
		 t.OPRAVNY_TERMIN,
		 decode(:lang,'cs',(select fn_meaning2(t.opravny_termin,'TERMINY_KDO') from dual),'sk',(select fn_meaning2(t.opravny_termin,'TERMINY_KDO') from dual),nvl((select fn_meaning_en(t.opravny_termin,'TERMINY_KDO') from dual),(select fn_meaning2(t.opravny_termin,'TERMINY_KDO') from dual))) as TERMIN_KDO_SLOVNE,
		 case when :lang in ('cs','sk') then
		 (select (select fn_meaning2(t.TYP_TERMINU,'TYP_TERMINU') from dual) from dual)
		 else
		 (select (select fn_meaning_en(t.TYP_TERMINU,'TYP_TERMINU') from dual) from dual)
		 end typ,
		 (select fn_meaning(t.TYP_TERMINU,'TYP_TERMINU') from dual) typ_zkr,
		 (select fn_get_ucitel(t.ucitidno,'JP') from dual) as ucitel,
t.prac_zkr||'/'||t.zkr_predm as predm,
t.termidno,
t.grteidno
from terminy t, pred_varianty p,ucitele u
where
@IF(0) t.termidno = :termidno and
--t.PRAC_ZKR like nvl(upper(.zkr_prac),'%')
--translate(t.prac_zkr,'ÁČĎÉĚÍÓŘŠŤŮÚÝŽŇ','ACDEEIORSTUUYZN') LIKE translate(nls_upper(ltrim(rtrim(nvl(.zkr_prac,'%'))),'NLS_SORT = XCzech'), 'ÁČĎÉĚÍÓŘŠŤŮÚÝŽŇ*','ACDEEIORSTUUYZN%')
(select FN_CS_TO_UPPER_ASC(t.prac_zkr) from dual) LIKE (select FN_CS_TO_UPPER_ASC(:zkr_prac) from dual)
				 --and t.ZKR_PREDM like nvl(upper(.zkr_predm),'%')
--and translate(t.ZKR_PREDM,'ÁČĎÉĚÍÓŘŠŤŮÚÝŽŇ','ACDEEIORSTUUYZN') LIKE translate(nls_upper(ltrim(rtrim(nvl(.zkr_predm,'%'))),'NLS_SORT = XCzech'), 'ÁČĎÉĚÍÓŘŠŤŮÚÝŽŇ*','ACDEEIORSTUUYZN%')
and (select FN_CS_TO_UPPER_ASC(t.ZKR_PREDM) from dual) LIKE (select FN_CS_TO_UPPER_ASC(:zkr_predm) from dual)
				 and t.ROK_PLATNOSTI like nvl(:xrok,'%')
				 and (
				    (t.semestr = 'ZS' and (nvl(:semestr,'%') in ('%','ZS','ZSaZSLS')))
                    or
                    (t.semestr = 'LS' and (nvl(:semestr,'%') in ('%','LS','LSaZSLS')))
                    or
                    (nvl(t.semestr,'ZL') = 'ZL' and (nvl(:semestr,'%') in ('%','ZSLS','LSaZSLS','ZSaZSLS')))
                 )   

				 /*
				 and ( (t.semestr is null and .xsemestr is null) or
				       (nvl(t.semestr,'%') like .xsemestr)
				 )
				 */
				 and upper(t.zkr_budovy||'-'||t.cislo_mist) like nvl(upper(:xmistnost)  ,'%')
@IF(1) and t.datum = :xdatum
				 and t.opravny_termin like nvl(:xopr_termin,'%')
				 --and upper(u.prijmeni) like nvl(upper(.prijmeni),'%')
				 --and translate(nls_upper(u.prijmeni,'NLS_SORT = XCzech'),'ÁČĎÉĚÍÓŘŠŤŮÚÝŽŇ','ACDEEIORSTUUYZN') LIKE translate(nls_upper(ltrim(rtrim(nvl(.prijmeni,'%'))),'NLS_SORT = XCzech'), 'ÁČĎÉĚÍÓŘŠŤŮÚÝŽŇ*','ACDEEIORSTUUYZN%')
                 and FN_CS_TO_UPPER_ASC(u.prijmeni) LIKE (select FN_CS_TO_UPPER_ASC(:prijmeni) from dual)
				 and t.ucitidno = u.ucitidno
				 and t.ucitidno like nvl(to_char(:xucitidno),'%')
				 and t.platnost like nvl(:platnost,'%')
				 and p.ZKR_PREDM = t.ZKR_PREDM
				 and p.PRAC_ZKR = t.PRAC_ZKR
				 and p.ROK_VARIANTY = t.ROK_PLATNOSTI
				 and t.typ_terminu like nvl(:typ_terminu,t.typ_terminu)
@IF(2) and fn_zive_datum(t.datum,t.hod_do) >=0
@IFNOT(2) and fn_zive_datum(t.datum,t.hod_do) =1
				 -- terminy aktualniho akad. roku, vzdy ale nejmene 30 dni zpatky
				/*and ((t.datum in (select datum from kalendar where rok_platnosti = (select rok_platnosti from kalendar where datum=trunc(sysdate))) or
										t.datum > trunc(sysdate)-30))*/
order by
		 t.datum desc,
		 to_char(t.hod_od,'HH24:MI') asc,
		 t.prac_zkr, t.zkr_predm, t.semestr desc) x
where rownum <= nvl(:do,51)) y
where y.poradi >= nvl(:od,0)
