SELECT
 u.JMENO,
 u.PRIJMENI,
 u.TELEFON,
 u.EMAIL,
 u.URL,
 u.PRAC_ZKR,
 u.ZKR_BUDOVY,u.CISLO_MIST,
 u.ZKR_BUDOVY||'-'||u.CISLO_MIST as mistnost,
 DECODE(:lang, 'cs', p1.NAZEV, 'sk', p1.NAZEV, NVL(p1.an_nazev, p1.NAZEV)) AS nazev,
 fn_vsechna_prac(u.ucitidno) dalsi_prac,
 DECODE(u.TITUL_PRED, NULL, NULL, c1.RV_ABBREVIATION||' ')||u.JMENO||' '||u.PRIJMENI||DECODE(u.TITUL_ZA, NULL, NULL,', '||c2.RV_ABBREVIATION) as ucitel,
 DECODE(:lang, 'cs', c1.RV_ABBREVIATION, 'sk', c1.RV_ABBREVIATION, NVL(c1.english, c1.RV_ABBREVIATION)) AS titul_pred,
 DECODE(:lang, 'cs', c2.RV_ABBREVIATION, 'sk', c2.RV_ABBREVIATION, NVL(c2.english, c2.RV_ABBREVIATION)) AS titul_za,
 p1.nad_prac_zkr AS nad_prac_zkr,
 DECODE(:lang, 'cs', p2.NAZEV, 'sk', p2.NAZEV, NVL(p2.an_nazev, p2.NAZEV)) AS nad_prac_nazev
FROM
 ucitele u,
 cg_ref_codes c1,
 cg_ref_codes c2,
 CIS_PRACOVIST p1,
 cis_pracovist p2
WHERE
 u.ucitidno=:ucitidno
 AND c1.RV_DOMAIN(+) = 'TITUL_PRED'
 AND c1.RV_LOW_VALUE(+) = u.TITUL_PRED
 AND c2.RV_DOMAIN(+) = 'TITUL_ZA'
 AND c2.RV_LOW_VALUE(+) = u.TITUL_ZA
 AND p1.ZKR(+) = u.PRAC_ZKR
 AND p2.ZKR(+) = p1.NAD_PRAC_ZKR
 order by 2,1
