select
  distinct
  pv.zkr_predm,
  pv.prac_zkr,
  pv.cz_nazev,
  pv.an_nazev,
  pv.vicezapis,
  pv.TYP_ZK,
  pv.VYUKA_ZS,
  pv.VYUKA_LS,
  pv.CRD as kredity,
  nvl(pv.jednotek_pr,'0')||'-'||nvl(pv.jednotek_cv,'0')||'-'||nvl(pv.jednotek_sem,'0') as jednotky,
  nvl(to_char(bp.DOPORSEM),'X') as semestr,
  nvl(to_char(bp.DOPORROC),'X') as rocnik,
  bp.BLOKIDNO,
  spl.STPLIDNO,
  b.STATUT,
  bp.ROK_VARIANTY,
  DECODE(:lang, 'cs', c1.RV_MEANING, 'sk', c1.RV_MEANING, NVL(c1.ENGLISH, c1.RV_MEANING)) as typzk
from

  studijni_plany spl,
  poradi_segmentu ps,
  segmenty_st_planu sp,
  skupiny_segmentu ss,
  bloky b,
  bloky_predm bp,
  pred_varianty pv,
  cg_ref_codes c1
where
  spl.stplidno = :stplidno
  and ps.STPLIDNO = spl.STPLIDNO
  and ps.SESPIDNO = sp.SESPIDNO
  and ss.STPLIDNO(+) = ps.STPLIDNO
  and ss.SESPIDNO(+) = ps.SESPIDNO
  and b.SESPIDNO = sp.SESPIDNO
  and bp.BLOKIDNO = b.BLOKIDNO
  and pv.prac_zkr = bp.prac_zkr
  and pv.zkr_predm = bp.zkr_predm
  and pv.rok_varianty = bp.rok_varianty
  and  pv.typ_zk = c1.rv_low_value
  and  c1.rv_domain = 'TYP_ZK_NEW'
 ORDER BY DECODE (rocnik, 'X', '99', rocnik),
         DECODE (semestr, 'ZS', '1', 'LS', '2', '3'),
         statut, prac_zkr, zkr_predm, blokidno
