SELECT
    ID_NAME as stag_username,
	ID_ROLE,
	DECODE(:lang,'cs',(select fn_meaning2(id_role,'ROLE') from dual),'sk',(select fn_meaning2(id_role,'ROLE') from dual),nvl((select fn_meaning_en(id_role,'ROLE') from dual),(select fn_meaning2(id_role,'ROLE') from dual))) as role,
    ucitidno,
    id_katedra,
    id_fakulta,
    aktivni,
    'N' as evaluacni_role,
    'N' as zastupujici_eva_role,
    decode(ID_ROLE,'VY',1,2) as poradi_role,
  nvl(fn_account_locked(id_name),'N') as konto_locked

FROM
    id_table2

WHERE ucitidno = :ucitidno
  AND aktivni = 'A'
  AND id_role in ('VY','KA','SR', 'EI', 'EP', 'FR', 'FS', 'UR', 'FA','PR','EV','RP', 'AD', 'ZS')
union
select
    null,
    'PR' as id_role,
    'EVA-PROREKTOR' as role,
    erl.UCITIDNO,
    null,
    null,
    'A',
    'A' as evaluacni_role,
    'N' as zastupujici_eva_role,
    2 as poradi_role,
    'N' as konto_locked
from
        eva_role erl,
        eva_role_pristup erp
      where
        erl.ucitidno = :ucitidno
        and erl.role_uzivatele = 'PROREKTOR'
        and erp.uzroidno =  erl.uzroidno
union
select
     null,
    'DE' as id_role,
    'EVA-DĚKAN' as role,
    cp.UCITIDNO,
    cp.zkr as id_katedra,
    cp.zkr as id_fakulta,
    'A',
    'A' as evaluacni_role,
    'N' as zastupujici_eva_role,
    2 as poradi_role,
    'N' as konto_locked
       from
        cg_ref_codes cg,
        cis_pracovist cp
       where
        cg.rv_domain = 'FAKULTA'
        and cg.rv_abbreviation = cp.zkr
        and cp.ucitidno = :ucitidno
        and cp.typ_prac = 'F'
union
select
    null,
    'DE' as id_role,
    'EVA-ZASTUPUJÍCÍ DĚKAN' as role,
    erl.UCITIDNO,
    erp.hodnota as id_katedra,
    erp.hodnota as id_fakulta,
    'A',
    'A' as evaluacni_role,
    'A' as zastupujici_eva_role,
    2 as poradi_role,
    'N' as konto_locked
      from
        eva_role erl,
        eva_role_pristup erp
      where
        erl.ucitidno = :ucitidno
        and erl.role_uzivatele = 'DEKAN'
        and erp.uzroidno =  erl.uzroidno
union
select
    null,
    'VK' as id_role,
    'EVA-VEDOUCÍ KATEDRY' as role,
    cp.UCITIDNO,
    cp.zkr as id_katedra,
    null,
    'A',
    'A' as evaluacni_role,
    'N' as zastupujici_eva_role,
    2 as poradi_role,
    'N' as konto_locked
    from cis_pracovist cp
     where cp.ucitidno = :ucitidno
        and cp.typ_prac = 'K'
union
select
    null,
    'VK' as id_role,
    'EVA-ZASTUPUJÍCÍ VEDOUCÍ KATEDRY' as role,
    erl.UCITIDNO,
    erp.hodnota as id_katedra,
    null,
    'A',
    'A' as evaluacni_role,
    'A' as zastupujici_eva_role,
    2 as poradi_role,
    'N' as konto_locked
      from
        eva_role erl,
        eva_role_pristup erp
      where
        erl.ucitidno = :ucitidno
        and erl.role_uzivatele = 'VEDOUCI_KATEDRY'
        and erp.uzroidno =  erl.uzroidno
ORDER BY evaluacni_role desc,poradi_role, id_role , id_katedra

