select distinct
  uc_roakce.priorita priorita,
@IFNOT(0)  min(k.datum) over (partition by ra.roakidno) as datum_od, max(k.datum) over (partition by ra.roakidno) as datum_do, null as datum,
@IF(0) null as datum_od, null as datum_do, k.datum as datum,
  decode(ra.den, 'Po', 1, 'Út', 2, 'St', 3, 'Čt', 4, 'Pá', 5, 'So', 6, 'Ne', 7, 8) den_poradi,
  ra.semestr, ra.roakidno, ra.skut_hod_od, to_number(to_char(ra.skut_hod_od,'HH24MI')) skut_hod_od_number,
  ra.prac_zkr, ra.zkr_predm, ra.rok_varianty, ra.rok_platnosti, ra.casova_rada, ra.den,
  ra.hod_vyuc_od, ra.hod_vyuc_do, ra.hod_od, ra.hod_do, ra.skut_hod_do, ra.tyden, ra.tyden_od,
  ra.tyden_do, ra.zkr_budovy, ra.cislo_mist, ra.grupidno, ra.je_nadrazena, ra.ma_nadrazenou, ra.plan, ra.obsazeni,
  ra.kontakt, ra.poznamka, ra.url, ra.vyuc_jazyk, ra.platnost, ra.typakce,
  (select to_char(wm_concat(replace(ka.kod, ',', '`'))) from krouzek_akce ka where ka.roakidno = ra.roakidno) x_krouzky,
  m.KAPACITA kapacita_mist,
  u.ucitidno as ucitel_ucitidno,
  u.jmeno as ucitel_jmeno,
  u.prijmeni as ucitel_prijmeni,
  u.titul_pred as ucitel_titul_pred,
  u.titul_za as ucitel_titul_za,
  'R' as druh_akce,
@IF(2)  (select count(*) from dop_mist_pro_ra dm where dm.roakidno = ra.roakidno) as pocetDoporucenychMistnostiAkce,
@IF(2)  FN_SEZNAM_DOP_MIST(ra.roakidno, null, null, null, null, null, 'cs') as doporuceneMistnostiAkce,
  pv.cz_nazev nazevPredmetuCs,
  pv.an_nazev nazevPredmetuEn
from
  rozvrh_akce ra,
  ucitele u,
  pred_varianty pv,
  mistnosti m,
  kalendar k,
  (select 0 priorita, ra2.roakidno, ra2.ucitidno from rozvrh_akce ra2
   union
   select 1 priorita, uc.roakidno, uc.ucitidno from uc_rozvrhove_akce uc) uc_roakce
where
       ra.prac_zkr like :prac_zkr
  and  ra.zkr_predm like :zkr_predm
  and  ra.rok_platnosti = :rok
  and  ra.semestr like nvl(translate(UPPER(:semestr), '*', '%'), '%')
@IFNOT(1)  and  ra.platnost <> 'Z'
  and  uc_roakce.roakidno(+) = ra.roakidno
  and  uc_roakce.ucitidno = u.ucitidno(+)
  and  pv.prac_zkr = ra.prac_zkr
  and  pv.zkr_predm = ra.zkr_predm
  and  pv.rok_varianty = ra.rok_varianty
  and  m.ZKR_BUDOVY(+) = ra.zkr_budovy
  and  m.cislo_mist(+) = ra.cislo_mist
  and  k.rok_platnosti(+)=ra.rok_platnosti
  AND  k.typ_rozvrh_dne(+)=ra.semestr
  and  decode(ra.tyden, 'J', k.typ_tydne(+), 'K', k.typ_tydne(+), ra.tyden) = k.typ_tydne(+)
  AND  decode(k.cislo_tydne(+),1,54,2,55,3,56,4,57,k.cislo_tydne(+)) BETWEEN decode(ra.tyden_od,1,54,2,55,3,56,4,57,ra.tyden_od) and decode(ra.tyden_do,1,54,2,55,3,56,4,57,ra.tyden_do)
  AND  k.rozvrh_den(+)=ra.den
  AND  k.rozvrh_den(+) NOT IN ('Rv','Sv')
order by
@IFNOT(0) 6 desc, 5, 2, 9,   -- pokud nevracim vsechny vyskyty akce: semestr, den v tydnu, prvni datum akce, cas zacatku
@IF(0) 4, 9,         -- pokud vracim vsechny vyskyty akce: datum, cas zacatku
  10, 11,            -- katedra, zkratka predmetu
  7,                 -- roakidno
  1                  -- priorita (kdyz je vice ucitelu)
