select
  ra.*,
  m.KAPACITA kapacita_mist,
  u.ucitidno as ucitel_ucitidno,
  u.jmeno as ucitel_jmeno,
  u.prijmeni as ucitel_prijmeni,
  u.titul_pred as ucitel_titul_pred,
  u.titul_za as ucitel_titul_za,
  (select min(cp.DATUM) from casoprostor cp where cp.ROAKIDNO = RA.ROAKIDNO) as datum_od,
  (select max(cp.DATUM) from casoprostor cp where cp.ROAKIDNO = RA.ROAKIDNO) as datum_do,
  (select to_char(wm_concat(replace(ka.kod, ',', '`'))) from krouzek_akce ka where ka.roakidno = ra.roakidno) x_krouzky,
  null as datum,
  'R' as druh_akce,
  pv.cz_nazev nazevPredmetuCs,
  pv.an_nazev nazevPredmetuEn
from
  rozvrh_akce ra,
  ucitele u,
  pred_varianty pv,
  mistnosti m,
  (select 0 priorita, ra2.roakidno, ra2.ucitidno from rozvrh_akce ra2
   union
   select 1 priorita, uc.roakidno, uc.ucitidno from uc_rozvrhove_akce uc) uc_roakce
where
       uc_roakce.roakidno(+) = ra.roakidno
  and  uc_roakce.ucitidno = u.ucitidno(+)
  and  pv.prac_zkr = ra.prac_zkr
  and  pv.zkr_predm = ra.zkr_predm
  and  pv.rok_varianty = ra.rok_varianty
  and  m.ZKR_BUDOVY(+) = ra.zkr_budovy
  and  m.cislo_mist(+) = ra.cislo_mist
  and  ra.prac_zkr like nvl(:pracZkr, '%')
  and  ra.zkr_predm like nvl(:zkrPredm, '%')
  and  ra.zkr_budovy like nvl(:zkrBudovy, '%')
  and  ra.cislo_mist like nvl(:cisloMistnosti, '%')
  and  ra.den like nvl(:den, '%')
  and  ra.rok_varianty like nvl(:rokVarianty, '%')
  and  ra.semestr like nvl(:semestr, '%')
  and  ra.typakce like nvl(:typ, '%')
  and  ra.owner like nvl(upper(:owner), '%')
  and  ra.platnost like nvl(:platnost, '%')
--@IF(0)  and  (ra.ucitidno = :ucitIdno or exists (select 1 from uc_rozvrhove_akce ra2 where ra2.roakidno = ra.roakidno and ra2.ucitidno = :ucitIdno) )
order by
  ra.rok_varianty, ra.semestr, ra.prac_zkr, ra.zkr_predm, ra.den, ra.skut_hod_od,
  ra.roakidno,
  uc_roakce.priorita