select
    'S' as typ,
    s.OS_CISLO,
    os.jmeno,
    os.PRIJMENI,
    (select fn_meaning(os.TITUL_PRED,'TITUL_PRED') from dual) as titul_pred,
    (select fn_meaning(os.TITUL_ZA,'TITUL_ZA') from dual) as titul_za
from
    zapisy z,
    studenti s,
    osoby os
where
    z.ROAKIDNO = :roakidno
    and z.ROK_PLATNOSTI = :rok_zapisu
    and z.OS_CISLO = s.OS_CISLO
    and s.OSOBIDNO = os.OSOBIDNO
union
select
    'U' as typ,
    null as os_cislo,
    uc.JMENO,
    uc.PRIJMENI,
    (select fn_meaning(uc.TITUL_PRED,'TITUL_PRED') from dual) as titul_pred,
    (select fn_meaning(uc.TITUL_ZA,'TITUL_ZA') from dual) as titul_za
from
    rozvrh_akce ra,
    ucitele uc
where
    ra.ROAKIDNO = :roakidno
    and ra.UCITIDNO = uc.UCITIDNO
union
select
    'U' as typ,
    null as os_cislo,
    uc.JMENO,
    uc.PRIJMENI,
    (select fn_meaning(uc.TITUL_PRED,'TITUL_PRED') from dual) as titul_pred,
    (select fn_meaning(uc.TITUL_ZA,'TITUL_ZA') from dual) as titul_za
from
    rozvrh_akce ra,
    uc_rozvrhove_akce ucx,
    ucitele uc
where
    ra.ROAKIDNO = :roakidno
    and ra.UCITIDNO = ucx.UCITIDNO
    and uc.UCITIDNO = ucx.UCITIDNO
order by
typ desc, prijmeni, jmeno
