select
	DECODE(:lang, 'cs', pv.CZ_NAZEV, 'sk', pv.CZ_NAZEV, NVL(pv.AN_NAZEV, pv.CZ_NAZEV)) AS nazev,
	ra.PRAC_ZKR as fk_prac_zkr,
	ra.ZKR_PREDM as fk_zkr_predm,
	ra.ROK_VARIANTY as fk_rok_varianty,
	ra.CISLO_MIST as fk_cislo_mist,
	ra.ZKR_BUDOVY as fk_zkr_budovy,
	ra.PLAN, ra.OBSAZENI,
	ra.TYPAKCE as zkr_typakce,
	ra.SEMESTR,
	ra.PLATNOST,
    ra.den as den_zkr,
  ra.hod_od,
  ra.hod_do,
	ra.HOD_VYUC_OD,
	ra.HOD_VYUC_DO,
	ra.skut_hod_od as HOD_SKUT_OD,
	ra.skut_hod_do as HOD_SKUT_DO,
	DECODE(:lang, 'cs', c1.RV_MEANING, 'sk', c1.RV_MEANING, NVL(c1.ENGLISH, c1.RV_MEANING)) AS typakce,
	ra.TYDEN_OD,
	ra.TYDEN_DO,
	ra.TYDEN as zkr_tyden,
	DECODE(:lang, 'cs', c2.RV_MEANING, 'sk', c2.RV_MEANING, NVL(c2.ENGLISH, c2.RV_MEANING)) AS tyden,
	DECODE(:lang, 'cs', c3.RV_MEANING, 'sk', c3.RV_MEANING, NVL(c3.ENGLISH, c3.RV_MEANING)) AS den,
	c3.PORADI AS den_poradi,
	ra.GRUPIDNO,
	ra.POZNAMKA,
	ra.ROAKIDNO as PK_ROAKIDNO,
    u.ucitidno as ucitidno,
    decode(u.TITUL_PRED, null, null, c4.RV_ABBREVIATION||' ')||u.JMENO||' '||u.PRIJMENI||decode(u.TITUL_ZA, null, null,', '||c5.RV_ABBREVIATION) as ucitel,
    u.PRIJMENI||' '||u.JMENO ucitel_pom,
    u.PRIJMENI as ucitel_prijmeni,
    ra.TYDEN as FK_TYDEN,
    ra.JE_NADRAZENA as JE_NADRAZENA,
    ra.MA_NADRAZENOU as MA_NADRAZENOU,
    ra.casova_rada,
    (select min(cp.DATUM) from casoprostor cp where cp.ROAKIDNO = RA.ROAKIDNO) as datum_od,
    (select max(cp.DATUM) from casoprostor cp where cp.ROAKIDNO = RA.ROAKIDNO) as datum_do,
    'R' as druh_akce,
    ra.ROK_PLATNOSTI,
    ra.kontakt
 from
	rozvrh_akce ra,
	pred_varianty pv,
	mistnosti m,
	cg_ref_codes c1,
	cg_ref_codes c2,
	cg_ref_codes c3,
    ucitele u,
    cg_ref_codes c4,
    cg_ref_codes c5,
    (select 0 priorita, ra2.roakidno, ra2.ucitidno from rozvrh_akce ra2
     union
     select 1 priorita, uc.roakidno, uc.ucitidno from uc_rozvrhove_akce uc) uc_roakce
where
	pv.ZKR_PREDM = ra.ZKR_PREDM
	and pv.PRAC_ZKR = ra.PRAC_ZKR
	and pv.ROK_VARIANTY = ra.ROK_VARIANTY
	and m.CISLO_MIST(+) = ra.CISLO_MIST
	and m.ZKR_BUDOVY(+) = ra.ZKR_BUDOVY
	and c1.RV_DOMAIN = 'TYP_AKCE'
	and c1.RV_LOW_VALUE = ra.TYPAKCE
	and c2.RV_DOMAIN(+) = 'TYDEN'
	and c2.RV_LOW_VALUE(+) = ra.TYDEN
	and c3.RV_DOMAIN(+) = 'DEN'
	and c3.RV_LOW_VALUE(+) = ra.DEN
    and  c4.RV_DOMAIN(+) = 'TITUL_PRED'
    and  c4.RV_LOW_VALUE(+) = u.TITUL_PRED
    and  c5.RV_DOMAIN(+) = 'TITUL_ZA'
    and  c5.RV_LOW_VALUE(+) = u.TITUL_ZA
    and  uc_roakce.roakidno(+) = ra.roakidno
    and  uc_roakce.ucitidno = u.ucitidno(+)
@IF(0) and ra.PRAC_ZKR like upper(:katedra)
@IF(1) and ra.ZKR_PREDM like upper(:predmet)
@IF(2) and ra.ROK_VARIANTY like  (:rok)
@IF(3) and ra.SEMESTR like upper(:semestr)
@IF(4) and upper(ra.TYPAKCE) like upper(:typakce)
@IF(5) and ra.PLATNOST = 'A'
@IF(6) and ra.grupidno = :grupidno
order by
	ra.ROK_PLATNOSTI,
	ra.PRAC_ZKR,
	ra.ZKR_PREDM,
	ra.SEMESTR,
	ra.TYPAKCE,
	c3.Poradi,
	ra.HOD_VYUC_OD,
	ra.roakidno,
	uc_roakce.priorita