SELECT
  ra.PRAC_ZKR as fk_prac_zkr,
  ra.ZKR_PREDM as fk_zkr_predm,
  ra.rok_varianty as fk_rok_varianty,
  ra.rok_platnosti as rok_platnosti,
  ra.roakidno,
  ra.roakidno as pk_roakidno,
  ra.semestr,
  (select fn_meaning(ra.typakce,'TYP_AKCE') from dual) as typakce,
  ra.typakce as fk_typakce,
  ra.typakce as zkr_typakce,
  ra.grupidno,
  ra.ma_nadrazenou,
  ra.je_nadrazena,
  --toto volani nejde vyhodi do aplikacni cache. Slozite prepocitavani pri zmene (napr. grupy).
  (select fn_ma_zapis(:os_cislo, :rok_platnosti, ra.roakidno) from dual) AS ma_zapis,
  substr(DECODE(:lang, 'cs', cg1.rv_meaning, 'sk', cg1.rv_meaning, NVL(cg1.english, cg1.rv_meaning)),1,2) AS den,
  cg1.poradi as den_poradi,
  ra.den as den_zkr,
  ra.tyden,
  ra.tyden_od,
  ra.tyden_do,
  ra.hod_od,
  ra.hod_do,
  ra.skut_hod_od,
  ra.skut_hod_do,
  ra.hod_vyuc_od,
  ra.hod_vyuc_do,
  ra.zkr_budovy,
  ra.cislo_mist,
  ra.zkr_budovy as fk_zkr_budovy,
  ra.cislo_mist as fk_cislo_mist,
  ra.casova_rada,
  ra.plan,
  ra.obsazeni,
  ra.kontakt,
  uc.prijmeni AS vyuc_prijmeni,
  uc.UCITIDNO AS UCITIDNO,
  ra.poznamka,
  ra.skraidno,
  nvl((select fn_get_ucitel(ra.ucitidno) from dual),'-') vyuc,
--  nvl((select fn_get_ucitel(ra.ucitidno) from dual),'-') UCITEL,
  ra.PLATNOST,
  --fn_ra_pristupna velmi zvysi narocnost celeho selectu. Proto se to pocita na urovni aplikace.
  -- Jo a proto je kurva schovana za IFem aby ti nezavazela v predzapisu!!! Burza RA tam tohle potrebuje.
--@IF(0)  (select fn_ra_pristupna_zapsana(ra.roakidno,:os_cislo) from dual) as pristupna,
  DECODE(:lang, 'cs', pv.CZ_NAZEV, 'sk', pv.CZ_NAZEV, NVL(pv.AN_NAZEV, pv.CZ_NAZEV)) AS nazev

FROM
  rozvrh_akce ra
  LEFT JOIN cg_ref_codes cg1
  ON (ra.den = cg1.rv_low_value AND cg1.rv_domain = 'DEN')
  LEFT JOIN ucitele uc
  ON (ra.ucitidno = uc.ucitidno)
  LEFT JOIN 	pred_varianty pv
  ON (pv.ZKR_PREDM = ra.ZKR_PREDM and pv.PRAC_ZKR = ra.PRAC_ZKR and pv.ROK_VARIANTY = ra.ROK_VARIANTY)
WHERE
  ra.prac_zkr = :prac_zkr
  AND ra.zkr_predm = :zkr_predm
  AND ra.rok_varianty = :rok_varianty
  AND ra.rok_platnosti = :rok_platnosti
  --prehozeno do aplikacni logiky
--@IF(0) AND ra.SEMESTR != nvl((select pg_cti_parametry.cti_retezec_oc('NEPOVOLIT_PREDZAPIS',:os_cislo) from dual), 'XX')
  and ra.semestr like :semestr
  AND (ra.platnost = 'A' OR (ra.platnost='Z'))
  AND (ra.plan is null or ra.plan > 0)
  
ORDER BY
	ra.semestr DESC,
	ra.typakce DESC,
	cg1.poradi,
	ra.hod_vyuc_od,
	ra.hod_vyuc_do,
	ra.tyden