-- ToR - náš student vyjiždějící ven
-- zakladní data
SELECT 'A' as nas_student,
       CGORG.ENGLISH as sending_institution,
       'Czech Republic' as sending_institution_country,
       CP.AN_NAZEV as sending_department,
       fn_get_ucitel(SV.UCITIDNO_DC_PODPIS,'PJ','N') as sending_DC,
       SV.ECTS_TELEFON as sending_tel,
       SV.ECTS_FAX as sending_fax,
       SV.ECTS_EMAIL as sending_email,
       OS.prijmeni as student_family_name,
       OS.JMENO as student_first_name,
       to_char(ST.DAT_NASTUPU,'DD.MM.RRRR') as student_from_date,
       to_char(nvl(ST.DAT_UKONCENI,sysdate),'DD.MM.RRRR') as student_to_date,
       to_char(OS.DATUM_NAROZ,'DD.MM.RRRR') as student_birth_date,
       (SELECT fn_meaning_en(OS.POHLAVI,'POHLAVI') FROM dual) as student_sex,
       to_char(ST.DAT_NASTUPU,'DD.MM.RRRR') as student_matriculation_date,
       ST.OS_CISLO as student_matriculation_number,
       decode(sv.typ_vyjezdu, 'S', CSKOL.NAZEV_SKOLY, 'P', SV.STAZ_FIRMA||', '||SV.STAZ_ADRESA||', '||SV.STAZ_MESTO, null) as receiving_institution,
       decode(sv.typ_vyjezdu, 'S', CSTAT.ENGLISH, 'P', CSTAT2.ENGLISH, null) as receiving_institution_country,
       SV.FAKULTA as receiving_department,
       SV.DC_CIZI as receiving_DC,
       SV.CIZI_TELEFON as receiving_tel,
       SV.CIZI_FAX as receiving_fax,
       SV.CIZI_EMAIL as receiving_email,
       (SELECT fn_meaning_en(SP.TITUL,'TITUL') FROM dual) as diploma_degree_awarded,
       to_char(ST.DAT_UKONCENI,'DD.MM.RRRR') as signature_date,
       (SELECT fn_get_ucitel(decode(pg_cti_parametry.cti_retezec('ECTS_TOR_PODPIS'),null,SV.UCITIDNO_DC_PODPIS,'DC',SV.UCITIDNO_DC_PODPIS,'IC',SV.UCITIDNO_IC_PODPIS,'DE',(select ucitidno from cis_pracovist where ZKR = (select fn_meaning2(substr(st.os_cislo,1,1),'OS_CISLO') from dual))),'PJ','A') FROM dual) as signature_dean,
       decode(KAL.rok_platnosti,NULL,case when to_char(sysdate,'MM')<'09' then to_char(sysdate-365,'RRRR')||'/'||to_char(sysdate,'RRRR')
                                     else to_char(sysdate,'RRRR')||'/'||to_char(sysdate+365,'RRRR')
                                     end,
                                     KAL.rok_platnosti||'/'||to_char(to_number(KAL.rok_platnosti)+1)) as academic_year
  FROM osoby OS,
       studenti ST,
       studijni_programy SP,
       cis_pracovist CP,
       STUDENTI_VYJEZDY SV,
       cis_skol CSKOL,
       cis_statu CSTAT,
       cis_statu CSTAT2,
       KALENDAR KAL,
       cg_ref_codes CGORG
 WHERE OS.osobidno = ST.osobidno
   AND ST.stpridno = SP.stpridno
   AND SP.FAKULTA_SP = CP.ZKR
   AND SV.OS_CISLO = ST.OS_CISLO
   AND SV.SKOLAIDNO = CSKOL.SKOLAIDNO(+)
   AND CSKOL.STATIDNO = CSTAT.STATIDNO(+)
   AND SV.DATUM_OD = KAL.DATUM(+)
   AND CGORG.RV_DOMAIN = 'ORGANIZACE'
   AND SV.STAZ_STATIDNO = CSTAT2.STATIDNO(+)
   AND SV.STVYIDNO = :stvyidno
