SELECT distinct
    os.PRIJMENI,
    os.JMENO,
    sp.STAND_DELKA,
    (select max(svor.standard_rok) from STUDENTI_V_ROCE svor where svor.OS_CISLO = st.os_cislo ) as rocnik,
    fn_adresa_studenta(st.os_cislo, 'ADRESA','PT') as adresa,
    os.DATUM_NAROZ,
    DECODE(os.TITUL_PRED, null, null, (select fn_meaning(os.TITUL_PRED,'TITUL_PRED') from dual)||' ')||os.JMENO||' '||os.PRIJMENI||DECODE(os.TITUL_ZA, null, null, ' '||(select fn_meaning(os.TITUL_ZA,'TITUL_ZA') from dual))  as student,
    DECODE(os.TITUL_PRED, null, null, (select fn_meaning(os.TITUL_PRED,'TITUL_PRED') from dual)||' ')||os.PRIJMENI||' '||os.JMENO||DECODE(os.TITUL_ZA, null, null, ' '||(select fn_meaning(os.TITUL_ZA,'TITUL_ZA') from dual))  as student2,
    st.os_cislo,
    sp.fakulta_sp AS fakulta,
    sp.CELOZIVOTNI_VZDELAVANI,
    DECODE(:lang, 'cs', (select fn_meaning2(fakulta_sp,'FAKULTA') from dual), 'sk', (select fn_meaning2(fakulta_sp,'FAKULTA') from dual), NVL((select fn_meaning_en(fakulta_sp,'FAKULTA') from dual), (select fn_meaning2(fakulta_sp,'FAKULTA') from dual))) AS fakulta_slovne,
    sp.typ as fk_typ,
    DECODE(:lang, 'cs', sp.cz_nazev, 'sk', sp.cz_nazev, NVL(sp.an_nazev, sp.cz_nazev)) AS obor, -- !!!chyba - todle je PROGRAM ne obor (oboru muze mit v ramci jednoho os cisla i vic)
    (select fn_vsechny_obko(st.os_cislo, fn_rok(st.os_cislo),null,'A') from dual) as obor_komb,
    (select fn_vsechny_obko(st.os_cislo, fn_rok(st.os_cislo),'A') from dual) as obor_komb_zkr,
    FN_STUDENTOVO_OBKO(st.os_cislo,(select fn_rok(st.os_cislo) from dual),'N',decode(:lang,'cs','CZ','sk','CZ','EN')) as obor_komb_slovne,
    DECODE(:lang, 'cs', d1.rv_meaning, 'sk', d1.rv_meaning, NVL(d1.english, d1.rv_meaning)) AS typ,
    DECODE(:lang, 'cs', d2.rv_meaning, 'sk', d2.rv_meaning, NVL(d2.english, d2.rv_meaning)) AS forma,
    sp.forma AS fk_forma,
    sp.stpridno AS fk_stpridno,
    (select fn_adresa_studenta(st.os_cislo, 'ULICE_CISLO','TP') from dual) ulice,
    (select fn_adresa_studenta(st.os_cislo, 'OBEC_CAST','TP') from dual) mesto,
    (select FN_EMAIL_STUDENTA(st.os_cislo) from dual) as email,
    os.ROD_CISLO rod_cislo,
    (SELECT to_char(to_number(KA.ROK_PLATNOSTI)+nvl(pg_cti_parametry.CTI_CISLO_OC('DP_PODKLAD_AKAD_ROK',st.os_cislo),0)) from kalendar KA where KA.DATUM = trunc(sysdate)) as rok_zadosti_o_podklad_kv_pr,
    nvl((select fn_account_locked(st.os_cislo) from dual),'N') as konto_locked
FROM
    cg_ref_codes d1,
    cg_ref_codes d2,
    STUDENTI ST,
    STUDIJNI_PROGRAMY SP,
    osoby os
WHERE st.os_cislo = :par_os_cislo
    AND sp.typ = d1.rv_low_value
    AND d1.rv_domain = 'TYP_OBORU'
    AND sp.forma = d2.rv_low_value
    AND d2.rv_domain = 'FORMA_OBORU_NEW'
    AND SP.stpridno = ST.stpridno
    AND os.osobidno = st.osobidno

ORDER  BY st.os_cislo