SELECT -- vybira znamky studenta z predmetu, ktere ma v danem akad. roce splnene (popr. semestru) (krome znamek nesplneno )
    'A' as univ_predmet,
	to_number(1) as plneni,
	z.ZKR_PREDM as pk_zkr_Predm,
	z.PRAC_ZKR as pk_prac_Zkr,
	z.ROK_VARIANTY as pk_rokVarianty,
	z.PRAC_ZKR||'/'||z.ZKR_PREDM as zkratka,
	DECODE(:lang, 'cs', p.cz_nazev, 'sk', p.cz_nazev, NVL(p.AN_NAZEV, p.cz_nazev)) as nazev,
	DECODE(z.hodnoceni_zk, 2, DECODE(:lang, 'cs', c1.RV_MEANING, 'sk', c1.RV_MEANING, NVL(c1.ENGLISH, c1.RV_MEANING)), 1, (SELECT fn_meaning(Z.znamka,'ZNAMKA')FROM dual)) as znamka,
	z.DATUM as datum,
	z.POKUS_CISLO,
	p.CRD as pocet_kreditu,
	 z.statut as statut,
	 z.semestr as semestr,
	CASE
		WHEN u.ucitidno IS NOT NULL
				THEN DECODE(u.TITUL_PRED, NULL, NULL, c4.RV_ABBREVIATION||' ')||u.JMENO||' '||u.PRIJMENI||DECODE(u.TITUL_ZA, NULL, NULL,', '||c5.RV_ABBREVIATION)
		ELSE u2.zkousejici
	 END AS ucitel,
	null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	null as pocet_aktualnich_terminu

FROM
	znamky z,
	cg_ref_codes c1,
	pred_varianty p,
	ucitele u,
	cg_ref_codes c4,
	cg_ref_codes c5,
	 (
	 SELECT
	    DECODE(uct.TITUL_PRED, NULL, NULL, c6.RV_ABBREVIATION||' ')||uct.JMENO||' '||uct.PRIJMENI||DECODE(uct.TITUL_ZA, NULL, NULL,', '||c7.RV_ABBREVIATION) AS zkousejici,
	    uct.email,
	    uct.telefon,
	    uct.ucitidno AS fk_ucitidno,
	    snz.os_cislo,
	    snz.prac_zkr,
	    snz.zkr_predm,
	    snz.rok_varianty,
	    snz.semestr,
	    snz.rok_platnosti,
	    snz.termidno
		FROM
			studenti_na_zkouskach snz,
			terminy trm,
			ucitele uct,
			cg_ref_codes c6,
			cg_ref_codes c7
		WHERE
			snz.termidno = trm.termidno
			AND  trm.ucitidno = uct.ucitidno
			AND  c6.RV_DOMAIN(+) = 'TITUL_PRED'
			AND  c6.RV_LOW_VALUE(+) = uct.TITUL_PRED
			AND  c7.RV_DOMAIN(+) = 'TITUL_ZA'
			AND  c7.RV_LOW_VALUE(+) = uct.TITUL_ZA
	 ) u2

WHERE
	z.os_cislo = UPPER(:os_cislo)
	AND  z.rok_platnosti = :rok
	AND  z.semestr like nvl(upper(translate(:semestr,'*','%')),'%')
	AND  u2.os_cislo(+) = z.os_cislo
	AND  u2.prac_zkr(+) = z.prac_zkr
	AND  u2.zkr_predm(+) = z.zkr_predm
	AND  u2.semestr(+) = z.semestr
	AND  u2.rok_varianty(+) = z.rok_varianty
	AND  u2.rok_platnosti(+) = z.rok_platnosti
	AND  c1.RV_DOMAIN = 'SLOVNI_HODNOCENI'
	AND  c1.RV_LOW_VALUE = NVL(z.slovni_hodnoceni, 'S')
	AND  p.prac_zkr = z.prac_zkr
	AND  p.zkr_predm = z.zkr_predm
	AND  p.rok_varianty = z.rok_varianty
	AND  u.ucitidno(+) = z.ucitidno
	AND  c4.RV_DOMAIN(+) = 'TITUL_PRED'
	AND  c4.RV_LOW_VALUE(+) = u.TITUL_PRED
	AND  c5.RV_DOMAIN(+) = 'TITUL_ZA'
	AND  c5.RV_LOW_VALUE(+) = u.TITUL_ZA
	AND  z.datum IS NOT NULL
	AND NOT(((z.HODNOCENI_ZK=1 and (SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = Z.znamka) = 'N') or (z.HODNOCENI_ZK=2 and z.SLOVNI_HODNOCENI = 'N')))
	AND  ((u2.termidno = (
			 SELECT  MAX(ta.termidno)
				 FROM  studenti_na_zkouskach snza, terminy ta
				WHERE  snza.termidno = ta.termidno
					AND  snza.os_cislo = u2.os_cislo
					AND  snza.prac_zkr = u2.prac_zkr
					AND  snza.zkr_predm = u2.zkr_predm
					AND  snza.rok_varianty = u2.rok_varianty
					AND  snza.rok_platnosti = u2.rok_platnosti
					AND  TO_DATE(TO_CHAR(ta.datum, 'DD.MM.YYYY')||' - '||TO_CHAR(ta.hod_od, 'HH24:MI'), 'DD.MM.YYYY - HH24:MI') >= ALL (
						SELECT  TO_DATE(TO_CHAR(tb.datum, 'DD.MM.YYYY')||' - '||TO_CHAR(tb.hod_od, 'HH24:MI'), 'DD.MM.YYYY - HH24:MI')
							FROM  studenti_na_zkouskach snzb, terminy tb
						 WHERE  snzb.termidno = tb.termidno
							 AND  snzb.os_cislo = u2.os_cislo
							 AND  snzb.prac_zkr = u2.prac_zkr
							 AND  snzb.zkr_predm = u2.zkr_predm
							 AND  snzb.rok_varianty = u2.rok_varianty
							 AND  snzb.rok_platnosti = u2.rok_platnosti )
		 )) OR (u2.termidno IS NULL))

union -- jako predchozi select, ale z jedznamky
select
    'N' as univ_predmet,
    to_number(1) as plneni,
    j.zkr_predm AS pk_zkr_predm,
    j.prac_zkr AS pk_prac_zkr,
    j.rok_platnosti AS pk_rok_varianty,
    j.zkratka_predm as zkratka,
    j.cz_nazev_predmetu AS nazev,
    DECODE(j.hodnoceni_zk, 2, cg1.RV_MEANING, 1, nvl((SELECT fn_meaning(j.znamka,'ZNAMKA')FROM dual),(SELECT cgrc.rv_abbreviation from cg_ref_codes cgrc where cgrc.rv_domain = 'ZNAMKA' and cgrc.poradi = (select max(pom.poradi) from cg_ref_codes pom where pom.rv_domain = 'ZNAMKA')))) AS znamka,
    j.datum AS datum,
    j.pokus_cislo as pokus_cislo,
    j.POC_KRED  as pocet_kreditu, -- z znamky
    decode(j.zkr_predm,null,'C',substr(fn_get_statut_a_stplidno(j.os_cislo,j.prac_zkr,j.zkr_predm,j.rok_platnosti,j.rok_platnosti),1,1)) as statut,
    j.SEMESTR AS semestr,
    Fn_Get_Ucitel(u.ucitidno,'JP','A') as ucitel,
    null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	null as pocet_aktualnich_terminu
    from jedznamky j,ucitele u,  cg_ref_codes cg1
    where j.os_cislo = UPPER(:os_cislo)
      and j.rok_platnosti = :rok
      AND j.semestr like upper(nvl(:semestr,'%'))
      and j.ucitidno = u.ucitidno
      AND  cg1.RV_DOMAIN = 'SLOVNI_HODNOCENI'
      AND  cg1.RV_LOW_VALUE = NVL(j.slovni_hodnoceni, 'N')
      AND  j.datum IS NOT NULL
      AND NOT(((j.HODNOCENI_ZK=1 and (SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = j.znamka) = 'N') or (j.HODNOCENI_ZK=2 and j.SLOVNI_HODNOCENI = 'N')))
      --or (j.PRAC_ZKR <> null AND (select FN_DEADLINE_ZAPISU_ZNAMEK(j.ROK_PLATNOSTI,j.PRAC_ZKR) from dual) = 'A') or (j.rok_platnosti < (select ROK_PLATNOSTI from KALENDAR where datum = trunc(SYSDATE))))
union
select -- vybira predmety studenta v roce na jejichz terminech je student zapsany.
    'A' as univ_predmet,
	to_number(2) as plneni,
	z.ZKR_PREDM as pk_zkr_Predm,
	z.PRAC_ZKR as pk_prac_Zkr,
	z.ROK_VARIANTY as pk_rokVarianty,
	z.PRAC_ZKR||'/'||z.ZKR_PREDM as zkratka,
	DECODE(:lang, 'cs', pv.cz_nazev, 'sk', pv.cz_nazev, NVL(pv.AN_NAZEV, pv.cz_nazev)) as nazev,
	DECODE(z.hodnoceni_zk, 2, DECODE(:lang, 'cs', c3.RV_MEANING, 'sk', c3.RV_MEANING, NVL(c3.ENGLISH, c3.RV_MEANING)), 1, (SELECT fn_meaning(Z.znamka,'ZNAMKA')FROM dual)) as znamka,
	to_date(to_char(t.DATUM, 'DD.MM.RRRR')||to_char(t.HOD_OD, ' HH24:MI'), 'DD.MM.RRRR HH24:MI') as datum,
	null as POKUS_CISLO,
	pv.CRD as pocet_kreditu,
	z.statut as statut,
	z.semestr as semestr,
	decode(u.TITUL_PRED, null, null, c1.RV_ABBREVIATION||' ')||u.JMENO||' '||u.PRIJMENI||
	decode(u.TITUL_ZA, null, null,', '||c2.RV_ABBREVIATION) as ucitel,
	t.TERMIDNO as fk_termidno,
	t.ZKR_BUDOVY as fk_zkr_budovy,
	t.CISLO_MIST as fk_cislo_mist,
	t.ZKR_BUDOVY||' '||t.CISLO_MIST as mistnost,
	DECODE(:lang, 'cs', c4.RV_MEANING, 'sk', c4.RV_MEANING, NVL(c4.ENGLISH, c4.RV_MEANING)) as typ_terminu,
	null as pocet_aktualnich_terminu

from
	znamky z,
	pred_varianty pv,
	cg_ref_codes c1,
	cg_ref_codes c2,
	cg_ref_codes c3,
	cg_ref_codes c4,
	ucitele u,
	studenti_na_zkouskach snz,
	terminy t

where
	z.OS_CISLO = upper(:os_cislo)
	and z.ROK_PLATNOSTI = :rok
	and z.SEMESTR like nvl(upper(translate(:semestr,'*','%')),'%')
	and pv.PRAC_ZKR = z.PRAC_ZKR
	and pv.ZKR_PREDM = z.ZKR_PREDM
	and pv.ROK_VARIANTY = z.ROK_VARIANTY
	and u.UCITIDNO(+) = t.UCITIDNO
	and c1.RV_DOMAIN(+) = 'TITUL_PRED'
	and c1.RV_LOW_VALUE(+) = u.TITUL_PRED
	and c2.RV_DOMAIN(+) = 'TITUL_ZA'
	and c2.RV_LOW_VALUE(+) = u.TITUL_ZA
	and c3.RV_DOMAIN(+) = 'SLOVNI_HODNOCENI'
	and c3.RV_LOW_VALUE(+) = z.slovni_hodnoceni
	--and (z.DATUM is null)
	and (   (z.HODNOCENI_ZK=1 and ((z.ZNAMKA is null) or ((SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = Z.znamka) = 'N'))) -- nahrada misto: and (z.DATUM is null)
			or (z.HODNOCENI_ZK=2 and ((z.SLOVNI_HODNOCENI = 'N') or (z.SLOVNI_HODNOCENI is null)))
		)
	--and nvl(z.pokus_cislo,0) < 3	    -- student by nemel byt nikdy zapsan na terminu poctvrte. !!! jenze ....
	and snz.SEMESTR = z.SEMESTR and snz.ROK_VARIANTY = z.ROK_VARIANTY and snz.PRAC_ZKR = z.PRAC_ZKR
	and snz.ZKR_PREDM = z.ZKR_PREDM and snz.OS_CISLO = z.OS_CISLO
	and t.TERMIDNO = snz.TERMIDNO
	and  Fn_Zive_Datum(t.datum,t.hod_od)=1
	and c4.RV_DOMAIN(+) = 'TYP_TERMINU'
	and c4.RV_LOW_VALUE(+) = t.TYP_TERMINU

union
select -- vybira predmety studenta , ktere maji vypsane terminy zkousky, ale student neni na zadne zapsan a neprobehl jiz jeho treti pokus z daneho predmetu.
    'A' as univ_predmet,
	to_number(3) as plneni,
	z.ZKR_PREDM as pk_zkr_Predm,
	z.PRAC_ZKR as pk_prac_Zkr,
	z.ROK_VARIANTY as pk_rokVarianty,
	z.PRAC_ZKR||'/'||z.ZKR_PREDM as zkratka,
	DECODE(:lang, 'cs', pv.cz_nazev, 'sk', pv.cz_nazev, NVL(pv.AN_NAZEV, pv.cz_nazev)) as nazev,
	null as znamka,
	null as datum,
	null as POKUS_CISLO,
	pv.CRD as pocet_kreditu,
	z.statut as statut,
	z.semestr as semestr,
	null as ucitel,
	null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	count(t.TERMIDNO) as pocet_aktualnich_terminu

from
	znamky z,
	terminy t,
	pred_varianty pv

where
	z.OS_CISLO = upper(:os_cislo)
	and z.ROK_PLATNOSTI = :rok
	and z.SEMESTR like nvl(upper(translate(:semestr,'*','%')),'%')
	and (   (z.HODNOCENI_ZK=1 and ((z.ZNAMKA is null) or ((SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = Z.znamka) = 'N')))
			or (z.HODNOCENI_ZK=2 and ((z.SLOVNI_HODNOCENI = 'N') or (z.SLOVNI_HODNOCENI is null)))
		)
	and pv.PRAC_ZKR = z.PRAC_ZKR
	and pv.ZKR_PREDM = z.ZKR_PREDM
	and pv.ROK_VARIANTY = z.ROK_VARIANTY
	and t.PRAC_ZKR = z.PRAC_ZKR
	and t.ZKR_PREDM = z.ZKR_PREDM
	and t.ROK_PLATNOSTI = z.ROK_PLATNOSTI
	and NVL(t.semestr,'X') = DECODE(t.semestr,NULL,'X',z.semestr)
	and Fn_Zive_Datum(t.datum,t.hod_od)=1
	and t.platnost = 'A'
	and nvl(z.pokus_cislo,0) < 3
	and not exists ( select t3.termidno
										from terminy t3, studenti_na_zkouskach s3
								where s3.os_cislo = z.os_cislo
									and t3.termidno = s3.termidno
									and t3.prac_zkr = z.prac_zkr
									and t3.zkr_predm = z.zkr_predm
									and t3.rok_platnosti = z.rok_platnosti
									and Fn_Zive_Datum(t3.datum,t3.hod_od)=1 )

group by
    'A',
	to_number(3),
	z.ZKR_PREDM,
	z.PRAC_ZKR,
	z.ROK_VARIANTY,DECODE(:lang, 'cs', pv.cz_nazev, 'sk', pv.cz_nazev, NVL(pv.AN_NAZEV, pv.cz_nazev)),
	null,
	null,
	null,
	pv.CRD,
	z.statut,
	z.semestr,
	null,
	null,
	null,
	null,
	null,
	null,
	null

union
select -- vybira predmety studenta, z kterych nebyl dosud student klasifikovan a nemaji zadne vypsane terminy a neuplynul pro danou katedru jiz deadline zadavani znamek pro dany akad. rok.
    'A' as univ_predmet,
	to_number(4) as plneni,
	z.ZKR_PREDM as pk_zkr_Predm,
	z.PRAC_ZKR as pk_prac_Zkr,
	z.ROK_VARIANTY as pk_rokVarianty,
	z.PRAC_ZKR||'/'||z.ZKR_PREDM as zkratka,
	DECODE(:lang, 'cs', pv.cz_nazev, 'sk', pv.cz_nazev, NVL(pv.AN_NAZEV, pv.cz_nazev)) as nazev,
	null as znamka,
	null as datum,
	null as POKUS_CISLO,
	pv.CRD as pocet_kreditu,
	z.statut as statut,
	z.semestr as semestr,
	null as ucitel,
	null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	null as pocet_aktualnich_terminu

from
	znamky z,
	pred_varianty pv

where
	z.OS_CISLO = upper(:os_cislo)
	and z.ROK_PLATNOSTI = :rok
	and z.SEMESTR like nvl(upper(translate(:semestr,'*','%')),'%')
	and pv.PRAC_ZKR = z.PRAC_ZKR
	and pv.ZKR_PREDM = z.ZKR_PREDM
	and pv.ROK_VARIANTY = z.ROK_VARIANTY
	and ((z.HODNOCENI_ZK=1 and z.ZNAMKA is null) or (z.HODNOCENI_ZK=2 and z.SLOVNI_HODNOCENI is null))
	and not exists (select termidno
									 from terminy t
									where t.prac_zkr = z.prac_zkr
										and t.zkr_predm = z.zkr_predm
										and t.rok_platnosti = z.rok_platnosti
										--and t.semestr = z.semestr
										and NVL(t.semestr,'X') = DECODE(t.semestr,NULL,'X',z.semestr)
									 and Fn_Zive_Datum(t.datum,t.hod_od)=1)
	and FN_DEADLINE_ZAPISU_ZNAMEK(z.ROK_PLATNOSTI,z.PRAC_ZKR) = 'N'
union -- jako predchozi select, ale z jedznamky
select
    'N' as univ_predmet,
    to_number(4) as plneni,
    j.zkr_predm AS pk_zkr_predm,
    j.prac_zkr AS pk_prac_zkr,
    j.rok_platnosti AS pk_rok_varianty,
    j.zkratka_predm as zkratka,
    j.cz_nazev_predmetu AS nazev,
    null AS znamka,
    null AS datum,
    null as pokus_cislo,
    j.POC_KRED  as pocet_kreditu, -- z znamky
    decode(j.zkr_predm,null,'C',substr(fn_get_statut_a_stplidno(j.os_cislo,j.prac_zkr,j.zkr_predm,j.rok_platnosti,j.rok_platnosti),1,1)) as statut,
    j.SEMESTR AS semestr,
    null as ucitel,
    null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	null as pocet_aktualnich_terminu
    from jedznamky j,  cg_ref_codes cg1
    where j.os_cislo = UPPER(:os_cislo)
      and j.rok_platnosti = :rok
      AND j.semestr like upper(nvl(:semestr,'%'))
      AND  cg1.RV_DOMAIN = 'SLOVNI_HODNOCENI'
      AND  cg1.RV_LOW_VALUE = NVL(j.slovni_hodnoceni, 'N')
      and ((j.HODNOCENI_ZK=1 and j.ZNAMKA is null) or (j.HODNOCENI_ZK=2 and j.SLOVNI_HODNOCENI is null))
      and ((j.PRAC_ZKR <> null AND (select FN_DEADLINE_ZAPISU_ZNAMEK(j.ROK_PLATNOSTI,j.PRAC_ZKR) from dual) = 'N') or (j.rok_platnosti = (select ROK_PLATNOSTI from KALENDAR where datum = trunc(SYSDATE))))
union
/*
Vybira predmety studenta, u kterych ma student zapsanu znamku 4 nebo neuspel a jednalo se jiz o jeho treti pokus.
Dále pokud je hodnocen z predmetu znamkou 4/neuspel a zaroven jiz neni zadny termin takoveho predmetu (pro dany akad. rok) vypsan.
Znamka 4/neuspel se u predmetu vypisuje také v pripadne , ze student nebyl nikdy hodnocen a pro danou katedru predmetu jiz uplynul deadline zadavani znamek.
*/
select
    'A' as univ_predmet,
	to_number(5) as plneni,
	z.ZKR_PREDM as pk_zkr_Predm,
	z.PRAC_ZKR as pk_prac_Zkr,
	z.ROK_VARIANTY as pk_rokVarianty,
	z.PRAC_ZKR||'/'||z.ZKR_PREDM as zkratka,
	DECODE(:lang, 'cs', pv.cz_nazev, 'sk', pv.cz_nazev, NVL(pv.AN_NAZEV, pv.cz_nazev)) as nazev,
	DECODE(z.hodnoceni_zk, 2, DECODE(:lang, 'cs',c1.RV_MEANING, 'sk', c1.RV_MEANING, NVL(c1.ENGLISH, c1.RV_MEANING)), 1, nvl((SELECT fn_meaning(Z.znamka,'ZNAMKA')FROM dual),(SELECT cgrc.rv_abbreviation from cg_ref_codes cgrc where cgrc.rv_domain = 'ZNAMKA' and cgrc.poradi = (select max(pom.poradi) from cg_ref_codes pom where pom.rv_domain = 'ZNAMKA')))) as znamka,
	z.datum as datum,
	z.POKUS_CISLO as POKUS_CISLO,
	pv.CRD as pocet_kreditu,
	z.statut as statut,
	z.semestr as semestr,
	CASE
        WHEN u.ucitidno IS NOT NULL
                THEN DECODE(u.TITUL_PRED, NULL, NULL, c4.RV_ABBREVIATION||' ')||u.JMENO||' '||u.PRIJMENI||DECODE(u.TITUL_ZA, NULL, NULL,', '||c5.RV_ABBREVIATION)
        ELSE u2.zkousejici
     END AS ucitel,
	null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	null as pocet_aktualnich_terminu

from
	znamky z,
	pred_varianty pv,
	cg_ref_codes c1,
	ucitele u,
    cg_ref_codes c4,
    cg_ref_codes c5,
    (
     SELECT
        DECODE(uct.TITUL_PRED, NULL, NULL, c6.RV_ABBREVIATION||' ')||uct.JMENO||' '||uct.PRIJMENI||DECODE(uct.TITUL_ZA, NULL, NULL,', '||c7.RV_ABBREVIATION) AS zkousejici,
        uct.email,
        uct.telefon,
        uct.ucitidno AS fk_ucitidno,
        snz.os_cislo,
        snz.prac_zkr,
        snz.zkr_predm,
        snz.rok_varianty,
        snz.semestr,
        snz.rok_platnosti,
        snz.termidno
        FROM
            studenti_na_zkouskach snz,
            terminy trm,
            ucitele uct,
            cg_ref_codes c6,
            cg_ref_codes c7
        WHERE
            snz.termidno = trm.termidno
            AND  trm.ucitidno = uct.ucitidno
            AND  c6.RV_DOMAIN(+) = 'TITUL_PRED'
            AND  c6.RV_LOW_VALUE(+) = uct.TITUL_PRED
            AND  c7.RV_DOMAIN(+) = 'TITUL_ZA'
            AND  c7.RV_LOW_VALUE(+) = uct.TITUL_ZA
     ) u2

where
	z.OS_CISLO = upper(:os_cislo)
	and z.ROK_PLATNOSTI = :rok
	and z.SEMESTR like nvl(upper(translate(:semestr,'*','%')),'%')
    AND  u2.os_cislo(+) = z.os_cislo
    AND  u2.prac_zkr(+) = z.prac_zkr
	AND  u2.zkr_predm(+) = z.zkr_predm
	AND  u2.semestr(+) = z.semestr
	AND  u2.rok_varianty(+) = z.rok_varianty
	AND  u2.rok_platnosti(+) = z.rok_platnosti
	and pv.PRAC_ZKR = z.PRAC_ZKR
	and pv.ZKR_PREDM = z.ZKR_PREDM
	and pv.ROK_VARIANTY = z.ROK_VARIANTY
	and u.UCITIDNO(+) = z.UCITIDNO
    AND  c4.RV_DOMAIN(+) = 'TITUL_PRED'
	AND  c4.RV_LOW_VALUE(+) = u.TITUL_PRED
	AND  c5.RV_DOMAIN(+) = 'TITUL_ZA'
	AND  c5.RV_LOW_VALUE(+) = u.TITUL_ZA
	AND c1.RV_DOMAIN(+) = 'SLOVNI_HODNOCENI'
	AND c1.RV_LOW_VALUE(+) = NVL(z.slovni_hodnoceni, 'N')
	AND
	((z.datum IS NOT NULL
	and ((z.HODNOCENI_ZK=1 and (SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = Z.znamka) = 'N') or (z.HODNOCENI_ZK=2 and z.SLOVNI_HODNOCENI = 'N'))
	and ((z.pokus_cislo >= 3 )or not exists(	select termidno
									 from terminy t
									where t.prac_zkr = z.prac_zkr
										and t.zkr_predm = z.zkr_predm
										and t.rok_platnosti = z.rok_platnosti
										--and t.semestr = z.semestr
										and NVL(t.semestr,'X') = DECODE(t.semestr,NULL,'X',z.semestr)
										and t.platnost = 'A'
									 and Fn_Zive_Datum(t.datum,t.hod_od)=1
				  ))
	) OR (z.datum IS NULL AND ((z.HODNOCENI_ZK=1 and z.ZNAMKA is null) or (z.HODNOCENI_ZK=2 and z.SLOVNI_HODNOCENI is null)) AND FN_DEADLINE_ZAPISU_ZNAMEK(z.ROK_PLATNOSTI,z.PRAC_ZKR) = 'A'))			  
    AND  ((u2.termidno = ( 
			 SELECT  MAX(ta.termidno)
				 FROM  studenti_na_zkouskach snza, terminy ta
				WHERE  snza.termidno = ta.termidno
					AND  snza.os_cislo = u2.os_cislo
					AND  snza.prac_zkr = u2.prac_zkr
					AND  snza.zkr_predm = u2.zkr_predm
					AND  snza.rok_varianty = u2.rok_varianty
					AND  snza.rok_platnosti = u2.rok_platnosti
					AND  TO_DATE(TO_CHAR(ta.datum, 'DD.MM.YYYY')||' - '||TO_CHAR(ta.hod_od, 'HH24:MI'), 'DD.MM.YYYY - HH24:MI') >= ALL (
						SELECT  TO_DATE(TO_CHAR(tb.datum, 'DD.MM.YYYY')||' - '||TO_CHAR(tb.hod_od, 'HH24:MI'), 'DD.MM.YYYY - HH24:MI')
							FROM  studenti_na_zkouskach snzb, terminy tb
						 WHERE  snzb.termidno = tb.termidno
							 AND  snzb.os_cislo = u2.os_cislo
							 AND  snzb.prac_zkr = u2.prac_zkr
							 AND  snzb.zkr_predm = u2.zkr_predm
							 AND  snzb.rok_varianty = u2.rok_varianty
							 AND  snzb.rok_platnosti = u2.rok_platnosti )
		 )) OR (u2.termidno IS NULL))
union -- jako predchozi select, ale z jedznamky
select
    'N' as univ_predmet,
    to_number(5) as plneni,
    j.zkr_predm AS pk_zkr_predm,
    j.prac_zkr AS pk_prac_zkr,
    j.rok_platnosti AS pk_rok_varianty,
    j.zkratka_predm as zkratka,
    j.cz_nazev_predmetu AS nazev,
    DECODE(j.hodnoceni_zk, 2, cg1.RV_MEANING, 1, nvl((SELECT fn_meaning(j.znamka,'ZNAMKA')FROM dual),(SELECT cgrc.rv_abbreviation from cg_ref_codes cgrc where cgrc.rv_domain = 'ZNAMKA' and cgrc.poradi = (select max(pom.poradi) from cg_ref_codes pom where pom.rv_domain = 'ZNAMKA')))) AS znamka,
    j.datum AS datum,
    j.pokus_cislo as pokus_cislo,
    j.POC_KRED  as pocet_kreditu, -- z znamky
    decode(j.zkr_predm,null,'C',substr(fn_get_statut_a_stplidno(j.os_cislo,j.prac_zkr,j.zkr_predm,j.rok_platnosti,j.rok_platnosti),1,1)) as statut,
    j.SEMESTR AS semestr,
    Fn_Get_Ucitel(u.ucitidno,'JP','A') as ucitel,
    null as fk_termidno,
    null as fk_zkr_budovy,
    null as fk_cislo_mist,
    null as mistnost,
    null as typ_terminu,
    null as pocet_aktualnich_terminu
    from jedznamky j,ucitele u,  cg_ref_codes cg1
    where j.os_cislo = UPPER(:os_cislo)
      and j.rok_platnosti = :rok
      AND j.semestr like upper(nvl(:semestr,'%'))
      and j.ucitidno = u.ucitidno
      AND  cg1.RV_DOMAIN = 'SLOVNI_HODNOCENI'
      AND  cg1.RV_LOW_VALUE = NVL(j.slovni_hodnoceni, 'N')
      --and (j.datum is not null and ((j.HODNOCENI_ZK=1 and (SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = j.znamka) = 'N') or (j.HODNOCENI_ZK=2 and j.SLOVNI_HODNOCENI = 'N')))
      --and ((z.HODNOCENI_ZK=1 and z.ZNAMKA is null) or (z.HODNOCENI_ZK=2 and z.SLOVNI_HODNOCENI is null))
      and ((j.datum is not null and ((j.HODNOCENI_ZK=1 and (SELECT CG.english FROM cg_ref_codes CG WHERE CG.rv_domain = 'ZNAMKA' AND CG.rv_low_value = j.znamka) = 'N') or (j.HODNOCENI_ZK=2 and j.SLOVNI_HODNOCENI = 'N')))
           OR (j.datum IS NULL AND ((j.HODNOCENI_ZK=1 and j.ZNAMKA is null) or (j.HODNOCENI_ZK=2 and j.SLOVNI_HODNOCENI is null)) AND ((j.PRAC_ZKR <> null AND (select FN_DEADLINE_ZAPISU_ZNAMEK(j.ROK_PLATNOSTI,j.PRAC_ZKR) from dual) = 'A') or (j.rok_platnosti < (select ROK_PLATNOSTI from KALENDAR where datum = trunc(SYSDATE)))))
      )

/* -- puvodni select pro zjisteni neuspesnych pokusu
select
	to_number(5) as plneni,
	z.ZKR_PREDM as pk_zkr_Predm,
	z.PRAC_ZKR as pk_prac_Zkr,
	z.ROK_VARIANTY as pk_rokVarianty,
	DECODE(:lang, 'cs', pv.cz_nazev, 'sk', pv.cz_nazev, NVL(pv.AN_NAZEV, pv.cz_nazev)) as nazev,
	DECODE(z.hodnoceni_zk, 2, DECODE(:lang, 'cs',c4.RV_MEANING, 'sk', c4.RV_MEANING, NVL(c4.ENGLISH, c4.RV_MEANING)), 1, nvl(z.znamka,4)) as znamka,
	z.DATUM as datum,
	z.POKUS_CISLO as POKUS_CISLO,
	pv.CRD as pocet_kreditu,
	z.statut as statut,
	z.semestr as semestr,
	null as ucitel,
	null as fk_termidno,
	null as fk_zkr_budovy,
	null as fk_cislo_mist,
	null as mistnost,
	null as typ_terminu,
	null as pocet_aktualnich_terminu

from
	znamky z,
	pred_varianty pv,
	cg_ref_codes c4,
	ucitele u

where
	z.OS_CISLO = upper(:os_cislo)
	and z.ROK_PLATNOSTI = :rok
	and z.SEMESTR like nvl(upper(translate(:semestr,'*','%')),'%')
	and pv.PRAC_ZKR = z.PRAC_ZKR
	and pv.ZKR_PREDM = z.ZKR_PREDM
	and pv.ROK_VARIANTY = z.ROK_VARIANTY
	and u.UCITIDNO(+) = z.UCITIDNO
	AND c4.RV_DOMAIN(+) = 'SLOVNI_HODNOCENI'
	AND c4.RV_LOW_VALUE(+) = NVL(z.slovni_hodnoceni, 'S')
	AND z.datum IS NOT NULL
	and ((z.HODNOCENI_ZK=1 and abs(z.ZNAMKA) = 4) or (z.HODNOCENI_ZK=2 and z.SLOVNI_HODNOCENI = 'N'))
	and ((z.pokus_cislo >= 3 ) or not exists(	select termidno
									 from terminy t
									where t.prac_zkr = z.prac_zkr
										and t.zkr_predm = z.zkr_predm
										and t.rok_platnosti = z.rok_platnosti
										--and t.semestr = z.semestr
										and NVL(t.semestr,'X') = DECODE(t.semestr,NULL,'X',z.semestr)
										and t.platnost = 'A'
									 and Fn_Zive_Datum(t.datum,t.hod_od)=1
				  ))
*/				  

order by
	plneni,
	pk_zkr_Predm,
	pk_PRAC_ZKR