SELECT --count(*) as pocet_prihlaseni,
       SNZ.DATE_OF_INSERT as datum_a_cas_prihlaseni,
       SNZ.prac_zkr||'_'||SNZ.zkr_predm||'_'||SNZ.rok_varianty||'_'||SNZ.rok_platnosti||'_'||SNZ.SEMESTR||'_'||TE.TYP_TERMINU as primKey,
       te.termidno,
       'A' as stale_zapsan -- znamena stale zapsany na terminu
  FROM studenti_na_zkouskach SNZ,
       terminy TE
 WHERE SNZ.OS_CISLO = :PAR_OS_CISLO
   --AND SNZ.ROK_VARIANTY = (SELECT FN_GET_ROK_PRO_ZAPIS_ZKOUSEK(SNZ.PRAC_ZKR ) FROM dual)
   AND SNZ.OMLUVEN <> 'A' --SNZ.OMLUVEN = 'N' -- neni omluven z terminu, ale muze byt oznacen jako nedostavil se na termin
   AND SNZ.TERMIDNO = TE.TERMIDNO -- tj. termin musi existovat, neni smazan
   AND TE.PLATNOST = 'A' -- jen platne terminy, ne ty zrusene
   AND fn_meaning3(TE.TYP_TERMINU,'TYP_TERMINU') = 'ZK' -- jen pro skupinu typu terminu ZK
   AND (trunc(SNZ.DATE_OF_INSERT) <> trunc(sysdate) OR (trunc(SNZ.DATE_OF_INSERT) = trunc(sysdate) AND trunc(TE.DATUM) = trunc(sysdate) AND to_char(TE.HOD_OD ,'HH24:MI')<to_char(sysdate,'HH24:MI')))
   --group by rollup(SNZ.DATE_OF_INSERT),SNZ.prac_zkr||'_'||SNZ.zkr_predm||'_'||SNZ.rok_varianty||'_'||SNZ.rok_platnosti||'_'||SNZ.SEMESTR||'_'||TE.TYP_TERMINU
UNION
SELECT --count(*) as pocet_prihlaseni,
       SNZA.DATUM_A_CAS_PRIHLASENI,
       SNZA.prac_zkr||'_'||SNZA.zkr_predm||'_'||SNZA.rok_varianty||'_'||SNZA.rok_platnosti||'_'||SNZA.SEMESTR||'_'||TE.TYP_TERMINU as primKey,
       te.termidno,
       'N' as stale_zapsan -- znamena byl zapsany, ale odepsal se z terminu.
  FROM studenti_na_zkouskach_audit SNZA,
       terminy TE
 WHERE SNZA.OS_CISLO = :PAR_OS_CISLO
   --AND SNZA.ROK_VARIANTY = (SELECT FN_GET_ROK_PRO_ZAPIS_ZKOUSEK(SNZA.PRAC_ZKR ) FROM dual)
   AND SNZA.TERMIDNO = TE.TERMIDNO -- tj. termin musi existovat, neni smazan
   AND TE.PLATNOST = 'A' -- jen platne terminy, ne ty zrusene
   AND fn_meaning3(TE.TYP_TERMINU,'TYP_TERMINU') = 'ZK' -- jen pro skupinu typu terminu ZK
   AND trunc(SNZA.DATUM_A_CAS_PRIHLASENI) <> trunc(SNZA.DATUM_A_CAS_ODHLASENI) -- neodhlasil se stejny den
   --group by rollup(SNZA.DATUM_A_CAS_PRIHLASENI),SNZA.prac_zkr||'_'||SNZA.zkr_predm||'_'||SNZA.rok_varianty||'_'||SNZA.rok_platnosti||'_'||SNZA.SEMESTR||'_'||TE.TYP_TERMINU
 ORDER BY primKey,datum_a_cas_prihlaseni /*nulls first*/