select to_char(datum_a_cas_akce_pom,'DD.MM.RRRR HH24:MI') as datum_a_cas_akce,
       akce,
       predmet,
       datum_terminu,
       cas_terminu,
       typ_terminu,
       mistnost_terminu,
       decode(platnost_terminu,'A','Platný','N','Zrušený',platnost_terminu) as platnost_terminu,
       nvl(zapoctene_prihlaseni_do_limitu,' ') as zapoctene_prihlaseni_do_limitu,
       decode(omluven_z_terminu,'N','Ne','Z','Ne','A','Ano',null,' ',omluven_z_terminu) as omluven_z_terminu,
       ucitel,
       dozapsan_na_termin_zkousejicim,
       vlastni_odhlaseni
  from (
SELECT /*to_char(*/SNZAD.DATUM_A_CAS_PRIHLASENI/*,'DD.MM.RRRR HH24:MI')*/ as datum_a_cas_akce_pom,
      'Přihlášení' as akce,
      TE.PRAC_ZKR||'/'||TE.ZKR_PREDM||' ('||TE.ROK_PLATNOSTI||'/'||(TE.ROK_PLATNOSTI+1)||')' as predmet,
      to_char(TE.DATUM,'DD.MM.RRRR') as datum_terminu,
      to_char(TE.HOD_OD,'HH24:MI') as cas_terminu,
      (select fn_meaning2(te.TYP_TERMINU,'TYP_TERMINU') from dual) as typ_terminu,
      TE.ZKR_BUDOVY||TE.CISLO_MIST as mistnost_terminu,
      TE.platnost as platnost_terminu,
      decode(trunc(SNZAD.DATUM_A_CAS_PRIHLASENI),trunc(SNZAD.DATUM_A_CAS_ODHLASENI),'Ne',(decode(TE.platnost||(select nvl2(pg_cti_parametry.cti_cislo('TERM_MAX_POCET_ZAPISU_ZK'),'A','N') from dual)||(select fn_meaning3(TE.TYP_TERMINU,'TYP_TERMINU') from dual),'AAZK','Ano','Ne'))) as zapoctene_prihlaseni_do_limitu,
      null as omluven_z_terminu,
      fn_get_ucitel(TE.UCITIDNO, 'PJ', 'A') as ucitel,
      'Ne' as dozapsan_na_termin_zkousejicim,
      TE.ROK_PLATNOSTI,
      ' ' as vlastni_odhlaseni
 FROM terminy TE,
      STUDENTI_NA_ZKOUSKACH_AUDIT SNZAD
WHERE SNZAD.OS_CISLO = :par_os_cislo
  --AND SNZAD.ROK_PLATNOSTI = (SELECT FN_GET_ROK_PRO_ZAPIS_ZKOUSEK(TE.prac_zkr) FROM dual)
  AND SNZAD.TERMIDNO = TE.TERMIDNO
UNION ALL
SELECT /*to_char(*/SNZAD.DATUM_A_CAS_ODHLASENI/*,'DD.MM.RRRR HH24:MI')*/ as datum_a_cas_akce_pom,
       'Odhlášení' as akce,
       TE.PRAC_ZKR||'/'||TE.ZKR_PREDM||' ('||TE.ROK_PLATNOSTI||'/'||(TE.ROK_PLATNOSTI+1)||')' as predmet,
       to_char(TE.DATUM,'DD.MM.RRRR') as datum_terminu,
       to_char(TE.HOD_OD,'HH24:MI') as cas_terminu,
       (select fn_meaning2(te.TYP_TERMINU,'TYP_TERMINU') from dual) as typ_terminu,
       TE.ZKR_BUDOVY||TE.CISLO_MIST as mistnost_terminu,
       TE.platnost as platnost_terminu,
       null as zapocitane_prihlaseni,
       null as omluven_z_terminu,
       fn_get_ucitel(TE.UCITIDNO, 'PJ', 'A') as ucitel,
       ' ' as dozapsan_na_termin_zkousejicim,
       TE.ROK_PLATNOSTI,
       decode(SNZAD.OWNER, SNZAD.OS_CISLO, 'Ano', 'Ne') as vlastni_odhlaseni
FROM terminy TE,
     STUDENTI_NA_ZKOUSKACH_AUDIT SNZAD
WHERE SNZAD.OS_CISLO = :par_os_cislo
  --AND SNZAD.ROK_PLATNOSTI = (SELECT FN_GET_ROK_PRO_ZAPIS_ZKOUSEK(TE.prac_zkr) FROM dual)
  AND SNZAD.TERMIDNO = TE.TERMIDNO
UNION ALL
SELECT  /*to_char(*/SNZ.DATE_OF_INSERT/*,'DD.MM.RRRR HH24:MI')*/ as datum_a_cas_akce_pom,
       'Přihlášení' as akce,
       TE.PRAC_ZKR||'/'||TE.ZKR_PREDM||' ('||TE.ROK_PLATNOSTI||'/'||(TE.ROK_PLATNOSTI+1)||')' as predmet,
       to_char(TE.DATUM,'DD.MM.RRRR') as datum_terminu,
       to_char(TE.HOD_OD,'HH24:MI') as cas_terminu,
       (select fn_meaning2(te.TYP_TERMINU,'TYP_TERMINU') from dual) as typ_terminu,
       TE.ZKR_BUDOVY||TE.CISLO_MIST as mistnost_terminu,
       TE.platnost as platnost_terminu,
       decode(trunc(SNZ.DATE_OF_INSERT),trunc(sysdate),'Ne',(decode(TE.platnost||(select nvl2(pg_cti_parametry.cti_cislo('TERM_MAX_POCET_ZAPISU_ZK'),'A','N') from dual)||(select fn_meaning3(TE.TYP_TERMINU,'TYP_TERMINU') from dual)||decode(SNZ.omluven,'Z','N',SNZ.omluven),'AAZKN','Ano','Ne'))) as zapoctene_prihlaseni_do_limitu,
       SNZ.omluven as omluven_z_terminu,
       fn_get_ucitel(TE.UCITIDNO, 'PJ', 'A') as ucitel,
       decode(SNZ.OWNER, SNZ.OS_CISLO, 'Ne', 'Ano') as dozapsan_na_termin_zkousejicim,
       TE.ROK_PLATNOSTI,
       ' ' as vlastni_odhlaseni
FROM terminy TE,
     STUDENTI_NA_ZKOUSKACH SNZ
WHERE SNZ.OS_CISLO = :par_os_cislo
  --AND SNZ.ROK_PLATNOSTI = (SELECT FN_GET_ROK_PRO_ZAPIS_ZKOUSEK(TE.prac_zkr) FROM dual)
  AND SNZ.TERMIDNO = TE.TERMIDNO
)
ORDER BY ROK_PLATNOSTI DESC,datum_a_cas_akce_pom DESC