select
  distinct
  pv.zkr_predm,
  pv.prac_zkr,
  pv.cz_nazev,
  pv.an_nazev,
  pv.vicezapis,
  pv.typ_zk,
  l.rv_abbreviation||decode(pv.predz_za, 'A', '+', '') as typZk,
  pv.VYUKA_ZS,
  pv.VYUKA_LS,
  pv.CRD as kredity,
  nvl(to_char(bp.DOPORSEM),'X') as semestr,
  nvl(to_char(bp.DOPORROC),'X') as rocnik,
  bp.BLOKIDNO,
  spl.STPLIDNO,
  b.STATUT,
  bp.ROK_VARIANTY,
  to_char(pv.jednotek_pr)||i.pom_hodnota||'+'||to_char(pv.jednotek_cv)||j.pom_hodnota||'+'||to_char(pv.jednotek_sem)||k.pom_hodnota rozsah,
  fn_predch_nespl(snor.OS_CISLO,spl.rok_platnosti,pv.prac_zkr,pv.zkr_predm,nvl(to_char(bp.DOPORSEM),'LS')) as splneno,
  fn_predmet_abs(snor.OS_CISLO,pv.prac_zkr,pv.ZKR_PREDM,'A') as absolvoval,
  count(r.roakidno) pocet
from
  obory o,
  studenti_na_oboru_v_roce snor,
  studijni_plany spl,
  poradi_segmentu ps,
  segmenty_st_planu sp,
  skupiny_segmentu ss,
  bloky b,
  bloky_predm bp,
  pred_varianty pv,
  rozvrh_akce r,

     cg_ref_codes i,
    cg_ref_codes j,
    cg_ref_codes k,
    cg_ref_codes l
where
  snor.OS_CISLO = :os_cislo
  and snor.STPLIDNO = spl.STPLIDNO
  and o.OBORIDNO = spl.OBORIDNO
  and spl.ROK_PLATNOSTI = :rok
  and ps.STPLIDNO = spl.STPLIDNO
  and ps.SESPIDNO = sp.SESPIDNO
  and ss.STPLIDNO(+) = ps.STPLIDNO
  and ss.SESPIDNO(+) = ps.SESPIDNO
  and b.SESPIDNO = sp.SESPIDNO
  and bp.BLOKIDNO = b.BLOKIDNO
  and pv.prac_zkr = bp.prac_zkr
  and pv.zkr_predm = bp.zkr_predm
  and pv.rok_varianty = bp.rok_varianty
  and r.PRAC_ZKR(+) = pv.prac_zkr
  and r.ZKR_PREDM(+) = pv.zkr_predm
  and r.platnost(+) = 'A'
  and r.rok_varianty(+) = pv.rok_varianty
    /*        --and r.ROK_VARIANTY = '2006' */
    and r.ROK_PLATNOSTI(+) = pv.rok_varianty
    and  i.rv_domain = 'JEDNOTKA_VYUKY'
    and  pv.jednotka_pr = i.rv_low_value
    and  j.rv_domain = 'JEDNOTKA_VYUKY'
    and  pv.jednotka_cv = j.rv_low_value
    and  k.rv_domain = 'JEDNOTKA_VYUKY'
    and  pv.jednotka_sem = k.rv_low_value
    and  l.rv_domain = 'TYP_ZK_NEW'
    and  pv.typ_zk = l.rv_low_value
group by pv.zkr_predm, pv.prac_zkr, pv.cz_nazev, pv.an_nazev, pv.vicezapis, pv.typ_zk, l.rv_abbreviation||decode(pv.predz_za, 'A', '+', ''), pv.VYUKA_ZS, pv.VYUKA_LS, pv.CRD, nvl(to_char(bp.DOPORSEM),'X'), nvl(to_char(bp.DOPORROC),'X'), bp.BLOKIDNO, spl.STPLIDNO, b.STATUT, bp.ROK_VARIANTY, to_char(pv.jednotek_pr)||i.pom_hodnota||'+'||to_char(pv.jednotek_cv)||j.pom_hodnota||'+'||to_char(pv.jednotek_sem)||k.pom_hodnota,fn_predch_nespl(snor.OS_CISLO,spl.rok_platnosti,pv.prac_zkr,pv.zkr_predm,nvl(to_char(bp.DOPORSEM),'LS')), fn_predmet_abs(snor.OS_CISLO,pv.prac_zkr,pv.ZKR_PREDM,'A')
order by pv.prac_zkr, pv.zkr_predm