--hlavni select - info o studentovi na zaklade jeho os_cisla
SELECT   o.rod_cislo rc,
            prijmeni
         || ' '
         || jmeno
         || NVL2 (titul_pred, ', ', NULL)
         || pred.rv_abbreviation
         || NVL2 (titul_za, NVL2 (titul_pred, ' ', ', '), NULL)
         || za.rv_abbreviation prijmeni,
         s.os_cislo os_cislo, sp.kodsp_i st_progr,
         nvl(s.POCET_ZAPISOVYCH_PROPUSTEK,0) as POCET_ZAPISOVYCH_PROPUSTEK,
         org.rv_meaning || ' - ' || sp.fakulta_sp fak, sp.forma forma,
         org.rv_abbreviation as zkratka_organizace,
         sp.CELOZIVOTNI_VZDELAVANI,
         typ.rv_abbreviation typ, svor.rok_platnosti||'/'||to_char(to_date(svor.rok_platnosti+1,'RRRR'),'RR') akad_rok,
         svor.standard_rok rocnik, misto.rv_meaning misto,
         /*DECODE (p_vyber_komb, 'K', -1, obo.oboridno) oboridno,*/ stpl.etapa,
         (select fn_vzorec_vyhodnot(s.os_cislo,'MAX_DOBA_DATUM',NULL) from dual
           where to_date(fn_vzorec_vyhodnot(s.os_cislo,'MAX_DOBA_DATUM',NULL),'DD.MM.RRRR') <= (select max (k.datum) from kalendar k where k.rok_platnosti = svor.rok_platnosti)) as max_datum_studia

    FROM osoby o,
         studenti s,
         studenti_v_roce svor,
         studenti_na_oboru_v_roce snor,
         studijni_programy sp,
         studijni_plany stpl,
         obory obo,
         kombinace komb,
         cg_ref_codes typ,
         cg_ref_codes misto,
         cg_ref_codes org,
         cg_ref_codes pred,
         cg_ref_codes za
   WHERE
     svor.rok_platnosti LIKE NVL (:par_rok_sk, '%')
     AND snor.stplidno IN (
            SELECT MIN (snor2.stplidno)
              FROM studenti_na_oboru_v_roce snor2,
                   studenti_v_roce stvr2,
                   studijni_plany stpl2,
                   obory obo2,
                   studijni_programy sp2
             WHERE snor2.rok_platnosti = snor.rok_platnosti
               AND snor2.os_cislo = snor.os_cislo
               AND snor2.stplidno = stpl2.stplidno
               AND stpl2.oboridno = obo2.oboridno
               AND obo2.stpridno = sp2.stpridno
               AND snor2.rok_platnosti = stvr2.rok_platnosti
               AND snor2.os_cislo = stvr2.os_cislo
               AND stvr2.rok_platnosti LIKE NVL (:par_rok_sk, '%'))

     AND o.osobidno = s.osobidno
     AND s.stpridno = sp.stpridno
     AND s.os_cislo = svor.os_cislo
     AND svor.os_cislo = snor.os_cislo
     AND svor.rok_platnosti = snor.rok_platnosti
     AND snor.stplidno = stpl.stplidno
     AND stpl.oboridno = obo.oboridno
     AND typ.rv_domain = 'TYP_OBORU'
     AND typ.rv_low_value = sp.typ
     AND misto.rv_domain = 'MISTO_VYUKY'
     AND misto.rv_low_value = svor.misto_vyuky
     AND org.rv_domain = 'ORGANIZACE'
     AND o.titul_pred = pred.rv_low_value(+)
     AND pred.rv_domain(+) = 'TITUL_PRED'
     AND o.titul_za = za.rv_low_value(+)
     AND za.rv_domain(+) = 'TITUL_ZA'
     AND komb.kombidno(+) = svor.kombidno
     AND EXISTS (
            SELECT os_cislo
              FROM znamky z
             WHERE s.os_cislo = z.os_cislo
               AND svor.rok_platnosti = z.rok_platnosti
            UNION
            SELECT os_cislo
              FROM jedznamky z
             WHERE s.os_cislo = z.os_cislo
               AND svor.rok_platnosti = z.rok_platnosti)
     AND s.os_cislo LIKE UPPER (:p_os_cislo)