
select
	cp.ZKR as pk_zkr_prac,
	cp.NAZEV,
	cp.CISLO_PRAC,
	cp_nadraz.ZKR as zkr_nadraz,
	cp_nadraz.NAZEV as nazev_nadraz,
	cp_nadraz.CISLO_PRAC as cislo_prac_nadraz,
	DECODE(:lang, 'cs', c1.rv_meaning, 'sk', c1.rv_meaning, NVL(c1.english, c1.rv_meaning)) AS typ,
	DECODE(:lang, 'cs', c2.rv_meaning, 'sk', c2.rv_meaning, NVL(c2.english, c2.rv_meaning)) AS typ_nadraz

from
	zamestnanci z,
	cis_pracovist cp,
	cis_pracovist cp_nadraz,
	cg_ref_codes c1,
	cg_ref_codes c2

where
	z.UCITIDNO = :ucitidno
	and cp.ZKR = z.PRAC_ZKR
	and cp.NAD_PRAC_ZKR = cp_nadraz.ZKR
	and c1.RV_DOMAIN = 'TYP_PRACOVISTE'
	and c1.RV_LOW_VALUE = cp.TYP_PRAC
	and c2.RV_DOMAIN = 'TYP_PRACOVISTE'
	and c2.RV_LOW_VALUE = cp_nadraz.TYP_PRAC
UNION
(
SELECT
	cp.ZKR as pk_zkr_prac,
	cp.NAZEV,
	cp.CISLO_PRAC,
	cp_nadraz.ZKR as zkr_nadraz,
	cp_nadraz.NAZEV as nazev_nadraz,
	cp_nadraz.CISLO_PRAC as cislo_prac_nadraz,
	DECODE(:lang, 'cs', c1.rv_meaning, 'sk', c1.rv_meaning, NVL(c1.english, c1.rv_meaning)) AS typ,
	DECODE(:lang, 'cs', c2.rv_meaning, 'sk', c2.rv_meaning, NVL(c2.english, c2.rv_meaning)) AS typ_nadraz

from
	cis_pracovist cp,
	cis_pracovist cp_nadraz,
	ucitele u,
	cg_ref_codes c1,
	cg_ref_codes c2
	
where
	u.UCITIDNO = :ucitidno 
	and cp.ZKR = u.PRAC_ZKR
	and cp.NAD_PRAC_ZKR = cp_nadraz.ZKR
	and c1.RV_DOMAIN = 'TYP_PRACOVISTE'
	and c1.RV_LOW_VALUE = cp.TYP_PRAC
	and c2.RV_DOMAIN = 'TYP_PRACOVISTE'
	and c2.RV_LOW_VALUE = cp_nadraz.TYP_PRAC
)
