select
    snz.termidno,
	s.OS_CISLO as pk_os_cislo,
	o.JMENO,
	o.PRIJMENI,
	DECODE(:lang, 'cs', c1.RV_ABBREVIATION, 'sk', c1.RV_ABBREVIATION, NVL(c1.english, c1.RV_ABBREVIATION)) AS titul_pred,
	DECODE(:lang, 'cs', c2.RV_ABBREVIATION, 'sk', c2.RV_ABBREVIATION, NVL(c2.english, c2.RV_ABBREVIATION)) AS titul_za,
	decode(o.TITUL_PRED, null, null, c1.RV_ABBREVIATION||' ')||o.JMENO||' '||o.PRIJMENI||	   decode(o.TITUL_ZA, null, null,', '||c2.RV_ABBREVIATION) as student,
	o.PRIJMENI||' '||o.JMENO||' '||decode(o.TITUL_PRED, null, null, c1.RV_ABBREVIATION||' ')||decode(o.TITUL_ZA, null, null,', '||c2.RV_ABBREVIATION) as student2,
	snz.date_of_insert as datum_a_cas_prihlaseni

from
	Studenti s,
	osoby o,
	studenti_na_zkouskach snz,
	cg_ref_codes c1,
	cg_ref_codes c2

where
	snz.termidno = :idno
	and snz.os_cislo = s.os_cislo
	and o.OSOBIDNO = s.OSOBIDNO
	and c1.RV_DOMAIN(+) = 'TITUL_PRED'
	and c1.RV_LOW_VALUE(+) = o.TITUL_PRED
	and c2.RV_DOMAIN(+) = 'TITUL_ZA'
	and c2.RV_LOW_VALUE(+) = o.TITUL_ZA
	
order by
	o.PRIJMENI,
	o.JMENO
