select /*+ INDEX(c1 X_CG_REF_CODES_1) INDEX(c2 X_CG_REF_CODES_1) */
	p.PRAC_ZKR||'/'||p.ZKR_PREDM as zkratka,
	DECODE(:lang,'cs',c3.RV_MEANING,'sk',c3.RV_MEANING,NVL(c3.ENGLISH,c3.RV_MEANING)) as typ_terminu,
	t.datum as datum, 
	ng.NATEIDNO as fk_nateidno,
	ng.celk_obsazeni as obsaz_celkove,
	ng.celk_plan as plan_celkovy,
	g.GRTEIDNO as fk_GRTEIDNO,
	g.GRUPA_OBSAZENI as obsaz_grupa,
	g.GRUPA_PLAN as plan_grupa,
	t.TERMIDNO as pk_TERMIDNO,
	t.OBSAZENI_TERMINU as obsaz_termin,
	t.LIMIT_TERMINU as plan_termin,
	to_date(to_char(t.DATUM, 'DD.MM.RRRR')||to_char(t.hod_od, ' HH24:MI'),'DD.MM.RRRR HH24:MI') as od,
	to_date(to_char(t.DATUM, 'DD.MM.RRRR')||to_char(t.hod_do, ' HH24:MI'),'DD.MM.RRRR HH24:MI') as do,
	nvl(t.blok_datum, to_date(to_char(t.DATUM, 'DD.MM.RRRR')||to_char(t.hod_od, ' HH24:MI'),'DD.MM.RRRR HH24:MI')) as uzav,
	p.ZKR_PREDM as fk_zkr_predm,
	p.PRAC_ZKR as fk_prac_zkr,
	p.ROK_VARIANTY as fk_rok_varianty,
	DECODE(:lang, 'cs', p.CZ_NAZEV, 'sk', p.CZ_NAZEV, NVL(p.AN_NAZEV, p.CZ_NAZEV)) AS nazev,
	t.semestr as semestr,
	t.UCITIDNO as fk_ucitidno,
	t.poznamka as poznamka,
	--NVL(Pg_Cti_Parametry.cti_retezec_kat('UCITEL_ZNAMKY',p.PRAC_ZKR),'N') as opravneni_zap_znamku ,
	case
        when decode((select cg.pom_hodnota from cg_ref_codes cg where cg.RV_DOMAIN = 'TYP_TERMINU' and cg.RV_LOW_VALUE = t.typ_terminu),'ZPPZK',Pg_Cti_Parametry.cti_retezec_kat('UCITEL_PRISTUP_ZP_PRED_ZK',p.PRAC_ZKR),Pg_Cti_Parametry.cti_retezec_kat('UCITEL_PRISTUP_ZKOUSKA',p.PRAC_ZKR)) like '%T%'
        then 'A'
        else 'N'
    end as opravneni_zap_znamku,
	t.ZKR_BUDOVY as fk_zkr_budovy,
	t.CISLO_MIST as fk_cislo_mistnosti,
	t.zkr_budovy||t.cislo_mist mistnost,
	decode(u.TITUL_PRED, null, null, c1.RV_ABBREVIATION||' ')||u.JMENO||' '||u.PRIJMENI|| decode(u.TITUL_ZA, null, null,', '||c2.RV_ABBREVIATION) as ucitel,
	u.PRIJMENI as ucitel_prijmeni,
	Fn_deadline_zapisu_znamek(t.rok_platnosti,t.prac_zkr) as deadline_zapisu_znamek,
    t.platnost as platnost,
    TO_CHAR(t.hod_od, 'HH24:MI:SS') as hod_skut_od_time,
    TO_CHAR(t.hod_do, 'HH24:MI:SS') as hod_skut_do_time,
    t.opravny_termin as opravny_termin,
    t.datum_start as datum_start,
    t.blok_datum_prihlaseni as blok_datum_prihlaseni,
    t.blok_datum
from
	nadgrupy_terminu ng,
	grupy_terminu g,
	terminy t,
	pred_varianty p,
	ucitele u,
	cg_ref_codes c1,
	cg_ref_codes c2,
	cg_ref_codes c3
where
	ng.nateidno(+) = g.nateidno
	and  g.grteidno(+)  = t.grteidno
	and  t.platnost in (:platnost)
	and  t.prac_zkr like :pracoviste
	and  t.zkr_predm like :zkr_pred
	and  t.ucitidno like :ucitidno
	and  t.rok_platnosti = :rok
	and (t.semestr like :semestr or t.semestr is null)
	and p.PRAC_ZKR = t.PRAC_ZKR
	and p.ZKR_PREDM = t.ZKR_PREDM
	and p.ROK_VARIANTY = t.ROK_PLATNOSTI
	and u.UCITIDNO = t.UCITIDNO
	and c1.RV_DOMAIN(+) = 'TITUL_PRED'
	and c1.RV_LOW_VALUE(+) = u.TITUL_PRED
	and c2.RV_DOMAIN(+) = 'TITUL_ZA'
	and c2.RV_LOW_VALUE(+) = u.TITUL_ZA
	and c3.RV_DOMAIN = 'TYP_TERMINU'
	and c3.RV_LOW_VALUE = t.TYP_TERMINU
@IF(0) and  ( (trunc(t.datum) > trunc(sysdate)) or ((trunc(t.datum) = trunc(sysdate)) and(to_char(t.hod_od,'HH24:MI') > to_char(sysdate,'HH24:MI')) ) )
@IF(1) and  ( (trunc(t.datum) < trunc(sysdate)) or ((trunc(t.datum) = trunc(sysdate)) and (to_char(t.hod_od,'HH24:MI') < to_char(sysdate,'HH24:MI')) ) )
@IF(2)   and  (trunc(t.datum) > trunc(sysdate - (:pocetDni)))
order by datum DESC, od, fk_nateidno, fk_GRTEIDNO, nazev