select
    np.prac_zkr_podm as prac_zkr,
    np.zkr_predm_podm as zkr_predm,
    np.AIDNO,
    DECODE(:lang, 'cs', p.cz_nazev, 'sk', p.cz_nazev, NVL(p.AN_NAZEV, p.cz_nazev)) as nazev,
    p.ROK_VARIANTY,
    p.VYUKA_LS,
    p.vyuka_zs,
    
    prac1.nazev fakulta_nazev,
    prac1.zkr fakulta_zkr,
    prac.nazev katedra_nazev,
    p.cz_nazev,
    p.crd,
    p.akred,
    p.jednotek_cv,
    p.jednotek_pr,
    p.jednotek_sem,
    p.typ_zk as fk_typ_zk,
    p.hodnoceni_zk as fk_hodnoceni_zk,
    p.predz_za as fk_predz_za,
    deleni_pr_po, deleni_cv_po, deleni_sem_po, jednotka_pr, jednotka_cv, jednotka_sem,
    jednotek_pr, jednotek_cv, jednotek_sem, pocet_ra_typu_pr, pocet_ra_typu_cv, pocet_ra_typu_sem,
    poc_stud_cv, poc_stud_sem, typ_pr, typ_cv, typ_sem, typ_uceb_pr, typ_uceb_cv, typ_uceb_sem,
    poc_tydnu,
    poznamka,
    DECODE(:lang, 'cs', p.cz_anotace, 'sk', p.cz_anotace, NVL(p.AN_ANOTACE, p.cz_anotace)) as anotace,
    DECODE(:lang, 'cs', c1.RV_MEANING, 'sk', c1.RV_MEANING, NVL(c1.ENGLISH, c1.RV_MEANING)) as jednotka,
    DECODE(:lang, 'cs', c2.RV_MEANING, 'sk', c2.RV_MEANING, NVL(c2.ENGLISH, c2.RV_MEANING)) as jednotka_cv,
    DECODE(:lang, 'cs', c3.RV_MEANING, 'sk', c3.RV_MEANING, NVL(c3.ENGLISH, c3.RV_MEANING)) as jednotka_sem,
    DECODE(:lang, 'cs', c4.RV_MEANING, 'sk', c4.RV_MEANING, NVL(c4.ENGLISH, c4.RV_MEANING)) as typ_zk,
    DECODE(:lang, 'cs', c5.RV_MEANING, 'sk', c5.RV_MEANING, NVL(c5.ENGLISH, c5.RV_MEANING)) as predz_za,
    DECODE(:lang, 'cs', c6.RV_MEANING, 'sk', c6.RV_MEANING, NVL(c6.ENGLISH, c6.RV_MEANING)) as vicezapis,
    DECODE(:lang, 'cs', c7.RV_MEANING, 'sk', c7.RV_MEANING, NVL(c7.ENGLISH, c7.RV_MEANING)) as do_prumeru,

    np.SPLNIT_PODM
from
    np_pod np,
    pred_varianty p,
        cg_ref_codes c1,
    cg_ref_codes c2,
    cg_ref_codes c3,
    cg_ref_codes c4,
    cg_ref_codes c5,
    cg_ref_codes c6,
    cg_ref_codes c7,
        cis_pracovist prac,
        cis_pracovist prac1

where
    np.PRAC_ZKR = :pracZkr
    and np.ZKR_PREDM = upper(:zkrPredm)
    and p.PRAC_ZKR = np.PRAC_ZKR_PODM
    and p.ZKR_PREDM = np.ZKR_PREDM_PODM
    and (
        (exists (select * from pred_varianty pr where pr.PRAC_ZKR = np.PRAC_ZKR_PODM and pr.ZKR_PREDM = np.ZKR_PREDM_PODM and pr.rok_varianty = :rok) AND p.ROK_VARIANTY = :rok)
        OR
        (not exists (select * from pred_varianty pr where pr.PRAC_ZKR = np.PRAC_ZKR_PODM and pr.ZKR_PREDM = np.ZKR_PREDM_PODM and pr.rok_varianty = :rok)

        and p.ROK_VARIANTY = (
            select
                max(pr.rok_varianty)
            from
                pred_varianty pr
            where
                pr.PRAC_ZKR = np.PRAC_ZKR_PODM
                and pr.ZKR_PREDM = np.ZKR_PREDM_PODM

    )))
    
    
      and  p.jednotka_pr = c1.rv_low_value
  and  c1.rv_domain = 'JEDNOTKA_VYUKY'
  and  p.jednotka_cv = c2.rv_low_value
  and  c2.rv_domain = 'JEDNOTKA_VYUKY'
  and  p.jednotka_sem = c3.rv_low_value
  and  c3.rv_domain = 'JEDNOTKA_VYUKY'
  and  p.typ_zk = c4.rv_low_value
  and  c4.rv_domain = 'TYP_ZK_NEW'
  and  p.predz_za = c5.rv_low_value
  and  c5.rv_domain = 'ANO_NE'
  and  p.vicezapis = c6.rv_low_value
  and  c6.rv_domain = 'ANO_NE'
  and  p.do_prumeru = c7.rv_low_value
  and  c7.rv_domain = 'ANO_NE'
    and prac.nad_prac_zkr = prac1.zkr
    AND prac1.typ_prac = 'F'
    AND p.prac_zkr=prac.zkr

order  by AIDNO, 1, 2